import { WebElement } from '@contour/fet/lib/elements';
import { PageLocator } from '@contour/fet/lib/pages/pageLocator';

import scenarioContext from '../util/scenarioContext';

export class ContourElement extends WebElement {
  protected locators: Record<string, string>;

  constructor(selector: string, locators: PageLocator) {
    super(selector);

    const version = scenarioContext().appVersion || 'default';
    const locatorObj = locators[version] == undefined ? locators['default'] : locators[version];
    const merge = require('deepmerge');
    this.locators = {};
    Object.assign(this.locators, merge(locators['default'].locators, locatorObj.locators));
  }
}
