import { Input } from '@contour/fet/lib/elements';
import { WebElement } from '@contour/fet/lib/elements/webElement';

export class BNOSelect extends WebElement {
  PAGE_NAME = 'bnoSelect';
  constructor(selector: string) {
    super(selector);
  }

  async selectOptionByVisibleText(val: string) {
    await this.scroll();
    await this.clickElement();

    const childSelector = contourfet.getPageElement(this.PAGE_NAME, 'selectOption').replace('#OPTION#', val);
    const optionElement = new WebElement(childSelector);
    await optionElement.scroll();
    await optionElement.clickElement();
  }

  async setInputField(val: string) {
    await this.clickElement();
    const inputElement = new Input(contourfet.getPageElement(this.PAGE_NAME, 'selectInput'), this.selector);
    await inputElement.setInputField(val);
  }
}
