import { Input } from '@contour/fet/lib/elements/input';

export class ContourNumbericInput extends Input {
  constructor(selector: string) {
    super(selector);
  }

  async clearInputField() {
    await this.clickElement();

    const textLength = (await super.getText()).length;

    // Navigate to the end of the input field
    for (let i = 0; i < textLength; i++) {
      await super.keys('\uE014');
    }

    for (let i = 0; i < textLength; i++) {
      await super.keys('\uE003');
    }
  }

  async setInputField(val: string): Promise<any> {
    await this.scroll();
    await this.clearInputField();
    await super.setInputField(val);
  }
}
