export default {
  pages: {
    openDC: '/ui/requests/lc/',
    openDP: '/ui/requests/lc/#UUID#/dps/true',
    mailhogSearch: '/api/v2/search',
    resetPassword: '/ui/reset-password/',
    forgotPassword: '/ui/password/forget',
    forgotUsername: '/ui/username/recover',
    nodeAdmin: '/ui/nodeadmin/admins',
    setupUser: '/ui/onboard/#token#?email=#email#'
  },
  constants: {
    defaultPassword: 'P@ssw0rd@123'
  },
  defaultParty: {
    applicant: 'corpa',
    beneficiary: 'corpb',
    issuingBank: 'banka',
    advisingBank: 'bankb',
    confirmingBank: 'bankc',
    nominatedBank: 'bankd',
    bno: 'bno'
  },
  scenario: {
    sc1: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      newAdvisingBank: 'bankc',
      confirmingBank: null,
      nominatedBank: null,
      confirmation: 'WITHOUT',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      advisedLCRef: '123'
    },
    sc2: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: null,
      nominatedBank: 'bankb',
      confirmation: 'WITHOUT',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      nominatedLCRef: '123'
    },
    sc2split: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: null,
      nominatedBank: 'banka',
      confirmation: 'WITHOUT',
      issuedLCRef: '123_SC2Split',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      nominatedLCRef: '123_SC2Split',
      advisedLCRef: '123_SC2Split'
    },
    sc3split: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'banka',
      confirmingBank: null,
      nominatedBank: 'banka',
      confirmation: 'WITHOUT',
      issuedLCRef: '123_SC3Split',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      nominatedLCRef: '123_SC3Split'
    },
    sc4: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      newAdvisingBank: 'bankd',
      confirmingBank: 'bankb',
      nominatedBank: null,
      confirmation: 'WITH',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123'
    },
    sc5: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: 'bankc',
      nominatedBank: null,
      confirmation: 'MAY_ADD',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123',
      advisedLCRef: '123'
    },
    sc6: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: 'bankb',
      nominatedBank: 'bankb',
      confirmation: 'MAY_ADD',
      issuedLCRef: '123_SC6',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank'
    },
    sc8: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: 'bankc',
      nominatedBank: 'bankb',
      confirmation: 'WITH',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123',
      nominatedLCRef: '123'
    },
    sc10: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: 'bankc',
      nominatedBank: 'bankc',
      confirmation: 'WITH',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123',
      advisedLCRef: '123'
    },
    sc11: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'bankb',
      confirmingBank: 'bankc',
      newConfirmingBank: 'bankd',
      nominatedBank: 'bankd',
      confirmation: 'WITH',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123',
      nominatedLCRef: '123',
      advisedLCRef: '123'
    },
    sc12: {
      applicant: 'corpa',
      beneficiary: 'corpb',
      issuingBank: 'banka',
      advisingBank: 'banka',
      confirmingBank: null,
      nominatedBank: 'bankd',
      confirmation: 'WITHOUT',
      issuedLCRef: '123',
      instructionsToPayingBank: 'Instructions to paying bank',
      clauseContent: 'Additional clause from issuing bank',
      confirmedLCRef: '123',
      nominatedLCRef: '123',
      advisedLCRef: '123'
    }
  },
  pdfFiles: {
    root: {},
    files: []
  }
};
