import { WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import { ContourSelect } from '../../elements/contourSelect';
import locator from './bnoNodes.locator';

export default class BnoNodes extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }
  getNodeRecord(rowNum: number) {
    return new WebElement(this.getLocatorAsString('nodeRecord').replace('#ROW_NUM#', rowNum.toString()));
  }

  getVersionSelector() {
    return new ContourSelect(this.getLocatorAsString('versionSelector'));
  }

  getAddIdentityButton(rowNum: number) {
    return new ContourSelect(this.getLocatorAsString('addIdentityButton').replace('#ROW_NUM#', rowNum.toString()));
  }

  getNodeNameLink(rowNum: number) {
    return new ContourSelect(this.getLocatorAsString('nodeNameLink').replace('#ROW_NUM#', rowNum.toString()));
  }
}
