import { Link } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './identity.locator';

export default class BnoIdentity extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }
  getIdentityName(idName) {
    return new Link(this.getLocatorAsString('identityName').replace('#IDENTITY_NAME#', idName));
  }

  getIdentityField(idField) {
    return new Link(this.getLocatorAsString('identityField').replace('#ID_FIELD#', idField));
  }

  getIdentityValue(valueRow: number) {
    return new Link(this.getLocatorAsString('identityValue').replace('#VALUE_NO#', valueRow.toString()));
  }
}
