import { Button, Input } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './loginBNO.locator';

export default class LoginBNOPage extends ContourBasePage {
  url: string;
  constructor(url: string) {
    super(locator, url);
    if (url) {
      this.url = url;
    }
  }

  getUsernameInput() {
    return new Input(this.locators.emailInput);
  }

  getPasswordInput() {
    return new Input(this.locators.passwordInput);
  }

  getLoginButton() {
    return new Button(this.locators.loginBtn);
  }

  async loginBNO(loginName: string, loginPassword: string) {
    await this.goToPageUrl();
    await this.getUsernameInput().setInputField(loginName);
    await this.getPasswordInput().setInputField(loginPassword);
    await this.getLoginButton().clickElement();
  }
}
