export default {
  default: {
    url: '',
    title: 'Action Buttons',
    locators: {
      generalButton: '//button',
      sendToBeneficiaryButton: '[data-testid="Send to Beneficiary"]',
      submitToIssuingBankButton: '[data-testid="Submit to Issuing bank"]',
      resetButton: '//button[contains(@data-testid,"Reset")][@type="button"]',
      submitButton: '//button[contains(@data-testid,"Submit")][@type="button"]',
      cancelButton: '//button[contains(@data-testid,"Cancel")][@type="button"] | //button[contains(text(),"Cancel")]',
      verifyButton: '//button[contains(@data-testid,"Verify")][@type="button"]',
      rejectButton: '//button[@data-testid="Reject" or @data-testid="Decline" or @data-testid="Return"]',
      issueButton: '//button[contains(@data-testid,"Issue")][@type="button"]',
      returnButton: '//button[@data-testid = "Return"]',
      adviseButton: '//button[contains(@data-testid,"Advise")][@type="button"]',
      adviseWithConfirmationButton: '//button[@data-testid = "Advise with confirmation"]',
      adviseWithoutConfirmationButton: '//button[contains(@data-testid,"Advise without confirmation")]',
      amendButton: '//button[@data-testid = "Amend"]',
      presentButton: '//button[@data-testid = "Present"]',
      endorseButton: '//button[@data-testid = "Endorse"]',
      editAndReturnButton: '//button[@data-testid = "Edit & return"]',
      sendToApplicantButton: '//button[@data-testid = "Send to Applicant"]',
      confirmButton: '//button[@data-testid = "Confirm" or text() = "Confirm"]',
      confirmDiscardButton: '//button[contains(text(),"Yes, discard")]',
      updateDraftButton: '//button[@data-testid = "Update draft"]',
      p2pUpdateDraftButton: '//button[@data-testid = "updateDraft"]',
      deleteDraftButton: '//button[@data-testid = "Delete draft"]',
      editButton: '//button[@data-testid = "Edit"]',
      discardButton: '//button[@data-testid = "Discard"]',
      acceptButton: '//button[@data-testid = "Accept"]',
      submitToApplicantButton: '//button[@data-testid = "Send to Applicant"]',
      updateButton: '//button[@data-testid = "Update"] | //button[contains(text(),"Update")]',
      declineButton: '//button[@data-testid = "Decline"]',
      previewButton: '//button[@data-testid = "Preview"]',
      approveButton: '//button[@data-testid = "Approve"]',
      bottomButtonsContainer: '//button[contains(@class,"is-primary")]/..',
      backButton: '//button[@data-testid = "Back"]',
      saveAndNextButton: '//button[@data-testid = "Save & Next" or @data-testid = "saveAndNext"]',
      submitPresentationButton: '//button[@data-testid = "Submit presentation"]',
      forwardButton: '//button[@data-testid="Forward"]',
      saveButton: '//button[@data-testid="save"] | //body/div[@id="overlap"]/div[1]/div[1]/div[4]/button[1]',
      attachCommentButton: '//button[contains(text(),"attach")]',
      requestConfirmationButton: '//button[@data-testid = "Request confirmation"]',
      addConfirmationButton: '//button[@data-testid = "Add confirmation"]',
      rejectConfirmationButton: '//button[@data-testid = "Reject confirmation"]',
      cancelLCButton: '//button[@data-testid = "cancelLC"]',
      saveTemplate: '//button[@data-testid = "saveDraft"][2]',
      moreTemplatesBtn: '//button[contains(text(),"More templates")] | //button[contains(text(),"Less templates")]',
      setPaymentDueDateAndReleaseDocumentsButton:
        "//button[normalize-space()='Set payment due date and release documents']",
      setPaymentDueDateButton: '//button[normalize-space()="Set payment due date"]',
      releaseDocumentsButton: '//button[normalize-space()="Release documents"]',
      manageTemplatesButton: '//a[contains(text(),"Manage templates")]',
      backArrow: '//div[@data-testid= "back-navigator"]',
      saveNewTemplateButton: '//button[contains(text(),"Save as new")]'
    }
  }
};
