import { WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './amendmentDraftText.locator';

export class AmendmentDraftTextPage extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getUpdatedField(fieldName: string): WebElement {
    return new WebElement(this.getLocatorAsString('updatedField').replace('#FIELD_NAME#', fieldName));
  }

  getOriginalField(fieldName: string): WebElement {
    return new WebElement(this.getLocatorAsString('originalField').replace('#FIELD_NAME#', fieldName));
  }

  getDcFormAction(rowNum: string | number): WebElement {
    return new WebElement(this.getLocatorAsString('dcFormAction').replace('#ROW_NUM#', rowNum.toString()));
  }

  getDraftTextAction(rowNum: string | number): WebElement {
    return new WebElement(this.getLocatorAsString('draftTextAction').replace('#ROW_NUM#', rowNum.toString()));
  }

  // getOldAttachment(rowNum: string | number): WebElement {
  //   return new WebElement(this.getLocatorAsString('oldAttachment').replace('#ROW_NUM#', rowNum.toString()));
  // }
  async findAttachedFile(rowNum: string | number, prefix: string, fileName: string) {
    if (prefix) {
      await new WebElement(
        this.getLocatorAsString('attachedFile').replace('#ROW_NUM#', rowNum.toString()).replace('#TEXT#', prefix)
      ).isExisting();
    }
    await new WebElement(
      this.getLocatorAsString('attachedFile').replace('#ROW_NUM#', rowNum.toString()).replace('#TEXT#', fileName)
    ).isExisting();
  }

  getUpdatedAttachment(rowNum: string | number): WebElement {
    return new WebElement(this.getLocatorAsString('newAttachment').replace('#ROW_NUM#', rowNum.toString()));
  }

  getRemovedUpdatedAttachment(rowNum: string | number): WebElement {
    return new WebElement(this.getLocatorAsString('newAttachment').replace('#ROW_NUM#', rowNum.toString()));
  }

  getUpdatedAttachmentWithFileName(filename: string): WebElement {
    return new WebElement(this.getLocatorAsString('newAttachmentWithFilename').replace('#FILE_NAME#', filename));
  }
}
