import { Button, WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './amendmentOverview.locator';

export class AmendmentOverview extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getListRow(rowNum: string): WebElement {
    return new WebElement(this.getLocatorAsString('listRow').replace('#ROW_NUM#', rowNum));
  }

  getListRowYourAction(rowNum: string): WebElement {
    return new WebElement(this.getLocatorAsString('listRowYourAction').replace('#ROW_NUM#', rowNum));
  }

  getListRowDetail(rowNum: string): WebElement {
    return new WebElement(this.getLocatorAsString('listRowDetail').replace('#ROW_NUM#', rowNum));
  }

  getListRowOtherPartiesAction(rowNum: string): WebElement {
    return new WebElement(this.getLocatorAsString('listRowOtherPartiesAction').replace('#ROW_NUM#', rowNum));
  }

  getListRowViewButton(rowNum: string): WebElement {
    return new WebElement(this.getLocatorAsString('listRowViewButton').replace('#ROW_NUM#', rowNum));
  }

  getViewIssuedAmendmentsButton() {
    return new Button(this.getLocatorAsString('viewIssuedAmendmentsButton'));
  }
}
