import { WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../../base/basePage';
import locator from './auditLog.locator';

export class AuditLog extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getInitialParty(rowNum: number): WebElement {
    return new WebElement(this.getLocatorAsString('initialParty').replace('#ROW_NUM#', rowNum.toString()));
  }

  getStatus(rowNum: number): WebElement {
    return new WebElement(this.getLocatorAsString('status').replace('#ROW_NUM#', rowNum.toString()));
  }

  getActionLog(rowNum: number): WebElement {
    return new WebElement(this.getLocatorAsString('actionLog').replace('#ROW_NUM#', rowNum.toString()));
  }
}
