import { Link, WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import ContourSpinner from '../../elements/contourSpinner';
import locator from './companySettings.locator';

export class CompanySettingsPage extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  async selectOptionFromLeftMenu(option: string): Promise<void> {
    const linkTxt = {
      UserRoles: 'User roles',
      Users: 'Users',
      Network: 'Network',
      Customisation: 'Customisation',
      SharedMailbox: 'Shared mailbox',
      SecuritySettings: 'Security settings',
      AuditTrail: 'Audit trail'
    };
    await new Link(`=${linkTxt[option]}`).clickElement();
    await new ContourSpinner().waitForLoadingToComplete();
  }

  async assertPage() {
    await new WebElement(this.locators.backToContourBtn).checkElementExists();
  }
}
