export default {
  default: {
    url: '',
    title: 'DC Form',
    locators: {
      corporatesContainer: '//form/div/div[.="Corporates"]/..',
      banksContainer: '//form/div/div[.="Banks"]/..',
      keyTermsContainer: '//form/div/div[.="Key terms"]/..',
      shipmentDetailsContainer: '//form/div/div[.="Shipment details"]/..',
      dcDetailsContainer: '//form/div/div[.="DC details"]/..',
      attachmentsContainer: '//form//div[.="Attachments (PDF only, max 7 MB)"]/..',
      internalCommentsContainer: '//div[.="Internal comments"]/..',
      internalCommentsButton: '[name="addcomment"]',
      internalCommentsTextArea: '//textarea[@placeholder="(Optional) Leave a comment"]',
      backButton: '//*[contains(@class,"ion-arrow-left-c")]',
      applicant: '[name="parties.applicant"]',
      applicantAddressInput: '[name="applicant.address"]',
      beneficiary: 'input[name="beneficiary.x500"]',
      beneficiaryAddressInput: '[name="beneficiary.address"]',
      issuingBank: '[name="issuingBank.x500"]',
      issuingBankAddress: '[name="issuingBank.address"]',
      waiverCheckBox: '[name="waiver"]',
      advisingBank: '[name="advisingBank.x500"]',
      advisingBankAddressInput: '[name="advisingBank.address"]',
      confirmingBank: '[name="confirmingBank.x500"]',
      confirmingBankAddress: '[name="confirmingBank.address"]',
      //Available by
      deferredPaymentDetailsInput: '[name="deferredPaymentDetails"]',
      acceptanceDraftsAtInput: '[name="acceptanceDraftsAt"]',
      acceptanceDraweeBankDropdown: '[name="acceptanceDraweeBank.x500"]',
      acceptanceDraweeBankAddressInput: '[name="acceptanceDraweeBank.address"]',
      negotiationPaymentDetailsCheckbox: '[id="availableByDeferredPayment"]',
      negotiationPaymentDetailsInput: '[name="negotiationPaymentDetails"]',
      negotiationDraftsAtInput: '[name="negotiationDraftsAt"]',
      negotiationDraweeBankDropdown: '[name="negotiationDraweeBank.x500"]',
      negotiationDraweeBankAddressInput: '[name="negotiationDraweeBank.address"]',
      availableByPaymentConditions: '[name="typeCreditsCondition"]',
      //Credit available with
      creditAvailableWith: '[name="availableWithBank.x500"]',
      nominatedBankAddressInput: '//textArea[@name="partyAddresses.availableWithBank"]',
      //Key Terms
      applicableRules: '[name="applicableRules"]',
      descriptionOfApplicableRules: '[name="otherApplicableRules"]',
      amountCurrency: '[aria-label="ChevronDown"]',
      amountInput: '[inputmode="numeric"]',
      maxTolerenceInput: '[name="toleranceMax"]',
      minTolerenceInput: '[name="toleranceMin"]',
      additionalAmountCoveredInput: '[name="additionalAmountsCovered"]',
      expiryDate: '[name="expiryDate"]',
      expiryPlaceInput: '[name="placePresentation"]',
      partialShipments: '[name="partialShipment"]',
      transhipment: '[name="transShipment"]',
      descriptionOfGoodsAndServicesInput: '[name="goods"]',
      periodOfPresentationInput: '[name="periodPresentation"]',
      typeOfPresentationInput: '[name="typeOfPresentation"]',
      placeOfTakingInChargeInput: '[name="placeOfTakingInCharge"]',
      portOfLoadingInput: '[name="portLoading"]',
      portOfDischargeInput: '[name="portDischarge"]',
      placeOfFinalDestinationInput: '[name="placeOfFinalDestination"]',
      // Documents
      documentRequiredInvoiceDescriptionInput: '[name="documentsRequiredInvoiceDesc"]',
      documentRequiredTransportType: '[name="documentsRequiredTransportSub"]',
      documentRequiredTransportSubtypeInput: '[name="documentsRequiredTransportDesc"]',
      documentRequiredTransportDocumentDescriptionInput: '[name="documentsRequiredTransportDesc"]',
      documentRequiredCertificateOfOriginDescriptionInput: '[name="documentsRequiredCertificateDesc"]',
      documentRequiredPackingListDescriptionInput: '[name="documentsRequiredPackingListDesc"]',
      documentRequiredAddOtherDocumentButton: '//button/span[@innertext="Add document"]',
      doucmentRequiredOtherDocumentsRequiredInput: '[name*="otherDocumentsRequired.documentType"]',
      documentRequiredOtherDocumentsRequiredDescriptionInput: '[name*="otherDocumentsRequired.description"]',
      documentRequiredRemoveOtherDocumentsButton: 'svg[aria-label="Delete"]',

      detailsOfChargesInput: '[name="detailsCharges"]',
      additionalConditionsInput: '[name="additionalConditions"]',
      attachmentUpload: '[name="uploadFiles"]',
      attachmentFileName: '(//div[contains(@class,"lc-file-item")]/div[@class="lc-file-name"])[#ROW_NUM#]',
      attachmentRemoveButton: '(//div[contains(@class,"lc-file-item")]/span)[#ROW_NUM#]',
      attachmentContainer: '//div[@name="uploadFiles"]/../../../..',
      issuedDcRefenceInput: '//input[@name="issuedLCRef"]',
      additionalConditionsFromIssuingBankInput: '[name="issuerClause.content"]',
      instructionToPayingBankInput: '[name="instructionsToPayingBank"]',
      advisedDcReferenceInput: '[name="advisedLCRef"]',
      confirmedDcReferenceInput: '[name="confirmedLCRef"]',
      nominatedDcReferenceInput: '[name="availableWithLCRef"]',
      attachmentRow3: '(//div[contains(@class,"lc-file-item")])[3]',
      notificationContainer: '[name="danger-notification"]',
      paymentAtSightCheckbox: '[name="SIGHT_checkbox"]',
      hintText: '//span[contains(text(),"Action to issue the DC was declined by the checker/approver.")]',
      nomBankHintText: '//span[contains(text(),"Action to advise the DC was declined by the checker/approver.")]',
      rejectHintText: '//span[contains(text(),"Action to reject the DC was declined by the checker/approver.")]',
      dcForm: '[name="dcform"]',
      requiredFieldRow: '[name="danger-notification"] ul li',
      requiredFieldMsg: "//div[@name='danger-notification']//ul/li[.='#Message#']",
      attachmentRow1: '(//div[contains(@class,"lc-file-item")])[1]',
      saveTemplate: '///button[@innertext="Save as template"]',
      sendToBeneficiaryBtn: "///button[@innertext='Send to Beneficiary']",
      submitToIssuingBankBtn: "///button[@innertext='Submit to Issuing bank']",
      leaveACommentBtn: '///button[@innertext="Leave a comment"]',
      commentTxtArea: '[class*="StyledModalBox"] [class*="StyledTextArea"] textarea'
    }
  },
  v8_1: {
    locators: {}
  }
};
