import { Button, Input } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './dpCoverLetter.locator';

export default class DpCoverLetter extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getRadioInstructionPayment() {
    return new Button(this.getLocatorAsString('radioInstructionPayment'));
  }

  getRadioOtherInstruction() {
    return new Button(this.getLocatorAsString('radioOtherInstruction'));
  }

  getRadioNoInstruction() {
    return new Button(this.getLocatorAsString('radioNoInstruction'));
  }

  getInputAccountNumberToDebit() {
    return new Input(this.getLocatorAsString('inputAccountNumberToDebit'));
  }

  getInputAccountNumberToCredit() {
    return new Input(this.getLocatorAsString('inputAccountNumberToCredit'));
  }

  getInputExchangeContract() {
    return new Input(this.getLocatorAsString('inputExchangeContract'));
  }

  getInputOtherProceeds() {
    return new Input(this.getLocatorAsString('inputOtherProceeds'));
  }
}
