import { Button, Input } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import { ContourDatePicker } from '../../elements/contourDatePicker';
import { ContourFileUpload } from '../../elements/contourFileUpload';
import locator from './dpOtherDocument.locator';

export default class DpOtherDocument extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getRadioElectronicRecordAvailable() {
    return new Button(this.getLocatorAsString('radioElectronicRecordAvailable'));
  }

  getRadioDocumentsWillBeMailed() {
    return new Button(this.getLocatorAsString('radioDocumentsWillBeMailed'));
  }

  getRadioDocumentNotAvailable() {
    return new Button(this.getLocatorAsString('radioDocumentNotAvailable'));
  }

  getInputTransportDocument() {
    return new Input(this.getLocatorAsString('inputTransportDocument'));
  }

  getInputDateOfShipment() {
    return new ContourDatePicker(this.getLocatorAsString('inputDateOfShipment'));
  }

  getInputPortOfLoading() {
    return new Input(this.getLocatorAsString('inputPortOfLoading'));
  }

  getInputPortOfDischarge() {
    return new Input(this.getLocatorAsString('inputPortOfDischarge'));
  }

  getUploadFiles() {
    return new ContourFileUpload(this.getLocatorAsString('uploadFiles'));
  }
}
