import { Input } from '@contour/fet/lib/elements/index';

import { ContourBasePage } from '../../base/basePage';
import { ContourDatePicker } from '../../elements/contourDatePicker';
import { ContourSelect } from '../../elements/contourSelect';
import locator from './dpOverview.locator';

export default class DpOverview extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getSelectDocumentSource() {
    return new ContourSelect(this.getLocatorAsString('selectDocumentSource'));
  }

  getSelectPresentTo() {
    return new ContourSelect(this.getLocatorAsString('selectPresentTo'));
  }

  getSelectPresentThrough() {
    return new ContourSelect(this.getLocatorAsString('selectPresentThrough'));
  }
  getDrawingAmount() {
    return new Input(this.getLocatorAsString('drawingAmount'));
  }
  getPaymentDueDate() {
    return new ContourDatePicker(this.getLocatorAsString('paymentDueDate'));
  }
}
