import { Button, WebElement } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './navigationBar.locator';

export class NavigationBarPage extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  async openUserMenu(): Promise<void> {
    await browser.keys('\uE00C');
    await new Button(this.locators.userAvatar).clickElement();
  }

  async openSettingsPage(): Promise<void> {
    if (!(await browser.getUrl()).includes('company/user-roles')) {
      await new Button(this.locators.settingBtn).clickElement();
    }
  }

  async selectOption(option: string): Promise<void> {
    const selectOptions = { userAvatar: this.openUserMenu(), settingsIcon: this.openSettingsPage() };
    await selectOptions[option];
  }

  async assertPage() {
    await new WebElement(this.locators.companyLogo).checkIsDisplayed();
  }
}
