export default {
  default: {
    url: '',
    title: 'Notice of discrepancy',
    locators: {
      principalCurrency: '//div[text()="Principal amount"]/following::div[1]//div[@data-testid="currency"]',
      principalAmount: '//div[text()="Principal amount"]/following::div[1]//input[@data-testid="amount"]',

      additionalCurrency:
        '//div[text()="Additional amount (optional)"]/following::div[1]//div[@data-testid="currency"]',
      additionalAmount: '//div[text()="Additional amount (optional)"]/following::div[1]//input[@data-testid="amount"]',

      chargesToBeDeductedCheckbox: '//label[text()="Charges to be deducted (optional)"]//input',
      chargesToBeDeductedCurrency:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][1]//div[@data-testid="currency"]',
      chargesToBeDeductedAmount:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][1]//input[@data-testid="amount"]',
      agentChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"AGENT")]',
      commChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"COMM")]',
      corcomChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"CORCOM")]',
      discChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"DISC")]',
      insurChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"INSUR")]',
      postChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"POST")]',
      stampChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"STAMP")]',
      telecharChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"TELECHAR")]',
      warehousChargeCodesToBeDeducted:
        '//div[@class="message-form-indent"][1]//div[@class="lc-form-row"][2]//label[contains(text(),"WAREHOUS")]',
      chargesToBeDeductedDetails: '//textarea[@data-testid="chargesDeductedDetails"]',

      chargesToBeAddedCheckbox: '//label[text()="Charges to be added (optional)"]//input',
      chargesToBeAddedCurrency:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][1]//div[@data-testid="currency"]',
      chargesToBeAddedAmount:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][1]//input[@data-testid="amount"]',
      accptcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"ACCPTCOM")]',
      advcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"ADVCOM")]',
      amndcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"AMNDCOM")]',
      confcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"CONFCOM")]',
      corcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"CORCOM")]',
      defcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"DEFCOM")]',
      dscrpcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"DSCRPCOM")]',
      handlcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"HANDLCOM")]',
      interestChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"INTEREST")]',
      miscChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"MISC")]',
      negcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"NEGCOM")]',
      notfcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"NOTFCOM")]',
      paycomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"PAYCOM")]',
      postChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"POST")]',
      preadcomChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"PREADCOM")]',
      see72ZChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"SEE72Z")]',
      see77ChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"SEE77")]',
      stampChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"STAMP")]',
      telecharChargeCodesToBeAdded:
        '//div[@class="message-form-indent"][2]//div[@class="lc-form-row"][2]//label[contains(text(),"TELECHAR")]',
      chargesToBeAddedDetails: '//textarea[@data-testid="chargesAddedDetails"]',

      totalCurrency: '//div[text()="Total amount to be paid"]/following::div[1]//div[@data-testid="currency"]',
      totalAmount: '//div[text()="Total amount to be paid"]/following::div[1]//input[@data-testid="amount"]',

      accountWithBank: '//textarea[@data-testid="accountWithBank"]',
      senderToReceiver: '//textarea[@data-testid="senderToReceiver"]',
      noticeOfDiscrepancies: '//textarea[@data-testid="noticeOfDiscrepancies"]'
    }
  },
  v8: {
    locators: {}
  },
  v8_1: {
    locators: {}
  }
};
