import { Button, Input, Label } from '@contour/fet/lib/elements';

import { ContourBasePage } from '../../base/basePage';
import locator from './noticeOfDiscrepancy.locator';

export default class NoticeOfDiscrepancy extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getPricipalCurrency() {
    return new Button(this.getLocatorAsString('principalCurrency'));
  }

  getPrincipalAmount() {
    return new Input(this.getLocatorAsString('principalAmount'));
  }

  getAdditionalCurrency() {
    return new Label(this.getLocatorAsString('additionalCurrency'));
  }

  getAdditionalAmount() {
    return new Input(this.getLocatorAsString('additionalAmount'));
  }

  //Charges to be deducted section
  getChargesToBeDeductedCheckbox() {
    return new Button(this.getLocatorAsString('chargesToBeDeductedCheckbox'));
  }

  getChargesToBeDeductedCurrency() {
    return new Label(this.getLocatorAsString('chargesToBeDeductedCheckbox'));
  }

  getChargesToBeDeductedAmount() {
    return new Input(this.getLocatorAsString('chargesToBeDeductedAmount'));
  }

  getAgentChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('agentChargeCodesToBeDeducted'));
  }

  getCommChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('commChargeCodesToBeDeducted'));
  }

  getCorcomChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('corcomChargeCodesToBeDeducted'));
  }

  getDiscChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('discChargeCodesToBeDeducted'));
  }

  getInsurChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('insurChargeCodesToBeDeducted'));
  }

  getPostChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('postChargeCodesToBeDeducted'));
  }

  getStampChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('stampChargeCodesToBeDeducted'));
  }

  getTelecharChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('telecharChargeCodesToBeDeducted'));
  }

  getWarehousChargeCodesToBeDeducted() {
    return new Button(this.getLocatorAsString('warehousChargeCodesToBeDeducted'));
  }

  getChargesToBeDeductedDetails() {
    return new Input(this.getLocatorAsString('chargesToBeDeductedDetails'));
  }

  //Charges to be added section
  getChargesToBeAddedCheckbox() {
    return new Button(this.getLocatorAsString('chargesToBeAddedCheckbox'));
  }

  getChargesToBeAddedCurrency() {
    return new Label(this.getLocatorAsString('chargesToBeAddedCurrency'));
  }

  getChargesToBeAddedAmount() {
    return new Input(this.getLocatorAsString('chargesToBeAddedAmount'));
  }

  getAccptcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('accptcomChargeCodesToBeAdded'));
  }

  getAdvcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('advcomChargeCodesToBeAdded'));
  }

  getAmndcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('amndcomChargeCodesToBeAdded'));
  }

  getConfcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('confcomChargeCodesToBeAdded'));
  }

  getCorcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('corcomChargeCodesToBeAdded'));
  }

  getDefcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('defcomChargeCodesToBeAdded'));
  }

  getDscrpcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('dscrpcomChargeCodesToBeAdded'));
  }

  getHandlcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('handlcomChargeCodesToBeAdded'));
  }

  getInterestChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('interestChargeCodesToBeAdded'));
  }

  getMiscChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('miscChargeCodesToBeAdded'));
  }

  getNegcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('negcomChargeCodesToBeAdded'));
  }

  getNotfcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('notfcomChargeCodesToBeAdded'));
  }

  getPaycomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('paycomChargeCodesToBeAdded'));
  }

  getPostChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('postChargeCodesToBeAdded'));
  }

  getPreadcomChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('preadcomChargeCodesToBeAdded'));
  }

  getSee72ZChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('see72ZChargeCodesToBeAdded'));
  }

  getSee77ChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('see77ChargeCodesToBeAdded'));
  }
  getStampChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('stampChargeCodesToBeAdded'));
  }
  getTelecharChargeCodesToBeAdded() {
    return new Button(this.getLocatorAsString('telecharChargeCodesToBeAdded'));
  }
  getChargesToBeAddedDetails() {
    return new Input(this.getLocatorAsString('chargesToBeAddedDetails'));
  }

  //summary section
  getTotalCurrency() {
    return new Label(this.getLocatorAsString('totalCurrency'));
  }

  getTotalAmount() {
    return new Input(this.getLocatorAsString('totalAmount'));
  }

  getAccountWithBank() {
    return new Input(this.getLocatorAsString('accountWithBank'));
  }

  getSenderToReceiver() {
    return new Input(this.getLocatorAsString('senderToReceiver'));
  }

  getNoticeOfDiscrepancies() {
    return new Input(this.getLocatorAsString('noticeOfDiscrepancies'));
  }
}
