export default {
  default: {
    url: '',
    title: 'P2P Message',
    locators: {
      dangerNotification: '//div[@data-testid="danger-notification"]',
      newP2PMessageText: '//div[text()="New P2P Message"]',
      closeButton: '//*[@data-testid="close"]', //svg
      messageRoot: '//div[@data-testid="p2pThreadView"]',
      messageTypeDropdown: '//div[@data-testid="typeFormSelect"]',
      subjectTextArea: '//textarea[@data-testid="p2pSubject"]',

      noticeOfDiscrepancyType: '//div[@data-testid="Notice of discrepancy"]',
      generalMessageType: '//div[@data-testid="General message"]',
      requestForCancellationType: '//div[@data-testid="Request for cancellation"]',
      adviceOfReimbursementOrPaymentType: '//div[@data-testid="Advice of reimbursement or payment"]',
      authorisationToPayAcceptOrNegotiateType: '//div[@data-testid="Authorisation to pay, accept or negotiate"]',
      adviceOfDischargeType: '//div[@data-testid="Advice of discharge"]',
      adviceOfRefusalType: '//div[@data-testid="Advice of refusal"]',

      //TODO: ask FE developer to add data-test id for recipientsDropdown button
      recipientsDropdown: '//div[@data-testid="p2pRecipients"]/div[1]/div[1]/div[1]/div[2]//*[name()="svg"][1]',
      childRecipeint: '//div[@data-testid="p2pRecipients"]//div[@data-testid="#COMPANY_NAME#"]',

      formMessageTextArea: '//div[@data-testid="p2pThreadView"]//textarea[@data-testid="messageTextarea"]',
      viewMessageTextArea: '//div[@data-testid="p2pThreadView"]//textarea[@data-testid="messageTextarea"]',

      attachButton: '//div[@data-testid="attachFiles"]',
      sendButton: '//button[@data-testid="submitMessage"]',
      cancelButton: '//span[text()="Cancel"]/ancestor::button',

      displayAttachFilesRoot: '//div[@data-testid="attachedFiles"]',
      displayAttachFileChild: '//div[@data-testid="attachFile"]//span[text()="#FILE_NAME#"]',
      removeButtonAtAttachFileChild:
        '//div[@data-testid="attachFile"]//span[text()="#FILE_NAME#"]/ancestor::div[@data-testid="attachFile"]//*[name()="svg"][@data-testid="removeIcon"]',

      generalMessageOption: '//div[text()="General message"]',
      requestForCancellationOption: '//div[text()="Request for cancellation"]',

      //send message popup
      sendPopupCancelButton: '//div[@id="overlap"]//button[text()="Cancel"]',
      sendPopupConfirmButton: '//div[@id="overlap"]//button[text()="Confirm"]',
      approveButton: '//button[@data-testid="approveRequest"]',
      confirmApproveButton: '//button[@data-testid="submitLcCancellation"]',

      //leave page popup
      leavePagePopupLeaveButton: '//button[text()="Leave"]',
      leavePagePopupStayButton: '//button[text()="Stay"]',
      cancellationMessage: '//textarea[@data-testid="dcCancellationBody"]'
    }
  },
  v8: {
    locators: {}
  },
  v8_1: {
    locators: {}
  }
};
