export default {
  default: {
    url: '',
    title: 'P2P message view',
    locators: {
      filesTab: '//div[@data-testid="p2pThreadView"]//div[@data-testid="files-tab"]',
      messageTab: '//div[@data-testid="p2pThreadView"]//div[@data-testid="message-tab"]',
      viewRoot: '//div[@data-testid="p2pThreadView"]',
      header: {
        subject: '//div[@data-testid="subject"]',
        recipients: '//span[@data-testid="recipients"]',
        recipientCount: '//span[@data-testid="recipientCount"]',
        recipientIcon: '//*[@data-testid="recipientIcon"]' //svg
      },
      messageBubblesByMessage:
        '//div[text()="#MESSAGE#"]/ancestor::div[@data-testid="myMessage" or @data-testid="otherMessage"]',
      allMessageBubbles: '//div[@data-testid="myMessage" or @data-testid="otherMessage"]',
      allMyBubbles: '//div[@data-testid="myMessage"]',
      allOtherBubbles: '//div[@data-testid="otherMessage"]',
      downloadIconForAttachedFileAtMyMessage:
        '//div[text()="#MESSAGE#"]/ancestor::div[@data-testid="myMessage"]//span[text()="#FILE_NAME#"]/ancestor::div[@data-testid="attachFile"]//*[name()="svg"][@data-testid="downloadIcon"]',
      downloadIconForAttachedFileAtOtherMessage:
        '//div[text()="#MESSAGE#"]/ancestor::div[@data-testid="otherMessage"]//span[text()="#FILE_NAME#"]/ancestor::div[@data-testid="attachFile"]//*[name()="svg"][@data-testid="downloadIcon"]',
      rejectLabel: '//button[@data-testid="reject"]',
      approveLabel: '//button[@data-testid="approve"]',
      editLabel: '//button[@data-testid="edit"]',
      discardP2PButton: '//button[@data-testid="discard"]',
      discardConfirmButton: '//button[contains(text(),"Discard")]',
      approveRequestButton: '//button[@data-testid="approveRequest"]',
      rejectRequestButton: '//button[@data-testid="rejectRequest"]',
      confirmApproveButton: '//button[@data-testid="submitLcCancellation"]',

      body: {
        root: '//div[@id="p2p-message-list"]',
        myBubbleByMessage:
          '//div[@data-testid="myMessage"]//div[@data-testid="message"][text()="#MESSAGE#"]/ancestor::div[@data-testid="myMessage"]',
        otherBubbleByMessage:
          '//div[@data-testid="otherMessage"]//div[@data-testid="message"][text()="#MESSAGE#"]/ancestor::div[@data-testid="otherMessage"]',
        bubbleByIndex: '//div[#ORDER#][@data-testid="myMessage" or @data-testid="otherMessage"]',
        myBubbleByIndex: '//div[#ORDER#][@data-testid="myMessage"]',
        otherBubbleByIndex: '//div[#ORDER#][@data-testid="otherMessage"]',
        pendingBar: '//div[#ORDER#]//div[text()="Pending"]',
        child: {
          sender: '//div[@data-testid="sender"]',
          message: '//div[@data-testid="message"]',
          alertIcon: '//*[name()="svg"][@data-testid="alertIcon"]', //svg
          rejectLabel: '//span[text()="Rejected"]',
          rejectComment: '//div[@data-testid="rejectComment"]',
          dateTime: '//span[@data-testid="sentDate"]',
          attachedFileList: '//div[@data-testid="attachFileList"]',
          attachedFile: '//div[@data-testid="attachFile"]',
          attachedFileName: '//div[@data-testid="attachFile"]//span[text()="#FILE_NAME#"]',
          approveButton: '/following-sibling::div[1]//button[@data-testid="approve"]//span',
          verifyButton: '/following-sibling::div[1]//button[@data-testid="approve"]//span',
          rejectButton: '/following-sibling::div[1]//button[@data-testid="reject"]//span',
          editButton: '/following-sibling::div[1]//button[@data-testid="edit"]//span',
          discardButton: '/following-sibling::div[1]//button[@data-testid="discard"]//span'
        }
      },
      fileRows: '//div[@data-testid="p2pThreadView"]//div[@data-testid="file"]',
      fileRowForAFile: '//span[@data-testid="fileName"][text()="#FILE_NAME#"]/ancestor::div[@data-testid="file"]',
      fileRowChild: {
        fileName: '//span[@data-testid="fileName"]',
        downloadButton: '//[name()="svg"][@data-testid="downloadIcon"]',
        sentFrom: '//div[@data-testid="sender"]',
        sentDate: '//div[@data-testid="sentDate"]'
      }
    }
  },
  v8: {
    locators: {}
  },
  v8_1: {
    locators: {}
  }
};
