import { WebElement } from '@contour/fet/lib/elements';
import { Button } from '@contour/fet/lib/elements/button';

import { ContourBasePage } from '../../base/basePage';
import locator from './sideMenu.locator';

export default class SideMenu extends ContourBasePage {
  constructor(url?: string) {
    super(locator, url);
  }

  getDcExportButton() {
    return new Button(this.getLocatorAsString('dcExport'));
  }

  getDcImportButton() {
    return new Button(this.getLocatorAsString('dcImport'));
  }

  getContourLogo() {
    return new WebElement(this.getLocatorAsString('contourLogo'));
  }
}
