import { scrollToElement } from '@contour/fet/lib/support/action/scrollToElement';
import { checkVrElementImageWithElementsHide } from '@contour/fet/lib/support/check/checkVrElementImageWithElementHide';

async function scrollToAndCheckVR(pageName, elementName, refFile) {
  await scrollToElement(pageName, elementName);
  await checkVrElementImageWithElementsHide(pageName, elementName, refFile, pageName, 'issuedDate|applicationDate');
}

export async function checkAmendedOrUpdatedDc(refName: string) {
  await scrollToAndCheckVR('dcForm', 'corporatesContainer', `${refName}/Corp`);
  await scrollToAndCheckVR('dcForm', 'banksContainer', `${refName}/Banks`);
  await scrollToAndCheckVR('dcForm', 'keyTermsContainer', `${refName}/KeyTerms`);
  await scrollToAndCheckVR('dcForm', 'shipmentDetailsContainer', `${refName}/ShipmentDetails`);
  await scrollToAndCheckVR('dcForm', 'dcDetailsContainer', `${refName}/dcDetails`);
  await scrollToAndCheckVR('dcForm', 'attachmentsContainer', `${refName}/AttachmentsContainer`);
}
