import { AmendmentDraftTextPage } from '../../../pages/amendment/amendmentDraftText.page';
import * as stringUtil from '../../../util/stringUtil';

export function checkAmendmentDraftTextUpdatedValue(dataTable) {
  const amendmentDraftTextPage = new AmendmentDraftTextPage();

  const data = dataTable.rowsHash();

  Object.keys(data).forEach(function (key) {
    const updatedKey = stringUtil.toSentenceCase(key);
    const actualVal = amendmentDraftTextPage.getUpdatedField(updatedKey).getText();

    if (actualVal != data[key]) {
      throw new Error(
        'checkAmendmentDraftTextUpdatedValue: ' + key + 'expected ' + data[key] + 'but actual ' + actualVal
      );
    }
  });
}
