import USER_ROLE from '../../../enum/userRole';
import ActionButton from '../../../pages/actionButton/actionButton.page';
import SubSideMenu from '../../../pages/sideMenu/subSideMenu.page';
import { loginToMainPageForScenario } from '../../login/glue/loginToMainPageForScenario';
import { navigateToCurrentDC } from '../../navigation/glue/navigateToCurrentDC';

export async function checkAmendmentInactive(amendmentNum: number, dataTable: any) {
  const data = dataTable.raw();
  const subSideMenu = new SubSideMenu();
  const actionButton = new ActionButton();

  for (const element of data) {
    const party = element[0];

    loginToMainPageForScenario(party, USER_ROLE.MAKER);
    navigateToCurrentDC(party, 'contour uuid');

    await subSideMenu.getSubMenuOption('Amendments').clickElement();
    await subSideMenu.getSubMenuSubOption(`Amendment ${amendmentNum}`).clickElement();

    await actionButton.getGeneralButton().checkElementCount(0);
  }
}
