import { AmendmentDraftTextPage } from '../../../pages/amendment/amendmentDraftText.page';
import * as stepVariableMap from '../../../util/stepVariableMap';
import * as stringUtil from '../../../util/stringUtil';

export function checkAmendmentOriginalValue(scenario, dataTable) {
  const amendmentDraftTextPage = new AmendmentDraftTextPage();
  const svm = stepVariableMap.getStepVariableMap(scenario);

  const data = dataTable.rowsHash();

  Object.keys(data).forEach(function (key) {
    const updatedKey = stringUtil.toSentenceCase(key);
    const actualVal = amendmentDraftTextPage.getOriginalField(updatedKey).getText();

    const expectedVal = svm[data[key]] ?? data[key];

    if (actualVal != expectedVal) {
      throw new Error(
        'checkAmendmentDraftTextOriginalValue: ' + key + 'expected ' + expectedVal + 'but actual ' + actualVal
      );
    }
  });
}
