import USER_ROLE from '../../../enum/userRole';
import SubSideMenu from '../../../pages/sideMenu/subSideMenu.page';
import { loginToMainPageForScenario } from '../../login/glue/loginToMainPageForScenario';
import { navigateToCurrentDC } from '../../navigation/glue/navigateToCurrentDC';

export async function checkAmendmentVisibility(
  falseCase: boolean,
  type: string,
  amendmentVal: number,
  _scenario: string,
  dataTable: any
) {
  const data = dataTable.raw();
  const subSideMenu = new SubSideMenu();

  for (const element of data) {
    const party = element;

    loginToMainPageForScenario(String(party), USER_ROLE.MAKER);
    navigateToCurrentDC(String(party), 'contour uuid');

    (amendmentVal > 1 || !falseCase) ?? (await subSideMenu.getSubMenuOption('Amendments').clickElement());

    const option = type == 'amendment' ? 'Amendment ' : 'Draft Text ';
    await subSideMenu.getSubMenuSubOption(option + amendmentVal).checkIsDisplayed(!!falseCase);
  }
}
