import { DataTable, Given } from '@cucumber/cucumber';

import scenarioContext, {
  initScenarioContext,
  initScenarioContextForDefaultParty,
  setupCustomScenarioContext
} from '../../util/scenarioContext';
import * as glue from './glue';

Given(/^DEV_ONLY I set current dc uuid as "([^"]+)?"$/, glue.debugSetCurrentDCUUID);

Given(/^I setup test scenario context$/, initScenarioContext);
Given(/^I setup test scenario context for default node$/, initScenarioContextForDefaultParty);
Given(/^I setup test scenario variable map$/, () => {
  scenarioContext().initVariableMap();
});

Given(/^I setup test scenario context with following in data store$/, (dataTable: DataTable) => {
  const data = dataTable.hashes();
  initScenarioContext();
  data.forEach((row) => scenarioContext().dataStore.set(row['key'], row['value']));
});

Given(/^I setup custom test scenario context$/, setupCustomScenarioContext);
