import { pause } from '@contour/fet/lib/support/action/pause';
import { scrollToElement } from '@contour/fet/lib/support/action/scrollToElement';
import { checkVrElementImage } from '@contour/fet/lib/support/check/checkVrElementImage';
import { DataTable } from '@cucumber/cucumber';

export async function scrollToAndCheckVR(pageName, elementName, refFile) {
  await pause('2000');
  await scrollToElement(pageName, elementName);
  await pause('2000');
  await checkVrElementImage(pageName, elementName, refFile);
}

export function checkScreenshots(dataTable: DataTable) {
  const data = dataTable.hashes();
  logger.debug(`checkScreenshots: ${JSON.stringify(data, null, 2)}`);
  data.forEach(async (d) => {
    await scrollToAndCheckVR(d.page, d.element, d.refImage);
  });
}
