import { waitForVisible } from '@contour/fet/lib/support/action/waitForVisible';

import DcListing from '../../../pages/dc/dcListing.page';
import SideMenu from '../../../pages/sideMenu/sideMenu.page';
import { retry } from '../../../util/common';
import scenarioContext from '../../../util/scenarioContext';

export function checkStatusAfterRefresh(party: string, type: string, textToMatch: string) {
  retry(3, refreshDcListing, [party, type, textToMatch]);
}

export async function refreshDcListing(party: string, type: string, textToMatch: string) {
  await waitForVisible('dcListing', 'dcTable');
  await browser.refresh();
  if (party == 'exportParty') {
    const sideMenuPage = new SideMenu();
    await sideMenuPage.getDcExportButton().clickElement();
  }
  const dcListingPage = new DcListing();
  type == 'main'
    ? await dcListingPage.getDcMainStatusByUuid().checkContainsText(textToMatch)
    : await dcListingPage
        .getAmendmentMainStatus(scenarioContext().dc.uuid.substring(0, 8))
        .checkContainsText(textToMatch);
}
