import { Then } from '@cucumber/cucumber';

import { CompanySettingsPage } from '../../pages/companySettings/companySettings.page';
import { NavigationBarPage } from '../../pages/navigationBar/navigationBar.page';
import * as glue from './glue';

// Audit log
Then(
  /^I expect the audit log as follow for scenario (sc1|sc2|sc4|sc5|sc6|sc8|sc10|sc11)$/,
  async function (scenario, dataTable) {
    await glue.checkAuditLog(scenario, dataTable);
  }
);

// Company settings
Then(
  /^I select (UserRoles|Users|Network|Customisation|SharedMailbox|SecuritySettings|AuditTrail) from Company Settings left menu$/,
  async function (option) {
    await new NavigationBarPage().selectOption('settingIcon');
    await new CompanySettingsPage().selectOptionFromLeftMenu(option);
  }
);
