import { AuditLog } from '../../../pages/companySettings/auditLog/auditLog.page';
import * as stepVariableMap from '../../../util/stepVariableMap';

export async function checkAuditLog(scenario, dataTable) {
  const auditLogPage = new AuditLog();
  const svm = stepVariableMap.getStepVariableMap(scenario);

  const data = dataTable.raw();

  for (let i = 0; i < data.length; i++) {
    await auditLogPage.getInitialParty(i + 1).checkEqualsText(svm[data[i][0]] ?? data[i][0]);
    await auditLogPage.getStatus(i + 1).checkEqualsText(data[i][1]);
    await auditLogPage.getActionLog(i + 1).checkEqualsText(data[i][2]);
  }
}
