/* eslint-disable no-console */
import { Then, When } from '@cucumber/cucumber';

import DcListingPage from '../../pages/dc/dcListing.page';
import scenarioContext from '../../util/scenarioContext';
import * as glue from './glue';

const dcListing = new DcListingPage();

Then(/^I can see the DC has (main|sub) status "([^"]+)?"$/, async function (statusType, status) {
  const statusElement = statusType == 'sub' ? dcListing.getDcSubStatusByUuid() : dcListing.getDcMainStatusByUuid();
  await statusElement.checkContainsText(status);
});

Then(/^I can see the dc has amendment status "([^"]+)?"$/, async function (status) {
  const statusElement = dcListing.getAmendmentMainStatus(scenarioContext().dc.uuid.substring(0, 8));
  await statusElement.checkEqualsText(status);
});

Then(/^I can see the dc has amendment sub status "([^"]+)?"$/, async function (status) {
  const statusElement = dcListing.getAmendmentSubStatus(scenarioContext().dc.uuid.substring(0, 8));
  await statusElement.checkEqualsText(status);
});

Then(/^I can see the dc has dp status "([^"]+)?"$/, async function (status) {
  const statusElement = dcListing.getDpMainStatusByUuid(scenarioContext().dc.uuid.substring(0, 8));
  await statusElement.checkEqualsText(status);
});

Then(/^I can see the dc has dp sub status "([^"]+)?"$/, async function (status) {
  const statusElement = dcListing.getDpSubStatusByUuid(scenarioContext().dc.uuid.substring(0, 8));
  await statusElement.checkEqualsText(status);
});

When(/^I set (contour-id|ref no) to the inputfield "([^"]+)?"."([^"]+)?"$/, glue.setDCSearchInput);
