import { Input } from '@contour/fet/lib/elements';
import { scrollToElement } from '@contour/fet/lib/support/action/scrollToElement';
import { checkVrElementImage } from '@contour/fet/lib/support/check/checkVrElementImage';

async function scrollToAndCheckVR(pageName, elementName, refFile) {
  await scrollToElement(pageName, elementName);
  await checkVrElementImage(pageName, elementName, refFile);
}

export async function checkDc(scenario) {
  await scrollToAndCheckVR('dcForm', 'corporatesContainer', `dc_form/${scenario}/filledCorp`);
  await scrollToAndCheckVR('dcForm', 'banksContainer', `dc_form/${scenario}/filledBanks`);
  await scrollToAndCheckVR('dcForm', 'keyTermsContainer', `dc_form/${scenario}/filledKeyTerms`);
  await scrollToAndCheckVR('dcForm', 'shipmentDetailsContainer', `dc_form/${scenario}/filledShipmentDetails`);
  await scrollToAndCheckVR('dcForm', 'dcDetailsContainer', `dc_form/${scenario}/filleddcDetails`);
  await scrollToAndCheckVR('dcForm', 'attachmentsContainer', `dc_form/${scenario}/filledAttachmentsContainer`);
  await scrollToAndCheckVR('dcForm', 'internalCommentsContainer', `dc_form/${scenario}/filledinternalComments`);
}

export async function checkDCEditable(): Promise<Input[]> {
  const applicantAddress = new Input(contourfet.getPageElement('dcForm', 'applicantAddressInput'));
  const amount = new Input(contourfet.getPageElement('dcForm', 'amountInput'));
  const description = new Input(contourfet.getPageElement('dcForm', 'descriptionOfGoodsAndServicesInput'));
  await applicantAddress.checkIsEnabled();
  await amount.checkIsEnabled();
  await description.checkIsEnabled();
  return [applicantAddress, amount, description];
}
