import DcForm from '../../../pages/dc/dcForm.page';

export async function checkDocumentSource(dataTable: any) {
  const dcFormPage = new DcForm();
  const data = dataTable.rowsHash();

  if (data['Tick - Transport Document'] != '') {
    await dcFormPage.getDocumentRequiredTransportDocumentCheckbox().scroll();
    await dcFormPage.getDocumentRequiredTransportDocumentCheckbox().checkElementAttributeExists('checked');
    await dcFormPage.getDocumentRequiredTransportType().checkEqualsText(data['Select Transport Document']);

    if (data['Select Transport Document'] == 'Others, please specify') {
      await dcFormPage.getDocumentRequiredTransportSubtypeInput().checkEqualsText(data['Other Transport Document']);
    }

    await dcFormPage
      .getDocumentRequiredTransportDocumentDescription()
      .checkEqualsText(data['Transport Document Description']);
  } else {
    await dcFormPage.getDocumentRequiredTransportDocumentCheckbox().checkElementAttributeExists('checked', true);
    await dcFormPage.getDocumentRequiredTransportDocumentDescription().checkEqualsText('');
  }

  if (data['Tick - Certificate of Origin'] != '') {
    await dcFormPage.getDocumentRequiredCertificateOfOriginCheckbox().checkElementAttributeExists('checked');
    await dcFormPage
      .getDocumentRequiredCertificateOfOriginInput()
      .checkEqualsText(data['Certificate of Origin Description']);
  } else {
    await dcFormPage.getDocumentRequiredCertificateOfOriginCheckbox().checkElementAttributeExists('checked', true);
    await dcFormPage.getDocumentRequiredCertificateOfOriginInput().checkEqualsText('');
  }

  if (data['Tick - Packing List'] != '') {
    await dcFormPage.getDocumentRequiredPackingListCheckbox().checkElementAttributeExists('checked');
    await dcFormPage.getDocumentRequiredPackingListDescription().checkEqualsText(data['Packing List Description']);
  } else {
    await dcFormPage.getDocumentRequiredPackingListCheckbox().checkElementAttributeExists('checked', true);
    await dcFormPage.getDocumentRequiredPackingListDescription().checkEqualsText('');
  }

  for (let i = 0; i < data['Other Required Document Count']; i++) {
    const otherDocName = data['Other Required Document Names'].split(',');
    const otherDocDesc = data['Other Required Document Descriptions'].split(',');

    await dcFormPage.getDocumentRequiredOtherDocumentsRequiredInput(i).checkEqualsText(otherDocName[i]);
    await dcFormPage.getDocumentRequiredOtherDocumentsRequiredDescriptionInput(i).checkEqualsText(otherDocDesc[i]);
  }
}
