import { WebElement } from '@contour/fet/lib/elements';

import TemplateList from '../../../pages/template/templateList.page';

export async function checkTemplateName(templatePosition: number, templateName: string) {
  const templatesPage = new TemplateList();
  await templatesPage.getTemplateName(templatePosition).checkContainsText(templateName);
}

export async function checkPreFilledTemplateData(dataTable: any) {
  const data = dataTable.raw();
  for (let i = 0; i < data.length; i++) {
    if (data[i][0] == '') {
      return;
    }
    const element = data[i][0];
    const elementValue = data[i][1];
    const formElement = new WebElement(contourfet.getPageElement('dcForm', element));
    await formElement.checkContainsText(elementValue);
  }
}
