import { Given, Then, When } from '@cucumber/cucumber';

import * as glue from './glue';
import generateDpUtil from './glue/generateDpUtil';

Given(
  /^beneficiary present DP to "([^"]*)" through "([^"]*)" at dc (sc1|sc2|sc4|sc5|sc6|sc8|sc10|sc11|sc3split|sc2split)$/,
  async function (presentToParty, presentThroughParty, dcScenario) {
    await generateDpUtil(dcScenario, presentToParty, presentThroughParty);
  }
);

When(/^I fill in dp overview with following information for scenario "([^"]*)"$/, glue.fillInDpOverview);
When(/^I fill in the present to bank with following information for scenario "([^"]*)"$/, glue.fillInPresentTo);

When(/^I fill in dp cover letter by "([^"]*)" with following information$/, glue.fillInCoverLetter);

When(/^I fill in dp other document "([^"]*)" with following information$/, glue.fillInOtherDocument);

When(
  /^I (certify presentation is complete|sent notice of completion with mail) and submit presentation$/,
  glue.fillNoticeOfCompletenessAndSubmitPresentation
);
When(/^I fill in dp packing list "([^"]*)" with following information$/, glue.fillInPackingList);
When(/^I fill in dp certificate of origin "([^"]*)" with following information$/, glue.fillInCertificateOfOrigin);

Then(/^I expect the following document sources to match the references below$/, glue.checkDocumentSources);
