import { Given } from '@cucumber/cucumber';

import {
  loginAndAcceptDPNumberAtCurrentDC,
  loginAndOpenDPNumberAtCurrentDC,
  loginAndReviewPendingDPNumberAtCurrentDC,
  loginAndSetPaymentDueDateOrReleaseDocuments
} from './glue';

Given(
  /^(applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank) (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) login and open DP(\d)+ at current DC$/,
  loginAndOpenDPNumberAtCurrentDC
);

Given(
  /^(applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank) (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) login and Accept DP(\d)+ at current DC$/,
  loginAndAcceptDPNumberAtCurrentDC
);

Given(
  /^(applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank) (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) login and (Verify|Decline|Approve) pending DP(\d)+ at current DC$/,
  loginAndReviewPendingDPNumberAtCurrentDC
);
Given(
  /^(issuingBank)'s (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) logs in to (releaseDocuments|setPaymentDueDate) for DP(\d)+ at current DC$/,
  loginAndSetPaymentDueDateOrReleaseDocuments
);
