import PARTY from '../../../enum/party';
import ActionButton from '../../../pages/actionButton/actionButton.page';
import DpCoverLetter from '../../../pages/dp/dpCoverLetter.page';
import SubSideMenu from '../../../pages/sideMenu/subSideMenu.page';
import { toSentenceCase } from '../../../util/stringUtil';

export async function fillInCoverLetter(party: string, dataTable: any) {
  const data = dataTable.rowsHash();
  const subSideMenu = new SubSideMenu();
  const dpCoverLetter = new DpCoverLetter();
  const actionButton = new ActionButton();

  await subSideMenu.getSubMenuSubOption(`Cover letter by ${toSentenceCase(party)}`).clickElement();

  if (party == PARTY.BENEFICIARY) {
    const instruction = data['Instruction'];

    if (instruction == 'Payment') {
      await dpCoverLetter.getRadioInstructionPayment().clickElement();
    } else if (instruction == 'Other instruction') {
      await dpCoverLetter.getRadioOtherInstruction().clickElement();
    } else {
      await dpCoverLetter.getRadioNoInstruction().clickElement();
    }

    if (data['Account number to debit']) {
      await dpCoverLetter.getInputAccountNumberToDebit().setInputField(data['Account number to debit']);
    }

    if (data['Account number to credit']) {
      await dpCoverLetter.getInputAccountNumberToCredit().setInputField(data['Account number to credit']);
    }

    if (data['Exchange contract']) {
      await dpCoverLetter.getInputExchangeContract().setInputField(data['Exchange contract']);
    }

    if (data['Other proceeds']) {
      await dpCoverLetter.getInputOtherProceeds().setInputField(data['Other proceeds']);
    }
  }

  await actionButton.getSaveAndNextButton().clickElement();
}
