import moment from 'moment';

import { DP_ACTION } from '../../../enum/dp/dpAction';
import ActionButton from '../../../pages/actionButton/actionButton.page';
import DpOverview from '../../../pages/dp/dpOverview.page';
import * as dateUtil from '../../../util/dateUtil';
import { loginAndOpenDPNumberAtCurrentDC } from './';

export async function loginAndSetPaymentDueDateOrReleaseDocuments(
  party: string,
  role: string,
  action: string,
  dpNumber: number
) {
  await loginAndOpenDPNumberAtCurrentDC(party, role, dpNumber);
  const actionButtonPage = new ActionButton();
  const dpOverviewPage = new DpOverview();
  if (action == DP_ACTION.SETPAYMENTDUEDATE) {
    const randomDate = dateUtil.getRandomDate();
    await dpOverviewPage.getPaymentDueDate().selectDate(moment(randomDate, 'YYYY-MM-DD'));

    await actionButtonPage.getSetPaymentDateButton().clickElement(true, true);
    await actionButtonPage.getSubmitButton().clickElement(true, true);
  } else if (action == DP_ACTION.RELEASEDOCUMENTS) {
    await actionButtonPage.getReleaseDocumentsButton().clickElement(true, true);
    await actionButtonPage.getPreviewButton().clickElement();
    await actionButtonPage.getSubmitButton().clickElement();
  }
}
