import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getNodeProfile } from '../../../env/nodeProfile';
import SideMenu from '../../../pages/sideMenu/sideMenu.page';
import scenarioContext from '../../../util/scenarioContext';
import { loginToMainPageForScenario } from './loginToMainPageForScenario';

const assert = require('assert').strict;

export async function loginAndOpenCurrentDC(party: string, role: string): Promise<void> {
  loginToMainPageForScenario(party, role);
  const sideMenu = new SideMenu();
  await sideMenu.getContourLogo().checkIsExisting();
  const partyCompany = scenarioContext().isPartyInScenarioContext(party)
    ? scenarioContext().scenario[party]
    : envConfig.defaultParty[party];
  const baseUrl = getNodeProfile(partyCompany).baseUrl;
  const uuid = scenarioContext().dc.uuid;

  assert.equal(true, !!uuid, "dc uuid doesn't exist");
  await Web.url(baseUrl + envConfig.pages.openDC + uuid);
}
