import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getNodeProfile } from '../../../env/nodeProfile';
import SideMenu from '../../../pages/sideMenu/sideMenu.page';
import scenarioContext from '../../../util/scenarioContext';
import { loginToMainPageForScenario } from './loginToMainPageForScenario';

const assert = require('assert').strict;

export async function loginAndOpenCurrentDCWithDP(party: string, role: string): Promise<void> {
  loginToMainPageForScenario(party, role);
  const sideMenu = new SideMenu();
  await sideMenu.getContourLogo().checkIsExisting();
  const partyCompany = envConfig.defaultParty[party];
  const baseUrl = getNodeProfile(partyCompany).baseUrl;
  const uuid = scenarioContext().dc.uuid;
  assert.equal(true, !!uuid, "dc uuid doesn't exist");
  await browser.pause(3000);
  await Web.url(baseUrl + envConfig.pages.openDP.replace('#UUID#', uuid));
}
