import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getNodeProfile } from '../../../env/nodeProfile';

export async function loginNodeAdmin(): Promise<void> {
  const partyCompany = envConfig.defaultParty.issuingBank;
  const url = getNodeProfile(partyCompany).nodeAdminUrl;
  await Web.url(url);
}

export async function changeURL(): Promise<void> {
  const partyCompany = envConfig.defaultParty.applicant;
  let url = getNodeProfile(partyCompany).baseUrl;
  url = url + envConfig.pages.nodeAdmin;
  await Web.url(url);
}
