import { DbClient } from '@contour/db-client/lib/dbClient';
import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getDefaultNodeBaseUrl, getNodeProfile } from '../../../env/nodeProfile';
import { ResetPasswordPage } from '../../../pages/login/resetPassword/resetPassword.page';
import scenarioContext from '../../../util/scenarioContext';

export async function loadResetPasswordPage(loadType: string): Promise<void> {
  const baseURL = scenarioContext().currentLoggedInCompany
    ? getNodeProfile(scenarioContext().currentLoggedInCompany).baseUrl
    : getDefaultNodeBaseUrl();
  const resetPwdUrl = baseURL + envConfig.pages.resetPassword;

  if (loadType === 'invalid') {
    await Web.url(resetPwdUrl + 'invalidtoken');
    return;
  }

  const query = `select token from user_reset_password where email='${scenarioContext().userDtl.email}';`;
  const results = await new DbClient(getNodeProfile(scenarioContext().currentLoggedInCompany).dbConfig).runQuery(query);
  await Web.url(resetPwdUrl + results[0]['token']);
}

export async function submitResetPasswordForm(password: string, confirmPassword: string): Promise<void> {
  await new ResetPasswordPage().submitResetPasswordForm(password, confirmPassword);
  scenarioContext().userDtl.password = password;
}

export async function clearResetPasswordForm(): Promise<void> {
  await new ResetPasswordPage().clearPasswordInputFields();
}
