import { Given, When } from '@cucumber/cucumber';

import { ForgotPasswordPage } from '../../pages/login/forgotPassword/forgotPassword.page';
import * as glue from './glue';

Given(
  /^(applicant|beneficiary|issuingBank|confirmingBank|newConfirmingBank|advisingBank|newAdvisingBank|nominatedBank)'s (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) login to main page for scenario (sc1|sc2|sc2split|sc3split|sc4|sc5|sc6|sc8|sc10|sc11|sc12)$/,
  glue.loginToMainPageForScenario
);
Given(
  /^(applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank) (maker|checker|approver|makerChecker|checkerApprover|admin1|admin2) login and open current dc$/,
  glue.loginAndOpenCurrentDC
);

Given(
  /^I login to default (applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank)'s node as user in scenario context$/,
  glue.loginToDefaultNodeAsCustomUser
);

Given(/^I open nodeAdmin login page$/, glue.loginNodeAdmin);
Given(/^I change to nodeadmin URL$/, glue.changeURL);

When(/^I submit the forgot password form with "([^"]*)?"$/, async (email) => {
  const forgotPasswordPage = new ForgotPasswordPage();
  await forgotPasswordPage.requestPasswordResetLink(email);
});
When(/^I submit the forgot password form with user email in current context$/, async () => {
  const forgotPasswordPage = new ForgotPasswordPage();
  await forgotPasswordPage.requestPasswordResetLink(null);
});

When(
  /^I submit the reset password form with password "([^"]*)?" and confirm password "([^"]*)?"$/,
  glue.submitResetPasswordForm
);

Given(/^I load reset password page with (valid|invalid) token$/, glue.loadResetPasswordPage);
Given(/^I clear the reset password form$/, glue.clearResetPasswordForm);
