import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getNodeProfile } from '../../../env/nodeProfile';
import SideMenu from '../../../pages/sideMenu/sideMenu.page';
import * as loginGlue from '../../login/glue/index';

export async function loginAndOpenDC(party, role, scenario, uuid) {
  loginGlue.loginToMainPageForScenario(party, role, scenario);
  const sideMenu = new SideMenu();
  await sideMenu.getContourLogo().checkIsExisting();
  const partyCompany = envConfig.scenario[scenario][party];
  const baseUrl = getNodeProfile(partyCompany).baseUrl;
  await Web.url(baseUrl + envConfig.pages.openDC + uuid);
}
