import { Web } from '@contour/fet/lib/elements';

import envConfig from '../../../env/env-config';
import { getNodeProfile } from '../../../env/nodeProfile';
import { loginToMainPageForScenario } from '../../login/glue/loginToMainPageForScenario';

export async function makerLoginAndOpenScenario(party, scenario, uuid) {
  const partyCompany = envConfig.scenario[scenario][party];
  loginToMainPageForScenario(partyCompany, 'maker', scenario);
  const baseUrl = getNodeProfile(partyCompany).baseUrl;
  await browser.pause(3000);
  await Web.url(baseUrl + envConfig.pages.openDC + uuid);
}
