import { DOCUMENT_TYPE } from '../../../enum/documentType';
import { SECTION } from '../../../enum/navigationSection';
import P2PMessageListing from '../../../pages/p2p/p2pMessageListing.page';
import DCSideMenu from '../../../pages/sideMenu/dcSideMenu.page';
import DPSideMenu from '../../../pages/sideMenu/dpSideMenu.page';

export async function navigateFromDCToP2PSection(sectionName, docType) {
  const p2pMessageListing = new P2PMessageListing();
  if (docType === DOCUMENT_TYPE.DC) {
    const dcSideMenu = new DCSideMenu();
    await dcSideMenu.getP2PMessageButton().clickElement();
    if (sectionName === SECTION.NEW_P2P_MESSAGE) {
      await p2pMessageListing.getNewButton().clickElement();
    }
  } else if (docType === DOCUMENT_TYPE.DP) {
    const dpSideMenu = new DPSideMenu();
    await dpSideMenu.getP2PMessageButton().clickElement();
    if (sectionName === SECTION.NEW_P2P_MESSAGE) {
      await dpSideMenu.getP2PMessageButton().clickElement();
      await p2pMessageListing.getNewButton().clickElement();
    }
  }
}
