import PARTY from '../../../enum/party';
import DcListing from '../../../pages/dc/dcListing.page';
import DcOverview from '../../../pages/dc/dcOverview.page';
import scenarioContext from '../../../util/scenarioContext';
import { navigateToDcListingPage } from './';

export async function navigateToCurrentDP(party: string, uniqueIdentifier: string) {
  await navigateToDcListingPage(party);
  const dcListingPage = new DcListing();
  const contourId = scenarioContext().dc.uuid.substring(0, 8);
  const uuid = dcListingPage.getDcRefByUuid(contourId);
  await uuid.clickElement();

  const dcOverViewPage = new DcOverview();
  if (party == PARTY.BENEFICIARY) {
    await dcOverViewPage.getPresentationLink().clickElement();
  }
}
