import PARTY from '../../../enum/party';
import DcListing from '../../../pages/dc/dcListing.page';
import SideMenu from '../../../pages/sideMenu/sideMenu.page';

export async function navigateToDCByUUID(party: PARTY, uuid: string) {
  const sideMenuPage = new SideMenu();
  const dcListingPage = new DcListing();

  const needToClickExportParty = [PARTY.BENEFICIARY, PARTY.CONFIRMING_BANK, PARTY.NOMINATED_BANK, PARTY.ADVISING_BANK];

  if (needToClickExportParty.includes(party)) {
    await sideMenuPage.getDcExportButton().clickElement();
  }

  const contourId = uuid;
  await dcListingPage.getDcRefByUuid(contourId).clickElement();
}
