import { Given, When } from '@cucumber/cucumber';

import { NavigationBarPage } from '../../pages/navigationBar/navigationBar.page';
import { UserMenuPage } from '../../pages/navigationBar/userMenu.page';
import * as glue from './glue';

When(
  /^(applicant|beneficiary|issuingBank|advisingBank|nominatedBank|advisingBank|newAdvisingBank|confirmingBank|newConfirmingBank) navigate to current dc using (unique expiry date|contour uuid)$/,
  glue.navigateToCurrentDC
);

When(
  /^(applicant|beneficiary|issuingBank|advisingBank|nominatedBank|advisingBank|confirmingBank) navigate to dc has uuid "([^"]+)?"$/,
  glue.navigateToDCByUUID
);

When(/^I navigate to create dc page$/, glue.navigateToCreateDC);

When(/^I navigate to create( template)? page$/, glue.navigateToCreateTemplate);

Given(
  /^DEV_ONLY (applicant|beneficiary|issuingBank|confirmingBank|advisingBank|nominatedBank) (maker|makerChecker|checker|checkerApprover|approver|admin1|admin2) login and open scenario (sc1|sc2|sc4|sc5|sc6|sc8|sc10|sc11) dc "([^"]+)?"$/,
  glue.loginAndOpenScenario
);

Given(/^user is at new p2p message page$/, glue.userIsAtNewP2PMessagePage);

When(
  /^(applicant|beneficiary|issuingBank|advisingBank|nominatedBank|advisingBank|confirmingBank) navigate to current (amendment|draft text) (\d+) using (unique expiry date|contour uuid)$/,
  glue.navigateToAmendmentOrDraftText
);

When(
  /^(applicant|beneficiary|issuingBank|advisingBank|nominatedBank|advisingBank|confirmingBank) navigate to current amendment view issued amendments using (unique expiry date|contour uuid)$/,
  glue.navigateToViewIssuedAmendments
);

When(
  /^(applicant|beneficiary|issuingBank) navigate to current amendment draft using (unique expiry date|contour uuid)$/,
  glue.navigateToAmendmentDraft
);

When(
  /^(applicant|beneficiary|issuingBank|advisingBank|nominatedBank|advisingBank|confirmingBank) navigate to dc listing page$/,
  glue.navigateToDcListingPage
);

When(/^I select (logout|account) from user menu$/, async function (option) {
  await new UserMenuPage().selectOption(option);
});

When('I select identity {string} from user menu', async function (option) {
  await new UserMenuPage().switchIdentity(option);
});

When(/^I click (settingsIcon|userAvatar|helpIcon) from navigation bar$/, async (_user, option) => {
  await new NavigationBarPage().selectOption(option);
});

//starting from dc form page
Given(/^I am at (New p2p message|P2P message listing) under (DC|DP)$/, glue.navigateFromDCToP2PSection);
