import { Button } from '@contour/fet/lib/elements';

import { P2P_MESSAGE_BUTTONS } from '../../../enum/p2p';
import P2PMessageView from '../../../pages/p2p/p2pMessageView.page';

const assert = require('assert').strict;

export async function clickButtonAtPendingMessage(buttonType) {
  const p2pMessageView = new P2PMessageView();
  const messageIndex = 2;
  let button: Button;
  switch (buttonType) {
    case P2P_MESSAGE_BUTTONS.VERRIFY:
      button = p2pMessageView.getBubbleVerifyButtonByIndex(messageIndex);
      break;

    case P2P_MESSAGE_BUTTONS.REJECT:
      button = p2pMessageView.getBubbleRejectButtonByIndex(messageIndex);
      break;

    case P2P_MESSAGE_BUTTONS.APPROVE:
      button = p2pMessageView.getBubbleApproveButtonByIndex(messageIndex);
      break;

    case P2P_MESSAGE_BUTTONS.EDIT:
      button = p2pMessageView.getBubbleEditButtonByIndex(messageIndex);
      break;

    case P2P_MESSAGE_BUTTONS.DISCARD:
      button = p2pMessageView.getBubbleDiscardButtonByIndex(messageIndex);
      break;
    default:
      assert.fail('Unknown Button:' + buttonType);
      break;
  }
  await button.clickElement();
}
