import { P2P_MESSAGE_TYPE } from '../../../enum/p2p';
import P2PMessage from '../../../pages/p2p/p2pMessage.page';
import SendMessagePopup from '../../../pages/popup/sendMessagePopup.page';
import * as dateUtil from '../../../util/dateUtil';
import * as p2pContextUtil from '../../../util/p2pContextUtil';
import scenarioContext from '../../../util/scenarioContext';
import { fillInCreateGeneralMessage } from './p2pGlueUtil';

export async function createP2PMessage(threadType, dataTable) {
  const rowsHash = dataTable.rowsHash();
  const senderCompany = scenarioContext().currentLoggedInCompany;

  if (threadType === P2P_MESSAGE_TYPE.GENERAL) {
    const filledInMessage = await fillInCreateGeneralMessage(senderCompany, rowsHash);
    const p2pMessagePage = new P2PMessage();
    await p2pMessagePage.getSendButton().clickElement();
    p2pContextUtil.recordLatestGeneraP2PThread(
      filledInMessage.subject,
      filledInMessage.message,
      filledInMessage.sender.displayName,
      filledInMessage.recipients.displayNames,
      dateUtil.getP2PShortTodayStr(),
      dateUtil.getTimestampStr(),
      filledInMessage.fileNameAttachments
    );
    await p2pMessagePage.getSendPopupConfirmButton().clickElement();
    const sendMessagePopup = new SendMessagePopup();

    await sendMessagePopup.getRootPopup().waitForVisible(true);
  }
}
