import { SECTION } from '../../../enum/navigationSection';
import SendMessagePopup from '../../../pages/popup/sendMessagePopup.page';
import { loginAndOpenCurrentDC } from '../../login/glue';
import { navigateFromDCToP2PSection } from '../../navigation/glue';
import { createP2PMessage, selectP2PMessageType } from '../../p2p/glue';

export async function loginAndCreateP2PMessage(party, role, messageType, documentType, dataTable) {
  await loginAndOpenCurrentDC(party, role);
  await navigateFromDCToP2PSection(SECTION.NEW_P2P_MESSAGE, documentType);
  await selectP2PMessageType(messageType);
  await createP2PMessage(messageType, dataTable);
  await browser.pause(1000);

  const sendMessagePopup = new SendMessagePopup();
  await sendMessagePopup.getRootPopup().waitForVisible(true);
}
