import { P2P_MESSAGE_TYPE } from '../../../enum/p2p';
import P2PMessage from '../../../pages/p2p/p2pMessage.page';
import SendMessagePopup from '../../../pages/popup/sendMessagePopup.page';
import * as dateUtil from '../../../util/dateUtil';
import * as p2pContextUtil from '../../../util/p2pContextUtil';
import scenarioContext from '../../../util/scenarioContext';
import { fillInReplyGeneralMessage } from './p2pGlueUtil';

export async function replyP2PMessage(messageType, dataTable) {
  const rowsHash = dataTable.rowsHash();
  const senderCompany = scenarioContext().currentLoggedInCompany;

  if (messageType === P2P_MESSAGE_TYPE.GENERAL) {
    const filledInMessage = await fillInReplyGeneralMessage(senderCompany, rowsHash);
    const p2pMessagePage = new P2PMessage();
    await p2pMessagePage.getSendButton().clickElement();

    p2pContextUtil.recordLatestGeneraP2PReply(
      filledInMessage.message,
      filledInMessage.sender.displayName,
      dateUtil.getP2PShortTodayStr(),
      dateUtil.getTimestampStr(),
      filledInMessage.fileNameAttachments
    );

    await p2pMessagePage.getSendPopupConfirmButton().clickElement();
    const sendMessagePopup = new SendMessagePopup();

    await sendMessagePopup.getRootPopup().waitForVisible(true);
    await browser.pause(2000);
  }
}
