import { DOCUMENT_TYPE } from '../../../../enum/documentType';
import { SECTION } from '../../../../enum/navigationSection';
import { P2P_MESSAGE_TYPE } from '../../../../enum/p2p';
import P2PMessage from '../../../../pages/p2p/p2pMessage.page';
import SendMessagePopup from '../../../../pages/popup/sendMessagePopup.page';
import { loginAndOpenDPNumberAtCurrentDC } from '../../../dp/glue';
import { navigateFromDCToP2PSection } from '../../../navigation/glue';
import { fillInCreateP2PMessage, selectP2PMessageType } from '../../glue';

export async function loginAndSendNoticeOfDiscrepancyAtCurrentDCDP(
  party: string,
  role: string,
  dpNumber: number,
  dataTable: { rowsHash: () => any }
) {
  await loginAndOpenDPNumberAtCurrentDC(party, role, dpNumber);
  await navigateFromDCToP2PSection(SECTION.NEW_P2P_MESSAGE, DOCUMENT_TYPE.DP);
  await selectP2PMessageType(P2P_MESSAGE_TYPE.NOTICE_OF_DISCREPANCY);
  await fillInCreateP2PMessage(P2P_MESSAGE_TYPE.NOTICE_OF_DISCREPANCY, dataTable);

  const p2pMessage = new P2PMessage();
  await p2pMessage.getSendButton().clickElement();

  const sendMessagePopup = new SendMessagePopup();
  await sendMessagePopup.getConfirmButton().clickElement();

  await sendMessagePopup.getRootPopup().waitForVisible(true);
}
