import { Then, When } from '@cucumber/cucumber';

import SubSideMenu from '../../pages/sideMenu/subSideMenu.page';
import * as glue from './glue';

const subSideMenu = new SubSideMenu();

When(/^I click sub side menu option "([^"]+)?"$/, async (option) => {
  await subSideMenu.getSubMenuOption(option).clickElement();
});

When(/^I click sub side menu sub-option "([^"]+)?"$/, async (option) => {
  await subSideMenu.getSubMenuSubOption(option).clickElement();
});

Then(/^I can( not)* see following sub side menu (option|subOption)$/, glue.checkSideMenuOption);

Then(/^I open (Amendment|Draft|Draft Text|Overview) (\d+)$/, async (amendmentType, amendmentNumber) => {
  if (await subSideMenu.getSubMenuOption('Amendments').isDisplayed()) {
    await subSideMenu.getSubMenuOption('Amendments').clickElement();
  }
  if (amendmentType == 'Draft Text') {
    await subSideMenu.getSubMenuSubOption('Draft Text ' + amendmentNumber).clickElement();
  } else if (amendmentType == 'Amendment') {
    await subSideMenu.getSubMenuSubOption('Amendment ' + amendmentNumber).clickElement();
  } else if (amendmentType == 'Overview') {
    await subSideMenu.getSubMenuSubOption('Overview').clickElement();
  } else {
    await subSideMenu.getSubMenuSubOption('Draft').clickElement();
  }
});
