import WORKFLOWSTATUS from '../enum/workflowStatus';
import { API } from './API';
import { HTTP_METHOD } from './httpMethod';
import * as loginUtil from './loginUtil';
import checkerApprover_payload from './payloads/checkerApprover_payload';

export function isWorkflowReadyForExecution(apiResponse: any): boolean {
  logger.info(`workflow status is ${apiResponse.status}`);
  return apiResponse.status == WORKFLOWSTATUS.ready ? true : false;
}

export async function checkerApproverResponse(node: string, role: string, apiResponse: any): Promise<any> {
  const checkerApproverActionResponse = await loginUtil.makeAuthenticatedRequest(
    node,
    role,
    API.RESPOND + apiResponse.id,
    HTTP_METHOD.POST,
    JSON.stringify(checkerApprover_payload)
  );
  if (isWorkflowReadyForExecution(checkerApproverActionResponse)) {
    return checkerApproverActionResponse;
  }
}
