import ACTION_TYPE from '../enum/actionType';
import { hasApproverRole } from '../enum/userRole';
import envConfig from '../env/env-config';
import { HTTP_METHOD } from './httpMethod';
import * as loginUtil from './loginUtil';
import scenarioContext from './scenarioContext';
import { updateAmendmentId } from './updateAmendmentId';
import { executeDraftAndMapNewId } from './updateDcId';

export async function checkerApproverProceedDraft(
  party: string,
  role: string,
  scenario: string,
  draftId: string,
  type: string,
  updatePos = 0
) {
  const checkerApproverJson = {
    reject: false,
    draftComment: {
      comment: ''
    }
  };

  const res = await loginUtil.makeAuthenticatedRequest(
    party,
    role,
    'draft/respond/' + draftId,
    HTTP_METHOD.POST,
    JSON.stringify(checkerApproverJson)
  );

  if (hasApproverRole.includes(role)) {
    if (type == ACTION_TYPE.LOCAMEND) {
      await updateAmendmentId(envConfig.scenario[scenario][party], updatePos, res.id);
    } else if (type == ACTION_TYPE.LOCAPP) {
      await executeDraftAndMapNewId(party, res.id);
    }
  } else {
    scenarioContext().dc.currentDraftId = res.id;
  }
}
