import moment from 'moment';

export function getTodayDate(): string {
  const ts = Date.now();

  const date_ob = new Date(ts);
  let date = date_ob.getDate().toString();

  if (date.length < 2) {
    date = '0' + date;
  }

  let month = (date_ob.getMonth() + 1).toString();

  if (month.length < 2) {
    month = '0' + month;
  }

  const year = date_ob.getFullYear();

  return year + '-' + month + '-' + date;
}

export function getRandomDate(): string {
  const today = new Date();

  const randomDate = new Date(today);

  randomDate.setDate(randomDate.getDate() + Math.floor(Math.random() * 1000) + 1);

  let month = (randomDate.getMonth() + 1).toString();
  let date = randomDate.getDate().toString();

  if (month.length < 2) {
    month = '0' + month;
  }

  if (date.toString().length < 2) {
    date = '0' + date;
  }

  return randomDate.getFullYear() + '-' + month + '-' + date;
}

export function getTimestampStr() {
  return moment().format('YY/MM/DD HH:mm');
}

export function getP2PShortTodayStr(): string {
  return moment().format('YY/MM/DD');
}

export function getTimestampInPlainString() {
  return moment().format('YYMMDDHHmmss');
}

export function convertTimestampStrToDate(timestmpStr) {
  return moment(timestmpStr, 'YY/MM/DD HH:mm');
}

export function timestampStrDiffWithinSeconds(first, second, maxDiffSeconds) {
  return (
    Math.abs(this.convertTimestampStrToDate(first) - this.convertTimestampStrToDate(second)) <= maxDiffSeconds * 1000
  );
}
