// https://github.com/cucumber/cucumber-expressions/blob/main/README.md

import { defineParameterType } from '@cucumber/cucumber';

defineParameterType({
  name: 'role',
  useForSnippets: false,
  regexp: /maker|checker|approver|makerChecker|checkerApprover|admin1|admin2/,
  transformer: function (s) {
    return s;
  }
});

defineParameterType({
  name: 'party',
  useForSnippets: true,
  regexp:
    /applicant|beneficiary|issuingBank|confirmingBank|newConfirmingBank|advisingBank|newAdvisingBank|nominatedBank/,
  transformer: function (s) {
    return s;
  }
});

defineParameterType({
  name: 'scenario',
  useForSnippets: true,
  regexp: /sc1|sc2|sc2split|sc3split|sc4|sc5|sc6|sc8|sc10|sc11|sc12/,
  transformer: function (s) {
    return s;
  }
});

defineParameterType({
  name: 'boolean',
  regexp: /true|false/,
  transformer: (s) => (s === 'true' ? true : false)
});
