@Regression
Feature: Test Login E2E workflow
    As a user, I want to test the login, forgot/reset password functionality

    @Login @ForgotPassword @ResetPassword
    Scenario: Verify user is able to login, submit the forgot password form successfully and also reset the password
        Given I setup test scenario context
        And a new user is setup in default applicant's node, with maker role
        And I login to default applicant's node as user in scenario context
        Then user is redirected to home page
        And I expect the viewport to match reference "login/homePage" while hiding elements "dcListing"."tableBodyRows|pagination"
        When I select logout from user menu
        Then user is redirected to login page
        And I expect the viewport to match reference "login/loginPage"

        When I click on the link "login"."forgotPasswordLink"
        Then user is redirected to forgot password page
        And I expect the viewport to match reference "login/forgotPassword/mainPage"
        When I submit the forgot password form with user email in current context
        And I expect the viewport to match reference "login/forgotPassword/successPage"

        When I load reset password page with valid token
        And I expect the viewport to match reference "login/resetPassword/mainPage"
        And I submit the reset password form with password "Password@!321" and confirm password "Password@!321"
        And I expect the viewport to match reference "login/resetPassword/successPage"

        When I click on the link "resetPassword"."contourAppLink"
        Then user is redirected to login page
        And I login to default applicant's node as user in scenario context
        Then user is redirected to home page
        And I pause for 3000ms
        And I expect the viewport to match reference "login/homePage" while hiding elements "dcListing"."tableBodyRows|pagination"
