Feature: Test loginBNO Feature
    As a user, I want to test the loginBNO functionality

    Background: Setup scenario
        Given I open loginBNO page
 
    Scenario: Check element of BNO login page
        Then I expect that element "loginBNO"."emailInput" is not focused
        And the element "loginBNO"."emailLabel" matches the text "EMAIL"
        Then the attribute "type" from element "loginBNO"."emailInput" is "text"
        And the element "loginBNO"."passwordLabel" matches the text "PASSWORD"
        Then the attribute "type" from element "loginBNO"."passwordInput" is "password"
    
    Scenario Outline: Check for invalid login scenarios
        When I set "<Email>" to the inputfield "loginBNO"."emailInput"
        And I set "<Password>" to the inputfield "loginBNO"."passwordInput" 
        And I click on the button "loginBNO"."loginBtn"
        And the element "loginBNO"."errorMsg" matches the text "<ErrorMessage>"
        When I clear the inputfield "loginBNO"."emailInput"
        When I clear the inputfield "loginBNO"."passwordInput"
        Examples:
            | Email         | Password      | ErrorMessage                                |
            |               |               | Email and password cannot be empty          |
            |  admin        | password      | Your email or password is invalid           |
            |  admin        |               | Email and password cannot be empty          |
            |               | password      | Email and password cannot be empty          |
        
    Scenario: Check for successful login
        When I set "admin@bno.contour" to the inputfield "loginBNO"."emailInput"
        And I set "password" to the inputfield "loginBNO"."passwordInput" 
        And I click on the button "loginBNO"."loginBtn"
        And I click on the button "loginBNO"."userAvatar"
        Then the element "loginBNO"."logoutBtn" is displayed


    
   