Feature: Test metering feature
    As a user, I want to test the metering component

 Background: I go to the metering page
    Given I login to bno page successfully
    When I click on the button "metering"."meteringSubtab"
    Then I pause for 5000ms


 Scenario: I'm in the metering page and check element of the metering 
    Then I expect the element "metering"."meteringCardHeader" to match reference "BNO/metering/CardUIPage/meteringCardHeader"
    Then I expect the element "metering"."meteringContent" to match reference "BNO/metering/CardUIPage/meteringContent"
    Then I expect the element "metering"."resultCardHeader" to match reference "BNO/metering/CardUIPage/resultCardHeader"
    When I scroll to element "metering"."resultContent"
    Then I expect the element "metering"."resultContent" to match reference "BNO/metering/CardUIPage/resultContent"
    Then I expect the element "metering"."resultPaging" to match reference "BNO/metering/CardUIPage/resultPaging"
    Then the attribute "type" from element "metering"."startDateInput" is "text"
    Then the attribute "type" from element "metering"."endDateInput" is "text"
    Then I expect that element "metering"."submitBtn" is not enabled
    Then I expect that element "metering"."refreshBtn" is enabled
    

Scenario: Check element display when do action
    When I click on the button "metering"."nodeSelect"
    Then I expect that element "metering"."nodeListSelect" is enabled
    When I scroll to element "metering"."meteringCardHeader"
    Then I click on the element "metering"."messageHeader"
    Then I expect that element "metering"."nodeListSelect" is not displayed
    When I click on the button "metering"."startDateInput"
    Then I expect that element "metering"."datePicker" is enabled
    When I scroll to element "metering"."meteringCardHeader"
    When I click on the element "metering"."messageHeader"
    Then I expect that element "metering"."datePicker" is not displayed 
    Then I click on the button "metering"."endDateInput"
    And I expect that element "metering"."datePicker" is enabled
    When I click on the element "metering"."messageHeader"
    Then I expect that element "metering"."datePicker" is not displayed


Scenario: Check enable and disable button
    When I pick "All" to the BNOSelect "metering"."nodeSelect"
    Then I expect that element "metering"."submitBtn" is not enabled
    When I set "01/03/2021" to the inputfield "metering"."startDateInput"
    Then I click on the element "metering"."messageHeader"
    And I expect that element "metering"."submitBtn" is not enabled
    When I set "04/03/2021" to the inputfield "metering"."endDateInput"
    Then I click on the element "metering"."messageHeader"
    And I expect that element "metering"."submitBtn" is enabled


Scenario Outline: Check result metering collection after running
    When I pick "<node>" to the BNOSelect "metering"."nodeSelect"
    When I set "<startDate>" to the inputfield "metering"."startDateInput"
    When I set "<endDate>" to the inputfield "metering"."endDateInput"
    And I expect that element "metering"."submitBtn" is enabled
    When I click on the button "metering"."submitBtn"
    When I pause for 2000ms
    Then I expect that element "metering"."messageSubmit" is enabled
    And the element "metering"."messageSubmit" matches the text "Submitted successfully"
    When I pause for 120000ms
    Then I click on the button "metering"."refreshBtn"
    When I scroll to element "metering"."resultContent"
    Then I expect the element "metering"."resultContent" to match reference "<VRRef>"
    Examples:
       |node|        | startDate     | endDate       | VRRef                            |
       |All |        | 01/01/2021    | 31/01/2021    | BNO/metering/credential/Image1   |
       |Bank A |     | 01/02/2021    | 28/02/2021    | BNO/metering/credential/Image2   |
       |Corp B |     | 28/02/2021    | 01/03/2021    | BNO/metering/credential/Image3   |
       |Bank E |     | 01/03/2021    | 02/03/2021    | BNO/metering/credential/Image4   |
       |Corp D |     | 02/03/2021    | 02/03/2021    | BNO/metering/credential/Image5   |


Scenario: Check paging of metering result
    When I scroll to element "metering"."resultPaging" 
    Then I expect that element "metering"."downPaginate" is not enabled
    When I click on the button "metering"."upPaginate"
    And I expect the element "metering"."resultContent" to match reference "BNO/metering/paginate/upPaginate"
    And I expect that element "metering"."downPaginate" is enabled
    When I click on the button "metering"."downPaginate"
    Then I scroll to element "metering"."resultPaging" 
    Then I expect the element "metering"."resultContent" to match reference "BNO/metering/paginate/downPaginate"

