Feature: View Nodes
    As a BNO user,
    I want to view all nodes,
    So that I am able to have an overview of all nodes on Contour network   


 Scenario: Check user is able to view Nodes tab and UI after login
    Given I login to bno page successfully
    Then the page url contain "/nodes"
    Then the element "bnoNodes"."nodesHeaderText" is displayed

 Scenario: Check fields are displayed according to the design
    Then the element "bnoNodes"."nodesContainer" is displayed
    Then the attribute "placeholder" from element "bnoNodes"."nodeSearchInput" is "Search by node name"

 Scenario Outline: Check user is able to search by node name and unique special chars
    Then I set "<searchtext>" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I press the enter key    
    Then <count> nodes displayed in the search results
    Then I click on the element "bnoNavBar"."identitiesTab"
    Then I click on the element "bnoNavBar"."nodesTab"
    Examples:
    |searchtext | count |
    | Corp A    | 1     |
    | Corp      | 5     |
    | Bank B    | 1     |
    | C         | 7     |
    |           | 12    |
    |,          | 2     |
    |=          | 2     |
    |-          | 2     |
 


Scenario Outline: Check results when search input is invalid node name/special chars
    Then I set "<searchtext>" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I press the enter key
    Then the element "bnoNodes"."noNodesAvailable" is displayed
    Then I click on the element "bnoNavBar"."identitiesTab"
    Then I click on the element "bnoNavBar"."nodesTab"
    Examples:
    |searchtext  |
    | invalidname|  

#| #          | <- Uncomment this when VTX-6403 is completed to check for invalid special chars
#Scenario : Check results are displayed in ascending order sorted by node name
  #To be done when VTX-6386 is completed

 Scenario Outline: Check results can be filtered by version number
    When I pick <version> to the contourSelect "bnoNodes"."versionSelector"
    Then <count> nodes displayed in the search results
    Then I click on the element "bnoNavBar"."identitiesTab"
    Then I click on the element "bnoNavBar"."nodesTab"
    Examples:
    | version | count |
    | "7.0.0" | 2     |
    | "6.1.0" | 2     |
    | "8.0.0" | 8     |


Scenario: Check filtered results can be cleared
    When I pick "7.0.0" to the contourSelect "bnoNodes"."versionSelector"
    Then 2 nodes displayed in the search results
    Then I click on the element "bnoNodes"."versionSelector"
    Then I click on the element "bnoNodes"."clearSelected"
    Then 12 nodes displayed in the search results
   

Scenario: Check Refresh Button reflects latest search results
    Then I set "<searchtext>" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I click on the element "bnoNodes"."refreshList" 
    Then <count> nodes displayed in the search results
    Then I click on the element "bnoNavBar"."identitiesTab"
    Then I click on the element "bnoNavBar"."nodesTab"
    Examples:
    |searchtext | count |
    | Corp A    | 1     |
    | Corp      | 5     |
    | Bank B    | 1     |
   


Scenario Outline: Check 'Add Identity Button' display
    Then I set "<searchtext>" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I press the enter key
    Then Add Identity button <action> in row 1
    Then I click on the element "bnoNavBar"."identitiesTab"
    Then I click on the element "bnoNavBar"."nodesTab"
    Examples:
    |searchtext | action            |
    | Corp A    | is displayed      |
    | Corp C    | is not displayed  |
    | Corp D    | is not displayed  |



Scenario: Check navigation for 'Add Identity Button' and node name
    Then I set "Corp A" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I press the enter key
    Then I click on Add Identity button in row 1
    Then the element "identity"."addIdentityTitle" is displayed
    Then the element "identity"."addIdentityDescription" contains the text "You are adding an identity under Corp A"
    Then I click on the element "identity"."closeButton"
    Then I set "Corp A" to the inputfield "bnoNodes"."nodeSearchInput" 
    Then I press the enter key
    Then I click on node name in row 1
    Then the element "bnoNodes"."createIdentityButton" is displayed
  

   