@DCAmendment
Feature: DC Amendment E2E sc11

    @Test
    Scenario: Applicant can amend DC and send to beneficiary
        Given I setup test scenario context
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        And I click on the button "actionButton"."amendButton"
        And I fill in dc for scenario sc11 with following values
            | Applicant Address           | Updated |
            | Beneficiary Address         | Updated |
            | Issuing Bank Address        | Updated |
            | Advising Bank Address       | Updated |
            | Confirming Bank Address     | Updated |
            | Available With Bank Address | Updated |

            | Available By Payment At Sight | Check |

            | Form Of Documentary Credit         | Irrevocable |
            | Applicable Rules                   | Other       |
            | Description of Applicable Rules    | Updated     |
            | Amount                             | 20 000.00   |
            | Max Tolerance (Optional)           | 30.00       |
            | Min Tolerance (Optional)           | 30.00       |
            | Additional Amount Covered (Option) | Updated     |
            | Expiry Date (YY/MM/DD)             | 2025-01-01  |
            | Expiry Place                       | Updated     |

            | Partial Shipments (optional)         | Not allowed     |
            | Transhipment (optional)              | Conditional     |
            | Shipment Date / Period               | Shipment period |
            | Latest Date Of Shipment              | 2022-01-01      |
            | Description Of Goods And/Or Services | Updated         |

            | Shipment Period                                                                   | 20      |
            | Period Of Presentation                                                            | 321     |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Updated |
            | Port Of Loading / Airport Of Departure (optional)                                 | Updated |
            | Port Of Discharge / Airport Of Destination (optional)                             | Updated |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Updated |

        And I click on the button "actionButton"."sendToBeneficiaryButton" and submit
        And applicant's checker login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And applicant's approver login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/applicant"
        And I click on the button "actionButton"."approveButton" and confirm

    @Test
    Scenario: Beneficiary can accept amend DC
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."endorseButton" and submit
        And beneficiary's checker login to main page for scenario sc11
        And beneficiary navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's approver login to main page for scenario sc1
        And beneficiary navigate to current draft text 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/beneficiary"
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Applicant can amend DC and send to beneficiary
        When applicant's maker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."editButton"
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And applicant's approver login to main page for scenario sc1
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/applicant2"
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Issuing bank issue DC
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."issueButton"
        And I click on the button "actionButton"."submitButton"
        And I expect that element "actionButton"."submitButton" does not exist
        And issuingBank's checker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And issuingBank's approver login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/issuingBank"
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Confirm bank confirm DC
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."adviseWithoutConfirmationButton"
        And I click on the button "actionButton"."submitButton"
        And I expect that element "actionButton"."submitButton" does not exist
        And confirmingBank's checker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And confirmingBank's approver login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I can see the dc form for amendment/e2e/sc11/confirmBank
        Then I expect the document to match reference "amendment/e2e/sc11/confirmBank"
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Nominated bank confirm DC
        When nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."adviseButton"
        And I click on the button "actionButton"."submitButton"
        And I expect that element "actionButton"."submitButton" does not exist
        And nominatedBank's checker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's approver login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/nominatedBank"
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Advising bank advise DC
        When advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."adviseButton"
        And I click on the button "actionButton"."submitButton"
        And I expect that element "actionButton"."submitButton" does not exist
        And advisingBank's checker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And advisingBank's approver login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/contour"
        And I click on the button "actionButton"."approveButton" and confirm


    Scenario: Applicant re-verify
        When applicant's maker login to main page for scenario sc11
        When applicant navigate to current amendment 1 using contour uuid
        Then I expect the document to match reference "amendment/e2e/sc11/final"
