Feature: Amendment audit log

    As QA,
    I want to check for amendment audit log

    Background: Set up scenario context
        Given I setup test scenario context

    Scenario Outline: Audit Log for draft text (send to beneficiary)
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the audit log as follow for scenario sc11
            | <Audit Log Party> | Draft text | <Audit Log Text> |

        Examples:
            | Initiate Party | Next Party  | Audit Log Party | Audit Log Text      |
            | applicant      | beneficiary | #APPLICANT#     | Sent to beneficiary |
            | beneficiary    | applicant   | #BENEFICIARY#   | Sent to applicant   |

    Scenario: Beneficiary can review audit log
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        Then I expect the audit log as follow for scenario sc11
            | #ADVISING_BANK#   | Amended             | Advised                   |
            | #NOMINATED_BANK#  | Amended             | Advised                   |
            | #CONFIRMING_BANK# | Amended             | Advised with confirmation |
            | #ISSUING_BANK#    | Amended             | Issued                    |
            | #APPLICANT#       | Amendment requested | Submitted to issuing bank |

    Scenario: After beneficiary accept, correct audit log will be displayed
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        Then I expect the audit log as follow for scenario sc11
            | #BENEFICIARY#     | Amended             | Accepted                  |
            | #ADVISING_BANK#   | Amended             | Advised                   |
            | #NOMINATED_BANK#  | Amended             | Advised                   |
            | #CONFIRMING_BANK# | Amended             | Advised with confirmation |
            | #ISSUING_BANK#    | Amended             | Issued                    |
            | #APPLICANT#       | Amendment requested | Submitted to issuing bank |

    Scenario: Confirming bank can see audit log
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the audit log as follow for scenario sc11
            | #ISSUING_BANK# | Amended | Issued |

    Scenario: Nominated bank can see audit log
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the audit log as follow for scenario sc11
            | #CONFIRMING_BANK# | Amended | Advised with confirmation |
            | #ISSUING_BANK#    | Amended | Issued                    |

    Scenario: Advising bank review amendment - Audit log
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the audit log as follow for scenario sc11
            | #NOMINATED_BANK#  | Amended | Advised                   |
            | #CONFIRMING_BANK# | Amended | Advised with confirmation |
            | #ISSUING_BANK#    | Amended | Issued                    |

    Scenario: Nominated bank can see audit log after confirming bank rejected amendment
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the audit log as follow for scenario sc11
            | #CONFIRMING_BANK# | Amended | Rejected |
            | #ISSUING_BANK#    | Amended | Issued   |


    Scenario: Advising bank can see audit log after nominated bank reject
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
        And advisingBank's maker login to main page for scenario sc11
        When advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the audit log as follow for scenario sc11
            | #NOMINATED_BANK#  | Amended | Rejected |
            | #CONFIRMING_BANK# | Amended | Rejected |
            | #ISSUING_BANK#    | Amended | Issued   |