@DCAmendment
@VTX-1881
Feature: Amendment draft

    As QA,
    I would like to check for amendment draft
    so that user can see expected action buttons and icons for draft

    Background: Set up scenario context
        Given I setup test scenario context

    @AMD-DraftText-1
    Scenario: Can see 3 button (send to beneficiary)
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "admin1"
        And beneficiary's maker login to main page for scenario sc11
        When beneficiary navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."endorseButton" is displayed
        And I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."returnButton" is displayed

    @AMD-DraftText-2
    Scenario: Can see 3 button (send to applicant)
        Given beneficiary created amendment for scenario sc11 submit to applicant proceeded by "admin1"
        And applicant's maker login to main page for scenario sc11
        When applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."returnButton" is displayed

    @AMD-DraftText-3
    Scenario: Can see 3 button (after beneficiary edited and returned)
        Given beneficiary edited and returned amendment for scenario sc11 proceeded by "admin1"
        And applicant's maker login to main page for scenario sc11
        When applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @AMD-DraftText-4
    Scenario: Can see 3 button (after applicant edited and returned)
        Given applicant edited and returned amendment for scenario sc11 proceeded by "admin1"
        And beneficiary's maker login to main page for scenario sc11
        When beneficiary navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."endorseButton" is displayed
        And I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @AMD-DraftText-5
    Scenario: DC Form: can see Amend button and can click to start Amendment
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
      

    @AMD-DraftText-6
    Scenario: DC form: can see “Hint: Request amendment under this DC.”
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_requestAmendment"

    @AMD-DraftText-7
    Scenario: Cannot amend the following fields
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        Then the element "dcForm"."applicant" is not enabled
        And the element "dcForm"."beneficiary" is not enabled
        And I expect that element "dcForm"."issuingBank" does have the class "is-disabled"
        And the element "dcForm"."issuedDcRefenceInput" is not enabled
        And the element "dcForm"."advisedDcReferenceInput" is not enabled
        And the element "dcForm"."confirmedDcReferenceInput" is not enabled
        And the element "dcForm"."nominatedDcReferenceInput" is not enabled
        And the element "dcForm"."waiverCheckBox" is not displayed
        And the element "dcForm"."applicationDate" is not enabled
        And I expect that element "dcForm"."amountCurrency" does have the class "is-disabled"
        And the element "dcForm"."issuedDate" is not enabled

    @AMD-DraftText-8
    Scenario: Can see 3 buttons
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        Then I expect that element "actionButton"."sendToBeneficiaryButton" is displayed
        And I expect that element "actionButton"."submitToIssuingBankButton" is displayed
        And I expect that element "actionButton"."resetButton" is displayed

    @AMD-DraftText-9
    Scenario Outline: Amendment hint (after beneficiary / applicant maker edit and return)
        Given <Current Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And <Current Party>'s <Login Role> login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        When I click sub side menu option "Amendments"
        And I click sub side menu sub-option "Draft Text 1"
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_<baseline>EditAmendment"
        Examples:
            | Current Party | Proceeded Role | Login Role | baseline        |
            | beneficiary   | maker          | checker    | beneMaker       |
            | beneficiary   | maker.checker  | approver   | beneChecker     |
            | applicant     | maker.checker  | approver   | applicantChecker|

    @AMD-DraftText-10
    Scenario Outline: Amendment hint (after beneficiary / applicant checker / approver reject)
        Given <Current Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Roles>"
        And <Current Party>'s <Reject Role> login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        And I click on the button "actionButton"."rejectButton" and confirm
        And <Current Party>'s maker login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_<baseline>ReturnAmendment"

        Examples:
            | Current Party | Proceeded Roles | Reject Role | baseline         |
            | beneficiary   | maker           | checker     | beneMaker        |
            | beneficiary   | maker.checker   | approver    | beneChecker      |
            | applicant     | maker.checker   | approver    | applicantChecker |

    @AMD-DraftText-11
    Scenario Outline: Amendment hint (before beneficiary / applicant action)
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Initiate Party | Next Party  | Reference                                   |
            | applicant      | beneficiary | amendment/hint_beneficiaryMakerBeforeAction |
            | beneficiary    | applicant   | amendment/hint_applicantMakerBeforeAction   |

    @AMD-DraftText-12
    Scenario: Can Reset
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                           | Updated |
            | Beneficiary                                 |         |
            | Beneficiary Address                         | Updated |
            | Issuing Bank                                |         |
            | Issuing Bank Address                        | Updated |
            | Allow Issuing Bank To Make Changes Directly |         |
            | Advising Bank                               |         |
            | Advising Bank Address                       | Updated |
            | Confirmation Instructions                   |         |
            | Confirming Bank                             |         |
            | Confirming Bank Address                     | Updated |
            | Available With Bank                         |         |
            | Available With Bank Address                 | Updated |

            | Available By                                 | Payment at sight |
            | Negotiation / Deferred Payment Details       |                  |
            | Drafts At                                    |                  |
            | Drawee Bank                                  |                  |
            | Drawee Bank Address                          |                  |
            | Check Negotiation / Deferred Payment Details |                  |
            | Check Draft At                               |                  |

            | Application Date                     | #TODAY_DATE#        |
            | Form Of Documentary Credit           | Irrevocable         |
            | Applicable Rules                     | eUCP latest version |
            | Selected Currency                    |                     |
            | Amount                               | 20 000.00           |
            | Max Tolerance (Optional)             | 30.00               |
            | Min Tolerance (Optional)             | 30.00               |
            | Additional Amount Covered (Option)   | Updated             |
            | Description Of Goods And/Or Services | Updated             |
            | Expiry Date (YY/MM/DD)               | #RANDOM_DATE#       |
            | Expiry Place                         | Updated             |

            | Partial Shipments (optional) | Not allowed |
            | Transhipment (optional)      | Conditional |

            | Shipment Date / Period  | Shipment period |
            | Latest Date Of Shipment |                 |

            | Shipment Period | 20 |

            | Period Of Presentation                                                            | 321     |
            | Type Of Presentation                                                              | Updated |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Updated |
            | Port Of Loading / Airport Of Departure (optional)                                 | Updated |
            | Port Of Discharge / Airport Of Destination (optional)                             | Updated |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Updated |
        And I click on the button "actionButton"."resetButton"
        And I accept the prompt
        

    @AMD-DraftText-13
    Scenario: Checker / Approver can see amendment hint
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "maker"
        And applicant's checker login to main page for scenario sc11
        And applicant navigate to current amendment draft using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_makerReviewAmendmentDraft"

    @AMD-DraftText-14
    Scenario: Review Draft 1 (DC Form column): Applicant can see all parties actions
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "admin1"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I can see the following dc form action on amendment draft text with following values
            | Corp A requested |

    # @VTX-1993
    # Scenario Outline: Review Draft 1 (DC Form column): can see all parties actions
    #     Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
    #     And <Next Party>'s maker login to main page for scenario sc11
    #     When <Next Party> navigate to current draft text 1 using contour uuid
    #     Then I can see the following dc form action on amendment draft text with following values
    #         | Comprehensive Fabric submitted              |
    #         | Good Design Co. Ltd. endorsed               |
    #         | Asia Best Bank issued                       |
    #         | Thorn Valley Bank advised with confirmation |
    #         | StarFerry Bank advised                      |
    #         | Mid-Atlantic Bank advised                   |

    #     Examples:
    #         | Initiate Party | Next Party  |
    #         | applicant      | beneficiary |
    #         | beneficiary    | applicant   |


    @VTX-1993
    @VTX-1988
    @AMD-DraftText-15
    Scenario Outline: Review Draft 1 (Draft 1 column): can see all parties actions
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I can see the following draft text action on amendment draft text with following values
            | <Text> |

        Examples:
            | Initiate Party | Next Party  | Text                           |
            | applicant      | beneficiary | Corp A requested               |
            | beneficiary    | applicant   | Corp B requested               |


    @VTX-1993
    @VTX-3237
    @AMD-DraftText-16
    Scenario: Review Draft 1 (Draft 1 column): can see all parties actions after beneficiary edited and returned and applicant sent to issuing bank
        Given beneficiary edited and returned amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's admin1 login to main page for scenario sc11
        When applicant navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."editButton"
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I can see the following draft text action on amendment draft text with following values
            | Corp A requested |

    @AMD-DraftText-17
    Scenario: Review Draft 1 (DC Form column): Checkerapprover can see all parties actions
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "admin1"
        And applicant's checkerApprover login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I can see the following dc form action on amendment draft text with following values
            | Corp A requested|

    # @VTX-1993
    # Scenario: Issuing Bank can see DC action
    #     Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
    #     And issuingBank's maker login to main page for scenario sc11
    #     And issuingBank navigate to current draft text 1 using contour uuid
    #     Then I can see the following dc form action on amendment draft text with following values
    #         | Comprehensive Fabric submitted              |
    #         | Good Design Co. Ltd. endorsed               |
    #         | Asia Best Bank issued                       |
    #         | Thorn Valley Bank advised with confirmation |
    #         | StarFerry Bank advised                      |
    #         | Mid-Atlantic Bank advised                   |

    @VTX-1993
    @AMD-DraftText-18
    Scenario: Issuing bank can see draft text action
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        And issuingBank's maker login to main page for scenario sc11
        When issuingBank navigate to current draft text 1 using contour uuid
        Then I can see the following draft text action on amendment draft text with following values
            | Corp A submitted |

    @AMD-DraftText-19
    Scenario: Review Draft 1: Can see two buttons: Issue and Return
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."issueButton" is displayed
        And I expect that element "actionButton"."returnButton" is displayed
