@DCAmendment
@VTX-3025
Feature: Highlight Field Changes

    As QA,
    I want to check for highlight field changes
    so that I can know whether the highlight fields meet following requirement

    Background: Set up scenario context
        Given I setup test scenario context

    @Retest-HF-1
    Scenario: Can amend the following input text fields:
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And I pause for 3000ms
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I set the following value into following contourSelect in page "dcForm"
            | shipmentDate | Shipment period |
        And I set the following value into following inputfield in page "dcForm"
            | applicantAddressInput                    | Updated |
            | beneficiaryAddressInput                  | Updated |
            | issuingBankAddress                       | Updated |
            | confirmingBankAddress                    | Updated |
            | nominatedBankAddressInput                | Updated |
            | expiryPlaceInput                         | Updated |
            | descriptionOfGoodsAndServicesInput       | Updated |
            | placeOfTakingInChargeInput               | Updated |
            | portOfLoadingInput                       | Updated |
            | portOfDischargeInput                     | Updated |
            | placeOfFinalDestinationInput             | Updated |
            | additionalAmountCoveredInput             | Updated |
            | typeOfPresentationInput                  | Updated |
            | detailsOfChargesInput                    | Updated |
            | additionalConditionsFromIssuingBankInput | Updated |
            | additionalConditionsInput                | Updated |
            | periodOfPresentationInput                | 122     |
            | shipmentPeriodInput                      | 5       |
        Then I expect the following contourAlert to match following reference on page "dcForm"
            | applicantAddressInput                    | amendment/applicantAddressInputAlert                    |
            | beneficiaryAddressInput                  | amendment/beneficiaryAddressInputAlert                  |
            | issuingBankAddress                       | amendment/issuingBankAddressInputAlert                  |
            | confirmingBankAddress                    | amendment/confirmingBankAddressInputAlert               |
            | nominatedBankAddressInput                | amendment/nominatedBankAddressInputAlert                |
            | expiryPlaceInput                         | amendment/expiryPlaceInputAlert                         |
            | descriptionOfGoodsAndServicesInput       | amendment/descriptionOfGoodsAndServicesInputAlert       |
            | placeOfTakingInChargeInput               | amendment/placeOfTakingInChargeInputAlert               |
            | portOfLoadingInput                       | amendment/portOfLoadingInputAlert                       |
            | portOfDischargeInput                     | amendment/portOfDischargeInputAlert                     |
            | placeOfFinalDestinationInput             | amendment/placeOfFinalDestinationInputAlert             |
            | additionalAmountCoveredInput             | amendment/additionalAmountCoveredInputAlert             |
            | typeOfPresentationInput                  | amendment/typeOfPresentationInputAlert                  |
            | detailsOfChargesInput                    | amendment/detailsOfChargesInputAlert                    |
            | additionalConditionsFromIssuingBankInput | amendment/additionalConditionsFromIssuingBankInputAlert |
            | additionalConditionsInput                | amendment/additionalConditionsInputAlert                |
            | periodOfPresentationInput                | amendment/periodOfPresentationInputAlert                |
            | shipmentPeriodInput                      | amendment/shipmentPeriodInputAlert                      |

    @Retest-HF-2
    Scenario: Can amend the following fields (numbericInput)
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I set the following value into following contourNumbericInput in page "dcForm"
            | amountInput       | 20000.00 |
            | maxTolerenceInput | 30.00    |
            | minTolerenceInput | 30.00    |
        Then I expect the following contourAlert to match following reference on page "dcForm"
            | amountContainer    | amendment/amountInputAlert       |
            | toleranceContainer | amendment/maxTolerenceInputAlert |
            | toleranceContainer | amendment/minToleranceInputAlert |

    @Retest-HF-3
    Scenario: Can amend the following fields (selection)
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I set the following value into following contourSelect in page "dcForm"
            | applicableRules  | UCP latest version |
            | partialShipments | Not allowed        |
            | transhipment     | Conditional        |
            | shipmentDate     | Shipment period    |
        Then I expect the following contourAlert to match following reference on page "dcForm"
            | applicableRules  | amendment/applicableRulesAlert  |
            | partialShipments | amendment/partialShipmentsAlert |
            | transhipment     | amendment/transhipmentAlert     |
            | shipmentDate     | amendment/shipmentDateAlert     |

    @Retest-HF-4
    Scenario: Applicant can see remove button for amendment
        Given advisingBank advised dc for scenario sc11 with 2 attachments proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        Then I can see the following attachment and remove button with following values
            | pdfDc1.pdf | DISPLAYED |
            | pdfDc2.pdf | DISPLAYED |

    Scenario: Applicant can see alert when remove attachment
        Given advisingBank advised dc for scenario sc11 with 2 attachments proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I remove 2 row of attachment
        And I scroll to element "dcForm"."attachmentContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."attachmentContainer" to match reference "amendment/removeAttachmentAlert"

    @Retest-HF-5
    Scenario: Applicant can see alert when add attachment
        Given advisingBank advised dc for scenario sc11 with 2 attachments proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I upload "test/support/pdf/pdfAmendment1.pdf" to contourFileUpload "dcForm"."attachmentUpload"
        And I scroll to element "dcForm"."attachmentRow3"
        And I pause for 2500ms
        Then I expect the following contourAlert to match following reference on page "dcForm"
            | attachmentRow3 | amendment/newAttachment |