@DCAmendment
Feature: Amendment Hint

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1993
    @VTX-1988
    @AMD-Hint-1
    Scenario Outline: Review Draft 1: can see hint “Review the draft amendment text sent by Applicant/Beneficiary.”
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Initiate Party | Next Party  | Reference                                            |
            | applicant      | beneficiary | amendment/hint_reviewDraftTextSubmittedByApplicant   |
            | beneficiary    | applicant   | amendment/hint_reviewDraftTextSubmittedByBeneficiary |
            | applicant      | issuingBank | amendment/hint_reviewDraftTextRequestedByApplicant   |


    @VTX-1993
    @VTX-3007
    @VTX-1988
    @AMD-Hint-2
    Scenario Outline: Checker-approver can see hint message when applicant/beneficiary submit to beneficiary / applicant
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "maker"
        And <Initiate Party>'s checkerApprover login to main page for scenario sc11
        And <Initiate Party> navigate to current dc using contour uuid
        Then I open Draft 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Initiate Party | Next Party  | Reference                                            |
            | applicant      | beneficiary | amendment/hint_reviewDraftTextSubmittedToBeneficiary |
            | beneficiary    | applicant   | amendment/hint_reviewDraftTextSubmittedToApplicant   |

    @VTX-1993
    @VTX-3007
    @AMD-Hint-3
    Scenario Outline: Checker-approver can see hint message when submit to issuing bank
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "maker"
        And <Initiate Party>'s checkerApprover login to main page for scenario sc11
        And <Initiate Party> navigate to current dc using contour uuid
        Then I open Draft 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Initiate Party | Next Party  | Reference                                            |
            | applicant      | issuingBank | amendment/hint_reviewDraftTextSubmittedToIssuingBank |

    @Fail
    @VTX-2780
    @AMD-Hint-4
    Scenario Outline: Amendment hint (issuing bank checker / approver after issuing bank issue)
        Given issuingBank issued amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And issuingBank's <Login Role> login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentEditedBy<baseline>"

        Examples:
            | Proceeded Role | Login Role | baseline        |
            | maker          | checker    | IssMaker        |
            | maker.checker  | approver   | IssMakerChecker |

    @VTX-1992
    @VTX-1990
    @AMD-Hint-5
    Scenario Outline: Amendment hint (applicant / beneficiary maker / checker discard)
        Given <Action Party> discarded amendment after <Counter Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Action Party | Counter Party | Proceeded Role | Login Role | Reference                                                        |
            | applicant    | beneficiary   | maker          | checker    | amendment/hint_reviewAmendmentDiscardedByMaker                   |
            | applicant    | beneficiary   | maker.checker  | approver   | amendment/hint_reviewAmendmentDiscardedByMakerAndCheckerVerified |
            | beneficiary  | applicant     | maker          | checker    | amendment/hint_reviewAmendmentDiscardedByMaker                   |
            | beneficiary  | applicant     | maker.checker  | approver   | amendment/hint_reviewAmendmentDiscardedByMakerAndCheckerVerified |


    @VTX-1991
    @VTX-1989
    @AMD-Hint-6
    Scenario Outline: Amendment hint (applicant / beneficiary's maker / checker rejected)
        Given <Action Party> rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect the element "hint"."hintMessage" to match reference "<Reference>"

        Examples:
            | Action Party | Proceeded Role | Login Role | Reference                                                             |
            | applicant    | maker          | checker    | amendment/hint_reviewAmendmentRejectedByMaker                         |
            | applicant    | maker.checker  | approver   | amendment/hint_reviewAmendmentRejectedByMakerAndVerifiedByChecker     |
            | beneficiary  | maker          | checker    | amendment/hint_reviewAmendmentRejectedByBeneMaker                     |
            | beneficiary  | maker.checker  | approver   | amendment/hint_reviewAmendmentRejectedByMakerAndVerifiedByBeneChecker |

    @VTX-1993
    @AMD-Hint-7
    Scenario: Amendment hint (before issuing bank action)
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        And issuingBank's maker login to main page for scenario sc11
        When issuingBank navigate to current draft text 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_makerBeforeAction"

    @AMD-Hint-8
    Scenario Outline: Amendment hint ( after issuing bank checker / approver reject)
        Given issuingBank issued amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And issuingBank's <Login Role> login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        And I click on the button "actionButton"."declineButton" and confirm
        And issuingBank's maker login to main page for scenario sc11
        When issuingBank navigate to current draft text 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_checkerApproverReturnAmendment"

        Examples:
            | Proceeded Role | Login Role |
            | maker          | checker    |
            | maker.checker  | approver   |

    @VTX-1987
    @AMD-Hint-9
    Scenario: Amendment hint (after issuing bank return amendment)
        Given issuingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentReturnedByIssuingBank"


    @AMD-Hint-10
    Scenario: Beneficiary can see amendment hint
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentAdvisedByAdvisingBank"

    @AMD-Hint-11
    Scenario: Confirming bank can see amendment hint (confirming bank without performing action)
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentIssuedByIssuingBank"

    @AMD-Hint-12
    Scenario Outline: Confirming bank can see amendment hint (maker advised)
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "<Proceeded Roles>"
            |  |  |
        And confirmingBank's <Login Role> login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendment<baseline>advisedWithConfirmation"

        Examples:
            | Proceeded Roles | Login Role | baseline       |
            | maker           | checker    | Maker          |
            | maker.checker   | approver   | MakerChecker   |

    @AMD-Hint-13
    Scenario Outline: Confirming bank can see amendment hint (after checker / approver reject)
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "<Proceeded Roles>"
            |  |  |
        And confirmingBank's <Login Role> login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."rejectButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentReturnedByCheckerOrApprover"

        Examples:
            | Proceeded Roles | Login Role |
            | maker           | checker    |
            | maker.checker   | approver   |

    @AMD-Hint-14
    Scenario: Nominated bank can see hint Review amendment 1 advised with confirmation by requested confirmation party
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentIssuedByIssuingBank"

    @AMD-Hint-15
    Scenario: Advising bank review amendment 1 hint
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentIssuedByIssuingBank"

    @AMD-Hint-16
    Scenario Outline: Confirming bank amendment hint: checker / approver can see review amendment rejected hint
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
            |  |  |
        And confirmingBank's <Login Role> login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentRejected<baseline>"

        Examples:
            | Proceeded Role | Login Role | baseline    |
            | maker          | checker    | Maker       |
            | maker.checker  | approver   | MakerChecker|

    @AMD-Hint-17
    Scenario Outline: Confirming bank amendment hint: checker / approver can see review amendment rejected hint
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "<Proceeded Roles>"
            |  |  |
        And confirmingBank's <Login Role> login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."rejectButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewRejectedAmendmentReturnedByCheckerOrApprover"

        Examples:
            | Proceeded Roles | Login Role |
            | maker           | checker    |
            | maker.checker   | approver   |

    @AMD-Hint-18
    Scenario: Nominated bank hint message after confirming bank reject (before any action)
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        When nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentIssuedByIssuingBank"


    @AMD-Hint-19
    Scenario Outline: Nominated bank hint message after confirming bank reject (after maker proceed)
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
            | confirmingBank | rejected |
        And nominatedBank's <Action Role> login to main page for scenario sc11
        When nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentRejectedByNom<baseline>"

        Examples:
            | Proceeded Role | Action Role | baseline      |
            | maker          | checker     | Maker        |
            | maker.checker  | approver    | MakerChecker |

    @AMD-Hint-20
    Scenario Outline: Nominated bank hint message after confirming bank reject (after checker / approver reject)
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
            | confirmingBank | rejected |
        And nominatedBank's <Action Role> login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."rejectButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentReturnedByNomCheckerOrApprover"

        Examples:
            | Proceeded Role | Action Role |
            | maker          | checker     |
            | maker.checker  | approver    |

    @AMD-Hint-21
    Scenario: Advising bank hint message after confirming bank reject (before any action)
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentIssuedByIssuingBank"

    @AMD-Hint-22
    Scenario Outline: Advising bank hint message after confirming bank reject (after maker proceed)
        Given following bank performed following action for amendment and advisingBank rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
        And advisingBank's <Action Role> login to main page for scenario sc11
        When advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentRejectedByAdv<baseline>"

        Examples:
            | Proceeded Role | Action Role | baseline |
            | maker          | checker     | Maker    |
            | maker.checker  | approver    | Checker  |

    @AMD-Hint-23
    Scenario Outline: Advising bank hint message after confirming bank reject (after checker / approver reject)
        Given following bank performed following action for amendment and advisingBank rejected amendment for scenario sc11 proceeded by "<Proceeded Role>"
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
        And advisingBank's <Action Role> login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."rejectButton" and confirm
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "amendment/hint_reviewAmendmentReturnedByAdvCheckerOrApprover"

        Examples:
            | Proceeded Role | Action Role |
            | maker          | checker     |
            | maker.checker  | approver    |

