@DCAmendment
@reviewed-by-bic
@VTX-1882
Feature: Amendments: Update the list view to include amendment status (amendment text)

    As a user,
    I would like to view the status of any amendments on the list view of both Import and Export DC
    so that I know which party the amendment is with and if my company needs to take any call to action on the amendments.

    Background: Set up scenario context
        Given I setup test scenario context


    @AMD-ListView-AmendmentDetails-1
    Scenario Outline: Display expected status after bank advised / rejected amendment
        Given following bank performed following action for amendment and <Action Party> <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | <Previous Party 1> | <Previous Action 1> |
            | <Previous Party 2> | <Previous Action 2> |
        And <Login Party>'s maker login to main page for scenario sc11
        And <Login Party> navigate to dc listing page
        Then I can see the dc has amendment status "Amended"
        And I can see the dc has amendment sub status "Please review"

        Examples:
            | Action Party   | Action                    | Previous Party 1 | Previous Action 1         | Previous Party 2 | Previous Action 2 | Login Party   |
            | confirmingBank | advised with confirmation |                  |                           |                  |                   | nominatedBank |

    @AMD-ListView-AmendmentDetails-2
    Scenario Outline: Display expected status after beneficiary accept / reject amendment
        Given beneficiary <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        Then I reload the browser session
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to dc listing page
        Then I can see the dc has amendment status "<Status>"


        Examples:
            | Action   | Status             |
            | accepted | Amended            |
            | rejected | Amendment rejected |

    @AMD-ListView-AmendmentDetails-3
    @VTX-3442
    Scenario Outline: Display expected status after beneficiary rejected all amendments / accept one of the amendment
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Amendment 1 | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.<Amendment 1 Decision> |
            | Amendment 2 | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.<Amendment 2 Decision> |
        Then I reload the browser session
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to dc listing page
        Then I can see the dc has amendment status "<Status>"

        Examples:
            | Amendment 1 Decision | Amendment 2 Decision | Status      |
            | accepted             | accepted             | Amended (2) |
            | accepted             | rejected             | Amended (2) |
            | rejected             | accepted             | Amended (2) |
            | rejected             | rejected             | Amendment rejected (2) |

    @AMD-ListView-AmendmentDetails-4
    Scenario: Display expected status after some amendments not proceeded by beneficiary
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Amendment 1 | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2 | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised                      |
        Then I reload the browser session
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to dc listing page
        Then I can see the dc has amendment status "In progress (2)"


    @AMD-ListView-AmendmentDetails-5
    Scenario: Displayed expected status when bank changed
        Given following parties proceeded following amendment for scenario sc1 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | confirmingBank.bankc    |
            | Changed - Amendment 2 | availableWithBank.bankd |
            | Amendment 1           | issuingBank.issued      |
            | Amendment 2           | issuingBank.issued      |
        Then I reload the browser session
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to dc listing page
        Then I can see the dc has amendment status "Amended"
        And I can see the dc has amendment sub status "Please review"
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to dc listing page
        Then I can see the dc has amendment status "In progress (2)"
        And I can see the dc has amendment sub status "Please review"

