@DCAmendment
@reviewed-by-bic
@VTX-1882
Feature: Amendments: Update the list view to include amendment status (draft text)

    As a user,
    I would like to view the status of any amendments on the list view of both Import and Export DC
    so that I know which party the amendment is with and if my company needs to take any call to action on the amendments.

    Background: Set up scenario context
        Given I setup test scenario context



    @AMD-ListView-DraftText-1
    Scenario Outline: Display expected status in maker checker approver flow
        Given <Initiate Party> created amendment for scenario sc11 submit to <Submit to Party> proceeded by "<Proceeded Role>"
        And <Initiate Party>'s maker login to main page for scenario sc11
        When <Initiate Party> navigate to dc listing page
        Then I can see the dc has amendment status "<Status>"
        And I can see the dc has amendment sub status "<Sub-status>"

        Examples:
            | Initiate Party | Submit to Party | Proceeded Role | Status            | Sub-status              |
            | applicant      | beneficiary     | maker          | Draft in progress | Your Checker to review  |
            | applicant      | beneficiary     | maker.checker  | Draft in progress | Your Approver to review |
            | beneficiary    | applicant       | maker          | Draft in progress | Your Checker to review  |
            | beneficiary    | applicant       | maker.checker  | Draft in progress | Your Approver to review |


    @VTX-3037
    @AMD-ListView-DraftText-2
    Scenario Outline: Display expected status in maker checker approver flow (reject)
        Given <Initiate Party> created amendment for scenario sc11 submit to <Submit to Party> proceeded by "<Proceeded Role>"
        And <Initiate Party>'s <Login Role> login to main page for scenario sc11
        When <Initiate Party> navigate to current dc using contour uuid
        Then I open Draft 1
        And I click on the button "actionButton"."declineButton" and confirm
        Then I can see the dc has amendment status "<Status>"
        And I can see the dc has amendment sub status "<Sub-status>"

        Examples:
            | Initiate Party | Submit to Party | Proceeded Role | Login Role | Status            | Sub-status           |
            | applicant      | beneficiary     | maker          | checker    | Draft in progress | Your Maker to review |
            | applicant      | beneficiary     | maker.checker  | approver   | Draft in progress | Your Maker to review |
            | beneficiary    | applicant       | maker          | checker    | Draft in progress | Your Maker to review |
            | beneficiary    | applicant       | maker.checker  | approver   | Draft in progress | Your Maker to review |

    @Retest-DT-1
    @AMD-ListView-DraftText-3
    Scenario Outline: Display expected status after applicant sent to beneficiary / applicant
        Given <Initiate Party> created amendment for scenario sc11 submit to <Submit to Party> proceeded by "admin1"
        And <Submit to Party>'s maker login to main page for scenario sc11
        When <Submit to Party> navigate to dc listing page
        Then I can see the dc has amendment status "Draft text"
        And I can see the dc has amendment sub status "Please review"

        Examples:
            | Initiate Party | Submit to Party |
            | applicant      | beneficiary     |
            | beneficiary    | applicant       |

    @Retest-DT-2
    @AMD-ListView-DraftText-4
    Scenario Outline: Display expected status after beneficiary / applicant rejected / endorsed / edited
        Given <Action Party> <Action> amendment for scenario sc11 proceeded by "admin1"
        And <Counter Party>'s maker login to main page for scenario sc11
        And <Counter Party> navigate to dc listing page
        Then I can see the dc has amendment status "<Status>"
        And I can see the dc has amendment sub status "Please review"

        Examples:
            | Action Party | Counter Party | Action              | Status              |
            | applicant    | beneficiary   | edited and returned | Draft text edited   |
            | applicant    | beneficiary   | rejected            | Draft text returned |
            | beneficiary  | applicant     | edited and returned | Draft text edited   |
            | beneficiary  | applicant     | endorsed            | Draft text endorsed |
            | beneficiary  | applicant     | rejected            | Draft text returned |

    @VTX-1992
    @VTX-1990
    @AMD-ListView-DraftText-5
    Scenario Outline: Display expected status after beneficiary / applicant discarded
        Given <Action Party> discarded amendment after <Counter Party> edited and returned amendment for scenario sc11 proceeded by "admin1"
        And <Action Party>'s maker login to main page for scenario sc11
        And <Action Party> navigate to dc listing page
        Then I can see the dc has amendment status "Discarded"

        Examples:
            | Action Party | Counter Party |
            | applicant    | beneficiary   |
            | beneficiary  | applicant     |

    @AMD-ListView-DraftText-6
    Scenario: Display expected status after applicant submitted to issuing bank
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to dc listing page
        Then I can see the dc has amendment status "Amendment requested"
        And I can see the dc has amendment sub status "Please review"

    @VTX-1987
    @AMD-ListView-DraftText-7
    Scenario: Display expected status after issuing bank rejected amendment
        Given issuingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to dc listing page
        Then I can see the dc has amendment status "Amendment returned"
        And I can see the dc has amendment sub status "Please review"

