@VTX-2722
Feature: After amendment viewing Dc Form

    As QA,
    I would like to check whether amendment will update original DC
    so that user can create DP with the expected DC

    Background: Set up scenario context
        Given I setup test scenario context

    @AMD-OriginalDC-1
    Scenario: User can see updated DC after changing bank's address for amendment
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.Test1.beneficiaryAddress.Test2.issuerAddress.Test3.advisingBankAddress.Test4            |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
        | page   | element             | refImage                           |
        | dcForm | corporatesContainer | amendment/addressUpdate/corporates |
        | dcForm | banksContainer      | amendment/addressUpdate/banks      |

    @AMD-OriginalDC-2
    Scenario Outline: User can see updated DC after changing available by
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 |<Change>                                                                                                  |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
            | page   | element             | refImage                          |
            | dcForm | availableByContainer| amendment/availableBy/<Reference> |
        Examples:
            | Change                       | Reference       |
            | typeCredits.Payment as sight | sight           |   
            | typeCredits.Deferred payment | deferredPayment |   
            | typeCredits.Acceptance       | Acceptance      |   
            | typeCredits.Negotiation      | Negotiation     |                                                     
   
    @AMD-OriginalDC-3
    Scenario Outline: User can see updated DC after changing document source
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker.checkerApprover" with following document source
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | advisingBank                         | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
            | page   | element                  | refImage                                      |
            | dcForm | documentRequiredContainer| amendment/document_source_updated/<Reference> |
       

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Reference                           |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | dc_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | dc_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | dc_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | dc_updateOtherDocumentDescription   |

    @AMD-OriginalDC-4
    @Test
    Scenario Outline: User can see updated DC after changing attachment
        Given beneficiary accepted amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I scroll to element "dcForm"."attachmentsContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Original Attachment Number | New Attachment Number | Reference                                      |
            | 2                          | 2                     | amendment/dc_form/updatedDc_noChangeAttachment |

    @AMD-OriginalDC-5
    Scenario: User can see updated DC after changing bank's address for amendment (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.Test5.beneficiaryAddress.Test6.issuerAddress.Test7.advisingBankAddress.Test8            |
            | Changed - Amendment 2 | applicantAddress.Test1.beneficiaryAddress.Test2.issuerAddress.Test3.advisingBankAddress.Test4            |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        #Then I expect the document to match reference "amendment/dc_form/updatedAddressWithMultiAmend" while hiding element "dcForm"."applicationDate"
        Then I can see the page as following screenshots
        | page   | element             | refImage                           |
        | dcForm | corporatesContainer | amendment/addressUpdate/corporates |
        | dcForm | banksContainer      | amendment/addressUpdate/banks      |

    @AMD-OriginalDC-6
    Scenario Outline: User can see updated DC after changing available by (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | <Change 1>                                                                                               |
            | Changed - Amendment 2 | <Change 2>                                                                                               |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
            | page   | element             | refImage                          |
            | dcForm | availableByContainer| amendment/availableBy/<Reference> |
        Examples:
        | Change 1               | Change 2                    | Reference       |
        | typeCredits.Negotiation| typeCredits.Payment as sight| sight           |
        | typeCredits.Negotiation| typeCredits.Deferred payment| deferredPayment | 
        | typeCredits.Negotiation| typeCredits.Acceptance      | Acceptance      | 
        | typeCredits.Acceptance | typeCredits.Negotiation     | Negotiation     |  
    
    @AMD-OriginalDC-7
    Scenario Outline: User can see updated DC after changing document source (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" },{ "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Certificate of Origin Description" },{ "documentType": "PACKING_LIST", "description": "Packing List Description" },{"documentType": "TRANSPORT_DOCUMENT_OTHER","subtype": "Other Transport Document","description": "Transport Document Description"}].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ] |
            | Changed - Amendment 2 | <Change>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
        Then I reload the browser session                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
       Then I can see the page as following screenshots
            | page   | element                  | refImage                                            |
            | dcForm | documentRequiredContainer| amendment/dc_form/updatedDocumentSource/<Reference> |

        Examples:
            | Change                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Reference                      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ]                                                                                                                                                                                                                                                                                                                                     | removeDocument_multiAmend      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ]                                                                                               | changeDocument_multiAmend      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null }, { "documentType": "Other Doc 3", "description": "Other Doc Description 3", "subtype": null } ] | addOtherDocument_multiAmend    |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }]                                                                                                                                                                                              | removeOtherDocument_multiAmend |

    @AMD-OriginalDC-8
    Scenario Outline: User can see updated DC after changing attachment (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | originalAttachmentNum.2.newAttachmentNum.1                                                               |
            | Changed - Amendment 2 | <Change>                                                                                                 |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I scroll to element "dcForm"."attachmentsContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Change                                     | Reference                                                       |
            | originalAttachmentNum.1.newAttachmentNum.2 | amendment/dc_form/updatedAttachment_addAttachment_multiAmend    |
            | originalAttachmentNum.1.newAttachmentNum.0 | amendment/dc_form/updatedAttachment_removeAttachment_multiAmend |

    @AMD-OriginalDC-9
    Scenario: If beneficiary remains silent, they are be reminded when clicking present button
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.Test1.beneficiaryAddress.Test2.issuerAddress.Test3.advisingBankAddress.Test4 |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised           |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I expect the element "hint"."hintMessage2" to match reference "amendment/dc_form/remindPendingAmendmentAlert"

    @AMD-OriginalDC-10
    Scenario Outline: Amendment rules on original dc (accept amendment 3 / accept amendment 4)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.A1.beneficiaryAddress.B1                                                                |
            | Changed - Amendment 2 | applicantAddress.A2                                                                                      |
            | Changed - Amendment 3 | issuerAddress.C1.advisingBankAddress.D1                                                                  |
            | Changed - Amendment 4 | issuerAddress.C2                                                                                         |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 3           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised                      |
            | Amendment 4           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised                      |
        Then I reload the browser session
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current amendment <Amendment Number> using contour uuid
        When I click on the button "actionButton"."acceptButton" and submit
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
        | page   | element             | refImage                                                   |
        | dcForm | corporatesContainer | amendment/dc_form/amendmentRuleAcceptCorp<Amendment Number>|
        | dcForm | banksContainer      | amendment/dc_form/amendmentRuleAcceptBank<Amendment Number>|

         Examples:
            | Amendment Number | 
            | 3                
            | 4         

        Examples:
            | Amendment Number | Reference                              |
            | 3                | amendment/dc_form/amendmentRuleAccept3 |
            | 4                | amendment/dc_form/amendmentRuleAccept4 | 

    @AMD-OriginalDC-11
    Scenario Outline: Amendment rules on original dc (accept amendment 3 -> 4 / accept amendment 4 -> 3)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.A1.beneficiaryAddress.B1                                                                |
            | Changed - Amendment 2 | applicantAddress.A2                                                                                      |
            | Changed - Amendment 3 | issuerAddress.C1.advisingBankAddress.D1                                                                  |
            | Changed - Amendment 4 | issuerAddress.C2                                                                                         |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 3           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised                      |
            | Amendment 4           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised                      |
        Then I reload the browser session
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current amendment <First Amendment Number> using contour uuid
        When I click on the button "actionButton"."acceptButton" and submit
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current amendment <Second Amendment Number> using contour uuid
        When I click on the button "actionButton"."acceptButton" and submit
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        Then I can see the page as following screenshots
        | page   | element             | refImage                                  |
        | dcForm | corporatesContainer | amendment/dc_form/amendmentRuleCorp<Order>|
        | dcForm | banksContainer      | amendment/dc_form/amendmentRuleBank<Order>|


        Examples:
            | First Amendment Number | Second Amendment Number |Order |
            | 3                      | 4                       |3Then4|
            | 4                      | 3                       |4Then3|

    @AMD-OriginalDC-12
    Scenario Outline: Dp will use amended dc
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker.checkerApprover" with following document source
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | advisingBank                         | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        When I fill in dp overview with following information for scenario "sc11"
            | Present to     | #CONFIRMING_BANK# |
            | Drawing Amount | 1000              |
        Then I can see following sub side menu subOption
            | <Side Menu Sub Option 1> |
            | <Side Menu Sub Option 2> |
            | <Side Menu Sub Option 3> |
            | <Side Menu Sub Option 4> |
            | <Side Menu Sub Option 5> |
            | <Side Menu Sub Option 6> |
            | <Side Menu Sub Option 7> |
        And I can not see following sub side menu subOption
            | <Not Displayed Side Menu Sub Option 1> |

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Side Menu Sub Option 1   | Side Menu Sub Option 2 | Side Menu Sub Option 3 | Side Menu Sub Option 4 | Side Menu Sub Option 5 | Side Menu Sub Option 6 |Side Menu Sub Option 7 | Not Displayed Side Menu Sub Option 1 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | Invoice                  | Transport Document     | Certificate of origin  | Packing List            | Other Doc 1            | Other Doc 2           |   Other Doc 3         |                                      |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | Invoice                  | Transport Document     | Certificate of origin  | Packing List            | Other Doc 1            |                       |                       | Other Doc 2                          |

    @AMD-OriginalDC-13
    Scenario: Dp will use amended dc
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ] |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                       |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        When I fill in dp overview with following information for scenario "sc11"
            | Present to     | #CONFIRMING_BANK# |
            | Drawing Amount | 1000              |
        Then I can not see following sub side menu subOption
            | Certificate of origin |
            | Packing List          |

    @AMD-OriginalDC-14
    Scenario: Dp will use amended dc - 'other documents' should be seen in the presentation draft
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ] |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                       |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        When I fill in dp overview with following information for scenario "sc11"
            | Present to     | #CONFIRMING_BANK# |
            | Drawing Amount | 1000              |
        Then I expect the following document sources to match the references below
        |Other Doc 1   |amendment/otherDoc1 |
        |Other Doc 2   |amendment/otherDoc2 |