@DCAmendment
@VTX-1881
Feature: Amendment overview

    As QA,
    I want to check for amendment overview
    so that each party can see expected overview after each party perform some action

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1993
    @VTX-1988
    @AMM-overview-1
    Scenario Outline: Amendment overview can see call to action
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "amendment/draft1TabDot"

        Examples:
            | Initiate Party | Next Party  |
            | applicant      | beneficiary |
            | beneficiary    | applicant   |
            | applicant      | issuingBank |


    @VTX-1993
    @VTX-3010
    @AMM-overview-2
    Scenario: Amendment overview should not see amendment from other DC
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "maker"
        And applicant created amendment for scenario sc11 submit to issuingBank proceeded by "maker"
        And applicant's checkerApprover login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        Then I expect the document to match reference "amendment/checkOverviewNotFromOtherDc"


    @VTX-1993
    @VTX-1988
    @AMM-overview-3
    Scenario Outline: Can see all changed fields with 'i' icon in front of each entry
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Overview 1
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "<Reference>"

        Examples:
            | Initiate Party | Next Party  | Reference                              |
            | applicant      | beneficiary | amendment/draft1TabDetails_Beneficiary |
            | beneficiary    | applicant   | amendment/draft1TabDetails_Applicant   |
            | applicant      | issuingBank | amendment/draft1TabDetails_IssuingBank |

    @VTX-1993
    @VTX-1988
    @AMM-overview-4
    Scenario Outline: Can click at Draft 1 and review Draft 1
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Overview 1
        When I open 1 row of the amendment overview
        And I click on 1 row view button of the amendment overview
        Then I can see the dc form for amendment/overView/sc11

        Examples:
            | Initiate Party | Next Party  |
            | applicant      | beneficiary |
            | beneficiary    | applicant   |
            | applicant      | issuingBank |

    @VTX-1992
    @VTX-1990
    @AMM-overview-5
    Scenario Outline: Applicant / beneficiary can see applicant has discarded application on overview page
        Given <Action Party> discarded amendment after <Counter Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Roles>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "<Reference>"

        Examples:
            | Action Party | Counter Party | Proceeded Roles | Login Role | Reference                                      |
            | applicant    | beneficiary   | maker           | checker    | amendment/amendment1Overview_discardInProgress |
            | applicant    | beneficiary   | maker.checker   | approver   | amendment/amendment1Overview_discardInProgress |
            | applicant    | beneficiary   | admin1          | maker      | amendment/amendment1Overview_discarded         |
            | beneficiary  | applicant     | maker           | checker    | amendment/amendment1Overview_discardInProgress |
            | beneficiary  | applicant     | maker.checker   | approver   | amendment/amendment1Overview_discardInProgress |
            | beneficiary  | applicant     | admin1          | maker      | amendment/amendment1Overview_discarded         |


    @VTX-1991
    @VTX-1989
    @AMM-overview-6
    Scenario Outline: Applicant/beneficiary can see beneficiary/applicant has rejected application on overview page
        Given <Action Party> rejected amendment for scenario sc11 proceeded by "<Proceeded Roles>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_<baseline>"

        Examples:
            | Action Party | Proceeded Roles | Login Role | baseline        |
            | applicant    | maker           | checker    | rejected        |
            | applicant    | maker.checker   | approver   | rejected        |
            | applicant    | admin1          | maker      | adminRejected   |
            | beneficiary  | maker           | checker    | rejected        |
            | beneficiary  | maker.checker   | approver   | rejected        |
            | beneficiary  | admin1          | maker      | adminRejected   |

    @AMM-overview-7
    Scenario: Beneficiary after advising bank advises, can see overview action
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview"

    @AMM-overview-8
    Scenario: Beneficiary can see overview after expanding
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Overview 1
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_Beneficiary"

    @AMM-overview-9
    Scenario: Requested confirmation party after issuing bank issued Amendment
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview"

    @AMM-overview-10
    Scenario: Confirming bank Amendment 1 Overview after expanding
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        Then I open Overview 1
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_ConfirmingBank"

    @AMM-overview-11
    Scenario: Confirming bank can see overview with action after advised with confirmation
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_advisedWithConfirmation"

    @AMM-overview-12
    Scenario: Nominated bank after confirming bank advised with confirmation
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview"

    @AMM-overview-13
    Scenario: Nominated bank Amendment 1 Overview after expanding
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_NominatedBank"

    @AMM-overview-14
    Scenario: Nominated bank can see the status after submit to next party
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_advised"

    @AMM-overview-15
    Scenario: Advising bank after nominated bank advises - Amendment overview
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview"

    @AMM-overview-16
    Scenario: Advising bank can see overview after expanding
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_AdvisingBank"

    @AMM-overview-17
    Scenario: Advising bank can see the status after advise and submit to beneficiary
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_advised"

    @AMM-overview-18
    Scenario: Confirming bank can see its action after reject amendment and submit to nominated bank
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_ammRejected"

    @AMM-overview-19
    Scenario: Nominated bank can see expanded overview after confirming bank rejected amendment
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_NominatedBankAfterConfirmingBankReject"

    @AMM-overview-20
    Scenario: Nominated bank can see its action after reject and submit to advising bank
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_ammRejected"

    @AMM-overview-21
    Scenario: Advising bank can see expanded overview after nominated bank rejected
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        And I scroll to element "amendmentOverview"."listContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentOverview"."listContainer" to match reference "amendment/amendment1TabDetails_AdvisingBankAfterNominatedBankReject"

    @AMM-overview-22
    Scenario: Advising bank can see its action after reject amendment
        Given following bank performed following action for amendment and advisingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I expect 1 row of the amendment overview to match reference "amendment/amendment1Overview_ammRejected"

    @VTX-2992
    @VTX-1883
    @AMM-overview-23
    Scenario: Amendment order for multiple amendment
        Given following parties proceeded following amendment for scenario sc1 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | placePresentation.Updated2                   |
            | Changed - Amendment 2 | availableWithBank.bankd.confirmingBank.bankc |
            | Amendment 1           | issuingBank.issued                           |
            | Amendment 2           | issuingBank.issued                           |
        Then I expect following parties to see following row details of the amendment overview for scenario sc11
            | Parties      | applicant.beneficiary.issuingBank.advisingBank.confirmingBank.nominatedBank |
            | Row 1 Detail | amendment/changedAmendment1                                                 |
            | Row 2 Detail | amendment/changedAmendment2                                                 |

    @VTX-1999
    @AMM-overview-24
    Scenario: All parties should see beneficiaryls decision (Accept)
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        Then I expect following parties to see following row beneficiary actions of the amendment overview for scenario sc11
            | Parties                  | applicant.beneficiary.issuingBank.advisingBank.confirmingBank.nominatedBank |
            | Row 1 Beneficiary Action | amendment/AcceptAmendment                                                   |

    @VTX-2001
    @AMM-overview-25
    Scenario: All parties should see beneficiaryls decision (Reject)
        Given beneficiary rejected amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        Then I expect following parties to see following row beneficiary actions of the amendment overview for scenario sc11
            | Parties                  | applicant.beneficiary.issuingBank.advisingBank.confirmingBank.nominatedBank |
            | Row 1 Beneficiary Action | amendment/RejectAmendment                                                   |

