@VTX-2722
Feature: Amendment view accepted / issued dc

    As QA,
    I would like to check I can see the amended on when clicking view issued amendment button
    so that user can see the expected amendment when clicking this button

    Background: Set up scenario context
        Given I setup test scenario context

    @AMD-ViewAcceptedOrIssuedDC-1
    Scenario: User can see updated DC when clicking view issued amendment after changing bank's address for amendment
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.Test1.beneficiaryAddress.Test2.issuerAddress.Test3.advisingBankAddress.Test4            |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
      
    Scenario Outline: Check updated DC when clicking view issued amendment after changing bank's address for amendment
        Then I expect element "dcForm"."<element>" matches the text "<text>"
        Examples:
              | element                 |text |
              | applicantAddressInput   |Test1|
              | beneficiaryAddressInput |Test2|  
              | issuingBankAddress      |Test3|  
              | advisingBankAddressInput|Test4| 

    @AMD-ViewAcceptedOrIssuedDC-2
    Scenario Outline: User can see updated DC when clicking view issued amendment after changing available by
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | <Change>                                                                                                 |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        Then the element "dcForm"."<element>" is checked
        Examples:
            | Change                       | Reference       | element                            |
            | typeCredits.Payment as sight | sight           |  availableByPaymentAtSightCheckBox | 
            | typeCredits.Deferred payment | deferredPayment |  availableByDeferredPaymentCheckBox|
            | typeCredits.Acceptance       | Acceptance      |  availableAcceptanceCheckBox       |
            | typeCredits.Negotiation      | Negotiation     |  availableNegotiationCheckBox      |

    @AMD-ViewAcceptedOrIssuedDC-3
    Scenario Outline: User can see updated DC when clicking view issued amendment after changing document source
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker.checkerApprover" with following document source
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | advisingBank                         | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        Then I can see the page as following screenshots
            | page   | element                  | refImage                                      |
            | dcForm | documentRequiredContainer| amendment/ViewAccepted/<Reference>            |
       

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Reference                           |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | dc_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | dc_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | dc_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | dc_updateOtherDocumentDescription   |


    @AMD-ViewAcceptedOrIssuedDC-4
    Scenario Outline: User can see updated DC when clicking view issued amendment after changing attachment
        Given beneficiary accepted amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Original Attachment Number | New Attachment Number | Reference                                           |
            | 2                          | 2                     | amendment/ViewAccepted/updatedDc_noChangeAttachment |
            | 2                          | 1                     | amendment/ViewAccepted/updatedDc_removeAttachment   |
            | 2                          | 3                     | amendment/ViewAccepted/updatedDc_addAttachment      |

    @AMD-ViewAcceptedOrIssuedDC-5
    Scenario: User can see updated DC when clicking view issued amendment after changing bank's address for amendment (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | applicantAddress.Test5.beneficiaryAddress.Test6.issuerAddress.Test7.advisingBankAddress.Test8            |
            | Changed - Amendment 2 | applicantAddress.Test1.beneficiaryAddress.Test2.issuerAddress.Test3.advisingBankAddress.Test4            |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        Then I can see the page as following screenshots
        | page   | element             | refImage                              |
        | dcForm | corporatesContainer | amendment/ViewAccepted/corporatesAdd  |


    @AMD-ViewAcceptedOrIssuedDC-6
    Scenario Outline: User can see updated DC when clicking view issued amendment after changing available by (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | <Change 1>                                                                                               |
            | Changed - Amendment 2 | <Change 2>                                                                                               |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        Then I can see the page as following screenshots
            | page   | element             | refImage                           |
            | dcForm | availableByContainer| amendment/ViewAccepted/<Reference> |
        Examples:
        | Change 1               | Change 2                    | Reference       |
        | typeCredits.Negotiation| typeCredits.Payment as sight| sight           |
        | typeCredits.Negotiation| typeCredits.Deferred payment| deferredPayment | 
        | typeCredits.Acceptance | typeCredits.Negotiation     | Negotiation     |  


    @AMD-ViewAcceptedOrIssuedDC-7
    Scenario Outline: User can see updated DC after changing document source (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" },{ "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Certificate of Origin Description" },{ "documentType": "PACKING_LIST", "description": "Packing List Description" },{"documentType": "TRANSPORT_DOCUMENT_OTHER","subtype": "Other Transport Document","description": "Transport Document Description"}].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ] |
            | Changed - Amendment 2 | <Change>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        Then I can see the page as following screenshots
            | page   | element                  | refImage                                   |
            | dcForm | documentRequiredContainer| amendment/dc_form/ViewAccepted/<Reference> |

        Examples:
            | Change                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Reference                      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ]                                                                                                                                                                                                                                                                                                                                     | removeDocument_multiAmend      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null } ]                                                                                               | changeDocument_multiAmend      |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }, { "documentType": "Other Doc 2", "description": "Other Doc Description 2", "subtype": null }, { "documentType": "Other Doc 3", "description": "Other Doc Description 3", "subtype": null } ] | addOtherDocument_multiAmend    |
            | documentsRequired.[ { "documentType": "INVOICE", "description": "Invoice Description" }, { "documentType": "CERTIFICATE_OF_ORIGIN", "description": "Updated2" }, { "documentType": "PACKING_LIST", "description": "Updated2" }, { "documentType": "TRANSPORT_DOCUMENT_ESSDOCS", "subtype": null, "description": "Updated2" } ].otherDocumentsRequired.[ { "documentType": "Other Doc 1", "description": "Other Doc Description 1", "subtype": null }]                                                                                                                                                                                              | removeOtherDocument_multiAmend |


    @AMD-ViewAcceptedOrIssuedDC-8
    Scenario Outline: User can see updated DC when clicking view issued amendment after changing attachment (multiple amendment)
        Given following parties proceeded following amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | originalAttachmentNum.2.newAttachmentNum.1                                                               |
            | Changed - Amendment 2 | <Change>                                                                                                 |
            | Amendment 1           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
            | Amendment 2           | confirmingBank.advised with confirmation.nominatedBank.advised.advisingBank.advised.beneficiary.accepted |
        Then I reload the browser session
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment view issued amendments using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"
        Examples:
            | Change                                     | Reference                                                            |
            | originalAttachmentNum.1.newAttachmentNum.2 | amendment/ViewAccepted/updatedAttachment_addAttachment_multiAmend    |
            | originalAttachmentNum.1.newAttachmentNum.0 | amendment/ViewAccepted/updatedAttachment_removeAttachment_multiAmend |


