@VTX-1883
Feature: Visibility Matrix

    As an applicant, beneficiary and issuing bank,
    I would like to be able to view any amendment applications initiated by the applicant or beneficiary.
    The other banks should not be able to view any amendment applications that have not been issued.

    As a bank,
    I would like to view any amendments that has been issued by the issuing bank.

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-3148
    @AMM-isibility-1
    Scenario Outline: Visibility after applicant / beneficiary create amendment
        Given <Action Party> created amendment for scenario sc11 submit to <Submit to Party> proceeded by "admin1"
        Then I expect the following parties can see draft text 1 for amendment for sc11
            | applicant   |
            | beneficiary |
            | issuingBank |
        And I expect the following parties can not see draft text 1 for amendment for sc11
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action Party | Submit to Party |
            | applicant    | beneficiary     |
            | beneficiary  | applicant       |


    @VTX-3148
    @AMM-isibility-2
    Scenario Outline: Visibility after applicant / beneficiary edited and returned / endorse / reject amendment
        Given <Action Party> <Action> amendment for scenario sc11 proceeded by "admin1"
        Then I expect the following parties can see draft text 1 for amendment for sc11
            | applicant   |
            | beneficiary |
            | issuingBank |
        And I expect the following parties can not see draft text 1 for amendment for sc11
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action Party | Action              |
            | applicant    | edited and returned |
            | applicant    | endorsed            |
            | applicant    | rejected            |
            | beneficiary  | edited and returned |
            | beneficiary  | endorsed            |
            | beneficiary  | rejected            |

    @VTX-3148
    @AMM-isibility-3
    Scenario: Visibility after applicant send to issuing bank amendment
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        Then I expect the following parties can see draft text 1 for amendment for sc11
            | applicant   |
            | beneficiary |
            | issuingBank |
        And I expect the following parties can not see draft text 1 for amendment for sc11
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |


    @AMM-isibility-4
    Scenario: Visibility after issuing bank issue amendment
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        Then I expect the following parties can see amendment 1 for amendment for sc11
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

    @VTX-3148
    @AMM-isibility-5
    Scenario: Visibility after issuing bank reject amendment
        Given issuingBank rejected amendment for scenario sc11 proceeded by "maker.checkerApprover"
        Then I expect the following parties can see draft text 1 for amendment for sc11
            | applicant   |
            | beneficiary |
            | issuingBank |
        And I expect the following parties can not see draft text 1 for amendment for sc11
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

    @AMM-isibility-6
    Scenario Outline: Visibility after confirming bank advise with confirmation / reject amendment
        Given following bank performed following action for amendment and confirmingBank <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        Then I expect the following parties can see amendment 1 for amendment for sc11
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action                    |
            | advised with confirmation |
            | rejected                  |


    Scenario Outline: Visibility after nominated bank advise / reject amendment
        Given following bank performed following action for amendment and nominatedBank <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
        Then I expect the following parties can see amendment 1 for amendment for sc11
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action   |
            | advised  |
            | rejected |

    Scenario Outline: Visibility after advising bank advise / reject amendment
        Given following bank performed following action for amendment and advisingBank <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        Then I expect the following parties can see amendment 1 for amendment for sc11
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action   |
            | advised  |
            | rejected |

    Scenario Outline: Visibility after beneficiary accept / reject amendment
        Given beneficiary <Action> amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        Then I expect the following parties can see amendment 1 for amendment for sc11
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | nominatedBank  |
            | advisingBank   |

        Examples:
            | Action   |
            | accepted |
            | rejected |

    @VTX-3174
    Scenario: Multi-amendment: Nominated bank (added when amends) can see amendment if 2 amendment exists
        Given following parties proceeded following amendment for scenario sc1 proceeded by "maker.checkerApprover" with following banks action
            | Changed - Amendment 1 | confirmingBank.bankc    |
            | Changed - Amendment 2 | availableWithBank.bankd |
            | Amendment 1           | issuingBank.issued      |
            | Amendment 2           | issuingBank.issued      |
        And nominatedBank's admin1 login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect the following parties can see amendment 2 for amendment for sc11
            | nominatedBank |
