@DCAmendment
@VTX-1881
@AMM-Workflow-IssuingBank
Feature: Amendment workflow (issuing bank)

    As an Issuing Bank,
    I would like to view the amendment application submitted by the applicant and either issue the amendment or return it to the applicant

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1987
    @AMM-Workflow-IssuingBank-1
    Scenario Outline: Can issue / reject Draft 1 (to checkerApprover)
        Given applicant created amendment for scenario sc11 submit to issuingBank proceeded by "admin1"
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Action Button |
            | issueButton   |
            | returnButton  |

    @AMM-Workflow-IssuingBank-2
    Scenario: Checker-approver can verify issue draft
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker"
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I can see amendment draft text right column with following values
            | Applicant Address                                                      | Updated      |
            | Beneficiary Address                                                    | Updated      |
            | Issuing Bank Address                                                   | Updated      |
            | Advising Bank Address                                                  | Updated      |
            | Requested Confirmation Party Address                                   | Updated      |
            | Nominated Bank Address                                                 | Updated      |
            | Amount                                                                 | USD 20000.00 |
            | Tolerance                                                              | +30% to -30% |
            | Additional amount covered (optional)                                   | Updated      |
            | Expiry Date                                                            | 25/01/01     |
            | Expiry Place                                                           | Updated      |
            | Partial Shipments                                                      | Not allowed  |
            | Transhipment                                                           | Conditional  |
            | Shipment Period                                                        | 20           |
            | Description of Goods and / or Services                                 | Updated      |
            | Period of Presentation                                                 | 321          |
            | Type of Presentation                                                   | Updated      |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Updated      |
            | Port of Loading / Airport of Departure                                 | Updated      |
            | Port of Discharge / Airport of Destination                             | Updated      |
            | Place of Final Destination / For Transportation to / Place of Delivery | Updated      |
        And I can see amendment draft text left column with following values for sc11
            | Applicant Address                                                      | #APPLICANT_ADDRESS#                                                               |
            | Beneficiary Address                                                    | #BENEFICIARY_ADDRESS#                                                             |
            | Issuing Bank Address                                                   | #ISSUING_BANK_ADDRESS#                                                            |
            | Advising Bank Address                                                  | #ADVISING_BANK_ADDRESS#                                                           |
            | Requested Confirmation Party Address                                   | #CONFIRMING_BANK_ADDRESS#                                                         |
            | Nominated Bank Address                                                 | #NOMINATED_BANK_ADDRESS#                                                          |
            | Amount                                                                 | USD 10000.00                                                                      |
            | Tolerance                                                              | +15% to -5%                                                                       |
            | Additional amount covered (optional)                                   | Additional Amount Covered (Option)                                                |
            | Expiry Date                                                            | #RANDOM_DATE (YY/MM/DD)#                                                          |
            | Expiry Place                                                           | Hong Kong                                                                         |
            | Partial Shipments                                                      | Allowed                                                                           |
            | Transhipment                                                           | Not allowed                                                                       |
            | Shipment Period                                                        | 12                                                                                |
            | Description of Goods and / or Services                                 | Automation                                                                        |
            | Period of Presentation                                                 | 123                                                                               |
            | Type of Presentation                                                   | 123                                                                               |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port of Loading / Airport of Departure                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port of Discharge / Airport of Destination                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place of Final Destination / For Transportation to / Place of Delivery | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |

    @AMM-Workflow-IssuingBank-3
    Scenario: Checker-approver can reject issue draft
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker"
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed


    @AMM-Workflow-IssuingBank-4
    @VTX-1987
    Scenario: Checker-approver can verify return draft
        Given issuingBank rejected amendment for scenario sc11 proceeded by "maker"
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed


    @AMM-Workflow-IssuingBank-5
    @VTX-1987
    Scenario: Checker-approver can reject return draft
        Given issuingBank rejected amendment for scenario sc11 proceeded by "maker"
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @AMM-Workflow-IssuingBank-6
    Scenario Outline: Issuing Bank can issue / reject with attachment change
        Given applicant created amendment for scenario sc1 submit to issuingBank with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover"
        And issuingBank's maker login to main page for scenario sc1
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Original Attachment Number | New Attachment Number | Action Button | Attachment Container Displayed | Old Attachment Name 1 | Old Attachment Name 2 | New Attachment Name 1 | New Attachment Name 2 | New Attachment Name 3 | Removed Attachment Name 1 | Removed Attachment Name 2 |
            | 2                          | 2                     | issueButton   | is not                         |                       |                       |                       |                       |                       |                           |                           |
            | 2                          | 1                     | issueButton   | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            |                       |                       | pdfDc2.pdf                |                           |
            | 2                          | 3                     | issueButton   | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            | pdfDc2.pdf            | pdfAmendment1.pdf     |                           |                           |
            | 2                          | 2                     | returnButton  | is not                         |                       |                       |                       |                       |                       |                           |                           |
            | 2                          | 1                     | returnButton  | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            |                       |                       | pdfDc2.pdf                |                           |
            | 2                          | 3                     | returnButton  | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            | pdfDc2.pdf            | pdfAmendment1.pdf     |                           |                           |

    @AMM-Workflow-IssuingBank-7
    Scenario Outline: Issuing bank checkerApprover can verify issue request with attachment change
        Given issuingBank issued amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker"
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
       And I expect that element "actionButton"."adviseButton" is displayed
       And I expect that element "actionButton"."rejectButton" is displayed

        Examples:
            | Original Attachment Number | New Attachment Number | Attachment Container Displayed | Old Attachment Name 1 | Old Attachment Name 2 | New Attachment Name 1 | New Attachment Name 2 | New Attachment Name 3 | Removed Attachment Name 1 | Removed Attachment Name 2 |
            | 2                          | 2                     | is not                         |                       |                       |                       |                       |                       |                           |                           |
            | 2                          | 1                     | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            |                       |                       | pdfDc2.pdf                |                           |
            | 2                          | 3                     | is                             | pdfDc1.pdf            | pdfDc2.pdf            | pdfDc1.pdf            | pdfDc2.pdf            | pdfAmendment1.pdf     |                           |                           |

    @AMM-Workflow-IssuingBank-8
    Scenario Outline: Issuing Bank's maker can issue / reject with document source change
        Given applicant created amendment for scenario sc11 submit to issuingBank with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And issuingBank's checkerApprover login to main page for scenario sc1
        And issuingBank navigate to current draft text 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action Button | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | issueButton   | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | issueButton   | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | issueButton   | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | issueButton   | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | returnButton  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | returnButton  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | returnButton  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | returnButton  | amendment/document_source_updateOtherDocumentDescription   |

    @AMM-Workflow-IssuingBank-9
    Scenario Outline: Issuing bank's checkerApprover can verify document source change
        Given issuingBank issued amendment for scenario sc11 with following document source proceeded by "maker"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And issuingBank's checkerApprover login to main page for scenario sc11
        And issuingBank navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."adviseWithConfirmationButton" is displayed
        And I expect that element "actionButton"."adviseWithoutConfirmationButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | amendment/document_source_updateOtherDocumentDescription   |


