@DCAmendment
@VTX-1992
Feature: Amendment workflow (applicant / beneficiary discard)

    As an Applicant,
    I would like to discard amendment applications returned by the Beneficiary that I have originally initiated.

    As a Beneficiary,
    I would like to discard amendment applications returned by the Applicant that I have initiated.

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1990
    @VTX-1992
    @AMM-Workflow-ApplicantDiscard-1
    Scenario Outline: Checker / Approver can see action buttons after applicant / beneficiary discard
        Given <Action Party> discarded amendment after <Previous Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."<Display Button>" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Action Party | Previous Party | Proceeded Role | Login Role | Display Button |
            | applicant    | beneficiary    | maker          | checker    | verifyButton   |
            | applicant    | beneficiary    | maker.checker  | approver   | approveButton  |
            | beneficiary  | applicant      | maker          | checker    | verifyButton   |
            | beneficiary  | applicant      | maker.checker  | approver   | approveButton  |

    @VTX-1990
    @VTX-1992
    @AMM-Workflow-ApplicantDiscard-2
    Scenario Outline: Checker can verify discard draft text after applicant / beneficiary discard
        Given <Action Party> discarded amendment after <Previous Party> edited and returned amendment for scenario sc11 proceeded by "maker"
        And <Action Party>'s checker login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."verifyButton" and confirm
        And <Action Party>'s approver login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."approveButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Action Party | Previous Party |
            | applicant    | beneficiary    |
            | beneficiary  | applicant      |

    @VTX-1990
    @VTX-1992
    @AMM-Workflow-ApplicantDiscard-3
    Scenario Outline: Approver can approve discard draft text after applicant / beneficiary discard
        Given <Action Party> discarded amendment after <Previous Party> edited and returned amendment for scenario sc11 proceeded by "maker.checker"
        And <Action Party>'s approver login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."approveButton" and confirm
        Then I can see the dc has amendment status "Discarded"

        Examples:
            | Action Party | Previous Party |
            | applicant    | beneficiary    |
            | beneficiary  | applicant      |

    @VTX-1990
    @VTX-1992
    @AMM-Workflow-ApplicantDiscard-4
    Scenario Outline: Checker / Approver can decline discard draft text after applicant / beneficiary discard
        Given <Action Party> discarded amendment after <Previous Party> edited and returned amendment for scenario sc11 proceeded by "<Proceeded Role>"
        And <Action Party>'s <Login Role> login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."declineButton" and confirm
        And <Action Party>'s maker login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

        Examples:
            | Action Party | Previous Party | Proceeded Role | Login Role | Display Button |
            | applicant    | beneficiary    | maker          | checker    | verifyButton   |
            | applicant    | beneficiary    | maker.checker  | approver   | approveButton  |
            | beneficiary  | applicant      | maker          | checker    | verifyButton   |
            | beneficiary  | applicant      | maker.checker  | approver   | approveButton  |



    @VTX-1990
    @AMM-Workflow-ApplicantDiscard-5
    Scenario Outline: Applicant/beneficiary can discard draft text after another party send it back to the creator by either reject, edit and return, or endorse (only happen when beneficiary endorse and send back to applicant)
        Given <Action Party> <Action> amendment for scenario sc11 proceeded by "admin1"
        And <Login Party>'s admin1 login to main page for scenario sc11
        And <Login Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."discardButton" and submit
        Then I can see the dc has amendment status "Discarded"

        Examples:
            | Action Party | Login Party | Action              |
            | beneficiary  | applicant   | edited and returned |
            | beneficiary  | applicant   | endorsed            |
            | beneficiary  | applicant   | rejected            |
            | applicant    | beneficiary | edited and returned |
            | applicant    | beneficiary | rejected            |


    @VTX-1991
    @AMM-Workflow-ApplicantDiscard-6
    Scenario: Applicant cannot discard amendment after bene send to applicant
        Given beneficiary created amendment for scenario sc11 submit to applicant proceeded by "maker.checkerApprover"
        And applicant's admin1 login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."discardButton" is not displayed

    @VTX-1991
    @AMM-Workflow-ApplicantDiscard-7
    Scenario: Applicant cannot discard amendment after bene re-send (endorse) amendment
        Given applicant rejected amendment for scenario sc11 proceeded by "admin1"
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."endorseButton" and submit
        And applicant's admin1 login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."discardButton" is not displayed

    @VTX-1991
    @AMM-Workflow-ApplicantDiscard-8
    Scenario: Applicant cannot discard amendment after bene re-send (edit and return) amendment
        Given applicant rejected amendment for scenario sc11 proceeded by "admin1"
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."editButton"
        And I click on the button "actionButton"."returnButton" and submit
        And applicant's admin1 login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."discardButton" is not displayed


    @AMM-Workflow-ApplicantDiscard-9
    Scenario: Applicant can discard amendment after issuing bank reject
        Given issuingBank rejected amendment for scenario sc1 proceeded by "maker.checkerApprover"
        And applicant's admin1 login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        When I click on the button "actionButton"."discardButton" and submit
        Then I can see the dc has amendment status "Discarded"


