@DCAmendment
@VTX-1881
@AMM-Workflow-ApplicantSubmit
Feature: Amendment workflow (applicant)

    As an applicant/beneficiary,
    I would like to make amendments on the DC.
    Each amendment application will be sent to the issuing bank by the applicant where the issuing bank can issue the amendment.

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1993
    @VTX-1988
    @AMM-Workflow-ApplicantSubmit-1
    Scenario Outline: Applicant can send to beneficiary/issuing bank and beneficiary can send to applicant
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        And <Login Party>'s admin1 login to main page for scenario sc11
        And <Login Party> navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                           | Updated |
            | Beneficiary                                 |         |
            | Beneficiary Address                         | Updated |
            | Issuing Bank                                |         |
            | Issuing Bank Address                        | Updated |
            | Allow Issuing Bank To Make Changes Directly |         |
            | Advising Bank                               |         |
            | Advising Bank Address                       | Updated |
            | Confirmation Instructions                   |         |
            | Confirming Bank                             |         |
            | Confirming Bank Address                     | Updated |
            | Available With Bank                         |         |
            | Available With Bank Address                 | Updated |

            | Available By                                 | Payment at sight |
            | Negotiation / Deferred Payment Details       |                  |
            | Drafts At                                    |                  |
            | Drawee Bank                                  |                  |
            | Drawee Bank Address                          |                  |
            | Check Negotiation / Deferred Payment Details |                  |
            | Check Draft At                               |                  |

            | Application Date                     | #TODAY_DATE#        |
            | Form Of Documentary Credit           | Irrevocable         |
            | Applicable Rules                     | eUCP latest version |
            | Selected Currency                    |                     |
            | Amount                               | 20 000.00           |
            | Max Tolerance (Optional)             | 30.00               |
            | Min Tolerance (Optional)             | 30.00               |
            | Additional Amount Covered (Option)   | Updated             |
            | Description Of Goods And/Or Services | Updated             |
            | Expiry Date (YY/MM/DD)               | 2025-01-01          |
            | Expiry Place                         | Updated             |

            | Partial Shipments (optional) | Not allowed |
            | Transhipment (optional)      | Conditional |

            | Shipment Date / Period  | Shipment period |
            | Latest Date Of Shipment |                 |

            | Shipment Period | 20 |

            | Period Of Presentation                                                            | 321     |
            | Type Of Presentation                                                              | Updated |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Updated |
            | Port Of Loading / Airport Of Departure (optional)                                 | Updated |
            | Port Of Discharge / Airport Of Destination (optional)                             | Updated |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Updated |
        And I click on the button "actionButton"."<Action Button>" and submit
        And <Counter Party>'s maker login to main page for scenario sc11
        And <Counter Party> navigate to current draft text 1 using contour uuid
        Then I can see the dc form for amendment/applicantSubmit/sc11

        Examples:
            | Login Party | Counter Party | Action Button             |
            | applicant   | beneficiary   | sendToBeneficiaryButton   |
            | applicant   | beneficiary   | submitToIssuingBankButton |
            | beneficiary | applicant     | submitToApplicantButton   |

    @VTX-1993
    @VTX-2742
    @VTX-2743
    @VTX-1989
    @AMM-Workflow-ApplicantSubmit-2
    Scenario Outline: Can update draft to Beneficiary / applicant after checker-approver rejects
        Given <Action Party> created amendment for scenario sc11 submit to <Submit to party> proceeded by "maker"
        And <Action Party>'s checkerApprover login to main page for scenario sc11
        And <Action Party> navigate to current amendment draft using contour uuid
        And I click on the button "actionButton"."declineButton" and confirm
        And <Action Party>'s admin1 login to main page for scenario sc11
        And <Action Party> navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."updateButton"
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                           | Updated2 |
            | Beneficiary                                 |          |
            | Beneficiary Address                         | Updated2 |
            | Issuing Bank                                |          |
            | Issuing Bank Address                        | Updated2 |
            | Allow Issuing Bank To Make Changes Directly |          |
            | Advising Bank                               |          |
            | Advising Bank Address                       | Updated2 |
            | Confirmation Instructions                   |          |
            | Confirming Bank                             |          |
            | Confirming Bank Address                     | Updated2 |
            | Available With Bank                         |          |
            | Available With Bank Address                 | Updated2 |

            | Available By                                 | Payment at sight |
            | Negotiation / Deferred Payment Details       |                  |
            | Drafts At                                    |                  |
            | Drawee Bank                                  |                  |
            | Drawee Bank Address                          |                  |
            | Check Negotiation / Deferred Payment Details |                  |
            | Check Draft At                               |                  |

            | Application Date                     | #TODAY_DATE#       |
            | Form Of Documentary Credit           | Irrevocable        |
            | Applicable Rules                     | UCP latest version |
            | Selected Currency                    |                    |
            | Amount                               | 30 000.00          |
            | Max Tolerance (Optional)             | 50.00              |
            | Min Tolerance (Optional)             | 50.00              |
            | Additional Amount Covered (Option)   | Updated2           |
            | Description Of Goods And/Or Services | Updated2           |
            | Expiry Date (YY/MM/DD)               | 2025-01-02         |
            | Expiry Place                         | Updated2           |

            | Partial Shipments (optional) | Conditional |
            | Transhipment (optional)      | Allowed     |

            | Shipment Date / Period  | Shipment period |
            | Latest Date Of Shipment |                 |

            | Shipment Period | 50 |

            | Period Of Presentation                                                            | 100      |
            | Type Of Presentation                                                              | Updated2 |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Updated2 |
            | Port Of Loading / Airport Of Departure (optional)                                 | Updated2 |
            | Port Of Discharge / Airport Of Destination (optional)                             | Updated2 |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Updated2 |
        And I click on the button "actionButton"."updateButton" and submit
        And <Submit to party>'s maker login to main page for scenario sc11
        And <Submit to party> navigate to current draft text 1 using contour uuid
        Then I can see the dc form for amendment/applicantSubmit/sc11

        Examples:
            | Action Party | Submit to party |
            | applicant    | issuingBank     |
            | beneficiary  | applicant       |


    @VTX-1993
    @VTX-2993
    @AMM-Workflow-ApplicantSubmit-3
    Scenario: Applicant's checker-approver can verify
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "maker"
        And applicant's checkerApprover login to main page for scenario sc11
        And applicant navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        Then I can see the dc has amendment sub status "Beneficiary to review"
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."endorseButton" is displayed
        And I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed


    @VTX-2744
    @VTX-1989
    @AMM-Workflow-ApplicantSubmit-4
    Scenario: Beneficiary's checker-approver should not see edit,endorse and reject button at draft
        Given beneficiary created amendment for scenario sc11 submit to applicant proceeded by "maker"
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment draft using contour uuid
        Then I expect that element "actionButton"."editButton" is not displayed
        And I expect that element "actionButton"."endorseButton" is not displayed
        And I expect that element "actionButton"."rejectButton" is not displayed


    @VTX-1988
    @AMM-Workflow-ApplicantSubmit-5
    Scenario: Beneficiary's checker-approver can verify
        Given beneficiary created amendment for scenario sc11 submit to applicant proceeded by "maker"
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        Then I can see the dc has amendment sub status "Applicant to review"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current draft text 1 using contour uuid
        Then I expect that element "actionButton"."editButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

    @AMM-Workflow-ApplicantSubmit-6
    Scenario: Applicant's checker-approver can reject
        Given applicant created amendment for scenario sc11 submit to beneficiary proceeded by "maker"
        And applicant's checkerApprover login to main page for scenario sc11
        And applicant navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        Then I can see the dc has amendment sub status "Your Maker to review"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current amendment draft using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @VTX-1993
    @VTX-1988
    @AMM-Workflow-ApplicantSubmit-7
    Scenario Outline: Applicant / Beneficiary can add attachment to amendment
        Given advisingBank advised dc for scenario sc11 with 2 attachments proceeded by "maker.checkerApprover"
        And <Action Party>'s maker login to main page for scenario sc11
        And <Action Party> navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I upload "test/util/pdf/pdfAmendment1.pdf" to contourFileUpload "dcForm"."attachmentUpload"
        And I click on the button "actionButton"."<Action Button>" and submit
        And <Action Party>'s checkerApprover login to main page for scenario sc11
        And <Action Party> navigate to current amendment draft using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "amendment/addAttachment"

        Examples:
            | Action Party | Action Button             |
            | applicant    | submitToIssuingBankButton |
            | beneficiary  | sendToApplicantButton     |


    @AMM-Workflow-ApplicantSubmit-8
    Scenario: Applicant can remove attachment to amendment
        Given advisingBank advised dc for scenario sc1 with 2 attachments proceeded by "maker.checkerApprover"
        And applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        When I remove 2 row of attachment
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        And I can see amendment attachment with following value
            | Removed file | pdfDc1.pdf |
            |              | pdfDc2.pdf |

    @VTX-1993
    @VTX-1988
    @AMM-Workflow-ApplicantSubmit-9
    Scenario Outline: Applicant / beneficiary's checker-approver can verify, issuing bank / applicant can view the updated attachment
        Given <Action Party> created amendment for scenario sc11 <Action> with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker"
        And <Action Party>'s checkerApprover login to main page for scenario sc11
        And <Action Party> navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        Then I can see the dc has amendment sub status "<Expected Status>"
        And I pause for 5000ms
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current draft text 1 using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Action Party | Action                | Expected Status        | Next Party  | Original Attachment Number | New Attachment Number | Reference                      |
            | applicant    | submit to issuingBank | Issuing bank to review | issuingBank | 2                          | 2                     | amendment/noChangeToAttachment |
            | applicant    | submit to issuingBank | Issuing bank to review | issuingBank | 2                          | 1                     | amendment/removeAttachment     |
            | applicant    | submit to issuingBank | Issuing bank to review | issuingBank | 2                          | 3                     | amendment/addAttachment        |
            | beneficiary  | submit to applicant   | Applicant to review    | applicant   | 2                          | 3                     | amendment/addAttachment        |


    @VTX-3252
    @AMM-Workflow-ApplicantSubmit-10
    Scenario: Applicant maker can remove document source
        Given advisingBank advised dc for scenario sc1 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           |
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And applicant's maker login to main page for scenario sc1
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I click on the button "dcForm"."documentRequiredTransportDocumentCheckbox"
        And I click on the button "dcForm"."documentRequiredCertificateOfOriginCheckbox"
        And I click on the button "dcForm"."documentRequiredPackingListCheckbox"
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "amendment/document_source_removeDocumentSource"

    @VTX-1993
    @AMM-Workflow-ApplicantSubmit-11
    Scenario: Applicant maker can change document source description
        Given advisingBank advised dc for scenario sc1 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           |
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And applicant's maker login to main page for scenario sc1
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I set "Updated" to the inputfield "dcForm"."documentRequiredInvoiceDescriptionInput"
        And I set "Updated" to the inputfield "dcForm"."documentRequiredTransportDocumentDescriptionInput"
        And I set "Updated" to the inputfield "dcForm"."documentRequiredCertificateOfOriginDescriptionInput"
        And I set "Updated" to the inputfield "dcForm"."documentRequiredPackingListDescriptionInput"
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailContainer"
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "amendment/document_source_changeDocumentSource_Description"

    @AMM-Workflow-ApplicantSubmit-12
    Scenario: Applicant maker can add other document
        Given advisingBank advised dc for scenario sc1 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           |
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And applicant's maker login to main page for scenario sc1
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I click on the button "dcForm"."documentRequiredAddOtherDocumentButton"
        And I set "Other Doc 3" to the other document name for row 3
        And I set "Other Doc Description 3" to the other document description for row 3
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "amendment/document_source_addOtherDocument"

    @AMM-Workflow-ApplicantSubmit-13
    Scenario: Applicant can remove other document
        Given advisingBank advised dc for scenario sc1 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           |
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And applicant's maker login to main page for scenario sc1
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I remove other document for row 2
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "amendment/document_source_removeOtherDocument"


    @AMM-Workflow-ApplicantSubmit-14
    Scenario: Applicant can change other document description
        Given advisingBank advised dc for scenario sc1 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           |
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And applicant's maker login to main page for scenario sc1
        And applicant navigate to current dc using contour uuid
        When I click on the button "actionButton"."amendButton"
        And I set "Other Doc Description Updated 1" to the other document description for row 1
        And I set "Other Doc Description Updated 2" to the other document description for row 2
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current amendment draft using contour uuid
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "amendment/document_source_updateOtherDocumentDescription"

    @VTX-1993
    @VTX-1988
    @AMM-Workflow-ApplicantSubmit-15
    Scenario Outline: Applicant / Beneficiary checkerApprover can verify document source change
        Given <Action Party> created amendment for scenario sc11 <Action> with following document source proceeded by "maker"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And <Action Party>'s checkerApprover login to main page for scenario sc11
        And <Action Party> navigate to current amendment draft using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And <Next Party>'s maker login to main page for scenario sc1
        And <Next Party> navigate to current draft text 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"

        Examples:
            | Action Party | Action                | Next Party  | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Reference                                                  |
            | applicant    | submit to issuingBank | issuingBank | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | amendment/document_source_addOtherDocument                 |
            | applicant    | submit to issuingBank | issuingBank | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | amendment/document_source_changeDocumentSource_Description |
            | applicant    | submit to issuingBank | issuingBank | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | amendment/document_source_removeOtherDocument              |
            | applicant    | submit to issuingBank | issuingBank | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | amendment/document_source_updateOtherDocumentDescription   |
            | beneficiary  | submit to applicant   | applicant   | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | amendment/document_source_changeDocumentSource_Description |
