@DCAmendment
@VTX-1881
Feature: Beneficiary conclude amendment workflow

    As a Beneficiary,
    I would like to explicitly accept or reject any amendments that has been issued on the DC.
    Any rejection by me would deem the amendment invalid.
    Any presentation that comply to amendments that has been issued but yet to be accepted by the beneficiary would mean that the beneficiary has implicitly accepted the amendment.


    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1999
    @AMM-Workflow-BeneficiaryConclude-1
    Scenario Outline: Beneficiary can accept amendment
        Given following bank performed following action for amendment and advisingBank <Advising Bank Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | <Confirming Bank Action> |
            | nominatedBank  | <Nominated Bank Action>  |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."acceptButton" and submit
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Confirming Bank Action    | Nominated Bank Action | Advising Bank Action |
            | advised with confirmation | advised               | advised              |
            | rejected                  | advised               | advised              |
            | advised with confirmation | rejected              | advised              |
            | advised with confirmation | advised               | rejected             |

    @VTX-1999
    @test-bvt
    @AMM-Workflow-BeneficiaryConclude-2
    Scenario Outline: Beneficiary checkerApprover can verify accept amendment
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker" with following banks action
            | confirmingBank | <Confirming Bank Action> |
            | nominatedBank  | <Nominated Bank Action>  |
            | advisingBank   | <Advising Bank Action>   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "amendment/beneficiaryAcceptedAmendment"

        Examples:
            | Confirming Bank Action    | Nominated Bank Action | Advising Bank Action |
            | advised with confirmation | advised               | advised              |
            | rejected                  | advised               | advised              |
            | advised with confirmation | rejected              | advised              |
            | advised with confirmation | advised               | rejected             |

    @VTX-1999
    @AMM-Workflow-BeneficiaryConclude-3
    Scenario: Beneficiary checkerApprover can reject accept amendment
        Given beneficiary accepted amendment for scenario sc11 proceeded by "maker" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-4
    Scenario Outline: Beneficiary can reject amendment
        Given following bank performed following action for amendment and advisingBank <Advising Bank Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | <Confirming Bank Action> |
            | nominatedBank  | <Nominated Bank Action>  |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        And I click on the button "actionButton"."rejectButton" and submit
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Confirming Bank Action    | Nominated Bank Action | Advising Bank Action |
            | advised with confirmation | advised               | advised              |
            | rejected                  | advised               | advised              |
            | advised with confirmation | rejected              | advised              |
            | advised with confirmation | advised               | rejected             |

    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-5
    Scenario Outline: Beneficiary checkerApprover can verify reject amendment
        Given beneficiary rejected amendment for scenario sc11 proceeded by "maker" with following banks action
            | confirmingBank | <Confirming Bank Action> |
            | nominatedBank  | <Nominated Bank Action>  |
            | advisingBank   | <Advising Bank Action>   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "amendment/beneficiaryRejectedAmendment"

        Examples:
            | Confirming Bank Action    | Nominated Bank Action | Advising Bank Action |
            | advised with confirmation | advised               | advised              |
            | rejected                  | advised               | advised              |
            | advised with confirmation | rejected              | advised              |
            | advised with confirmation | advised               | rejected             |

    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-6
    Scenario: Beneficiary checkerApprover can reject reject amendment
        Given beneficiary rejected amendment for scenario sc11 proceeded by "maker" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        When I click on the button "actionButton"."declineButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @VTX-1999
    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-7
    Scenario Outline: Beneficiary can accept / reject amendment with attachment change
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover"
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        When I click on the button "actionButton"."<Action Button>" and submit
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed


        Examples:
            | Original Attachment Number | New Attachment Number | Action Button | Reference                    |
            | 2                          | 2                     | acceptButton  | amendment/unchangeAttachment |
            | 2                          | 1                     | acceptButton  | amendment/removeAttachment   |
            | 2                          | 3                     | acceptButton  | amendment/addAttachment      |
            | 2                          | 2                     | rejectButton  | amendment/unchangeAttachment |
            | 2                          | 1                     | rejectButton  | amendment/removeAttachment   |
            | 2                          | 3                     | rejectButton  | amendment/addAttachment      |

    @VTX-1999
    @AMM-Workflow-BeneficiaryConclude-8
    Scenario Outline: Beneficiary's checkerapprover can verify accept amendment with update attachment
        Given beneficiary accepted amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "amendment/beneficiaryAcceptedAmendmentBeneView"
        And I click sub side menu sub-option "Amendment 1"
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Original Attachment Number | New Attachment Number | Action Button | Reference                    |
            | 2                          | 2                     | acceptButton  | amendment/unchangeAttachment |
            | 2                          | 1                     | acceptButton  | amendment/removeAttachment   |
            | 2                          | 3                     | acceptButton  | amendment/addAttachment      |

    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-9
    Scenario Outline: Beneficiary's checkerapprover can verify reject amendment with update attachment
        Given beneficiary rejected amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker" with following banks action
            | confirmingBank | advised with confirmation |
            | nominatedBank  | advised                   |
            | advisingBank   | advised                   |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "amendment/beneficiaryRejectedAmendment"

        Examples:
            | Original Attachment Number | New Attachment Number |
            | 2                          | 2                     |
            | 2                          | 1                     |
            | 2                          | 3                     |

    @VTX-1999
    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-10
    Scenario Outline: Beneficiary's maker can accept / reject amendment with document change
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        When I click on the button "actionButton"."<Action Button>" and submit
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        Then I open Amendment 1
        And I scroll to element "dcForm"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "dcForm"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action Button | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | acceptButton  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | acceptButton  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | acceptButton  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | acceptButton  | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejectButton  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejectButton  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejectButton  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejectButton  | amendment/document_source_updateOtherDocumentDescription   |

    @VTX-1999
    @AMM-Workflow-BeneficiaryConclude-11
    Scenario Outline: Beneficiary checkerApprover can verify amendment with document source change
        Given beneficiary <Action> amendment for scenario sc11 proceeded by "maker" with following document source
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | advisingBank                         | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's checkerApprover login to main page for scenario sc11
        And beneficiary navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "Amendments"
        Then I open Overview 1
        Then I expect 1 row of the amendment overview to match reference "<Beneficiary Reference>"
        And I click sub side menu sub-option "Amendment 1"
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action   | Beneficiary Reference                  | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | accepted | amendment/beneficiaryAcceptedAmendment | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | accepted | amendment/beneficiaryAcceptedAmendment | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | accepted | amendment/beneficiaryAcceptedAmendment | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | accepted | amendment/beneficiaryAcceptedAmendment | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejected | amendment/beneficiaryRejectedAmendment | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejected | amendment/beneficiaryRejectedAmendment | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejected | amendment/beneficiaryRejectedAmendment | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejected | amendment/beneficiaryRejectedAmendment | amendment/document_source_updateOtherDocumentDescription   |

    @VTX-1999
    @AMM-Workflow-BeneficiaryConclude-12
    Scenario Outline: Beneficiary can present documents to banks with rejected amendment
        Given beneficiary rejected amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
            | advisingBank   | rejected |
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        When I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        When I fill in dp overview with following information for scenario "sc11"
            | Present to | <Present to Party Name> |
        And I fill in dp cover letter by "beneficiary" with following information
            | Instruction              | Payment      |
            | Account number to debit  | 123-456-7890 |
            | Account number to credit | 456-789-0123 |
            | Exchange contract        |              |
            | Other proceeds           |              |
        And I fill in dp other document "Other transport document" with following information
            | Document           | Electronic record                  |
            | Transport document | Document                           |
            | Date of shipment   | 01-09-2025                         |
            | Upload file        | test/support/pdf/pdfAmendment1.pdf |
        And I certify presentation is complete and submit presentation
        Then I can see the dc has dp status "Bank review"

        Examples:
            | Present to Party Name |
            | #CONFIRMING_BANK#     |
            | #NOMINATED_BANK#      |

    @VTX-2004
    @AMM-Workflow-BeneficiaryConclude-13
    Scenario: If beneficiary remain slient, those bank rejected amendment will function same
        Given following bank performed following action for amendment and advisingBank advised amendment for scenario sc11 proceeded by "maker.checkerApprover"
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
        And beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        When I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        And I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        Then I expect the element "dpOverview"."bankSection" to match reference "amendment/beneRemainSilentOtherRejectedBankInfoForDp"


    @VTX-2001
    @AMM-Workflow-BeneficiaryConclude-14
    Scenario: After beneficiary reject amendment, the amendment will become inactive
        Given beneficiary rejected amendment for scenario sc11 proceeded by "maker.checkerApprover" with following banks action
            | confirmingBank | rejected |
            | nominatedBank  | rejected |
            | advisingBank   | rejected |
        Then following parties will see amendment1 as inactive
            | applicant      |
            | beneficiary    |
            | issuingBank    |
            | confirmingBank |
            | advisingBank   |
            | nominatedBank  |

