@DCAmendment
@AMM-Workflow-ConfirmingBank
@VTX-1881
Feature: Amendment workflow (confirming bank)

    As a bank involved in the DC flow,
    I would like to view any amendments issued on the DC and advise or reject each amendments.
    Any rejection by the banks will NOT stop the flow.
    Other banks in the flow will still be able to view and advise the amendments.

    As a requested confirmation party,
    I would like to add confirmation to any amendments that has been issued.

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1996
    @VTX-1997
    @AMM-Workflow-ConfirmingBank-1
    Scenario Outline: Confirming bank can Advise with / without confirmation
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Action Button                   |
            | adviseWithConfirmationButton    |
            | adviseWithoutConfirmationButton |


    @VTX-1998
    @AMM-Workflow-ConfirmingBank-2
    Scenario: Confirming bank can reject amendment after issued
        Given issuingBank issued amendment for scenario sc11 proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."rejectButton" and submit
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

    @VTX-1996
    @VTX-1997
    @AMM-Workflow-ConfirmingBank-3
    Scenario Outline: Confirming bank's checkerApprover can verify advise with / without confirmation
        Given following bank performed following action for amendment and confirmingBank <Action> amendment for scenario sc11 proceeded by "maker"
            |  |  |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."adviseButton" is displayed

        Examples:
            | Action                       |
            | advised with confirmation    |
            | advised without confirmation |


    @VTX-1996
    @VTX-1997
    @AMM-Workflow-ConfirmingBank-4
    Scenario Outline: Confirming bank's checkerApprover can reject advise with / without confirmation
        Given following bank performed following action for amendment and confirmingBank <Action> amendment for scenario sc11 proceeded by "maker"
            |  |  |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

        Examples:
            | Action                       |
            | advised with confirmation    |
            | advised without confirmation |

    @VTX-1998
    @AMM-Workflow-ConfirmingBank-5
    Scenario: Confirming bank checkerApprover can verify reject amendment
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker"
            |  |  |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

    @VTX-1998
    @AMM-Workflow-ConfirmingBank-6
    Scenario: Confirming bank checkerApprover can decline reject amendment
        Given following bank performed following action for amendment and confirmingBank rejected amendment for scenario sc11 proceeded by "maker"
            |  |  |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @VTX-1996
    @VTX-1997
    @AMM-Workflow-ConfirmingBank-7
    Scenario Outline: Confirming bank's maker can advise with / without confirmation with attachment change
        Given issuingBank issued amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover"
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Action Button                   | Original Attachment Number | New Attachment Number | Reference                    |
            | adviseWithConfirmationButton    | 2                          | 2                     | amendment/unchangeAttachment |
            | adviseWithConfirmationButton    | 2                          | 1                     | amendment/removeAttachment   |
            | adviseWithConfirmationButton    | 2                          | 3                     | amendment/addAttachment      |
            | adviseWithoutConfirmationButton | 2                          | 3                     | amendment/addAttachment      |

    @VTX-1996
    @VTX-1997
    @AMM-Workflow-ConfirmingBank-8
    Scenario Outline: Confirming bank checker approver can verify advise with / without confirmation with attachment change
        Given following bank performed following action for amendment and confirmingBank <Action> amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker"
            |  |  |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"

        Examples:
            | Action                       | Original Attachment Number | New Attachment Number | Reference                    |
            | advised with confirmation    | 2                          | 2                     | amendment/unchangeAttachment |
            | advised with confirmation    | 2                          | 1                     | amendment/removeAttachment   |
            | advised with confirmation    | 2                          | 3                     | amendment/addAttachment      |
            | advised without confirmation | 2                          | 3                     | amendment/addAttachment      |

    @Fail
    @VTX-1996
    @VTX-1998
    @AMM-Workflow-ConfirmingBank-9
    Scenario Outline: Confirming bank maker can advise with confirmation / reject amendment with document source change
        Given issuingBank issued amendment for scenario sc11 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action Button                | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | adviseWithConfirmationButton | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | adviseWithConfirmationButton | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | adviseWithConfirmationButton | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | adviseWithConfirmationButton | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejectButton                 | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejectButton                 | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejectButton                 | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejectButton                 | amendment/document_source_updateOtherDocumentDescription   |

    @VTX-1996
    @VTX-1998
    @AMM-Workflow-ConfirmingBank-10
    Scenario Outline: Confirming bank checkerApprover can verify amendment with document source change
        Given following bank performed following action for amendment and confirmingBank <Action> amendment for scenario sc11 with following document source proceeded by "maker"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And confirmingBank's checkerApprover login to main page for scenario sc11
        And confirmingBank navigate to current amendment 1 using contour uuid
        # Then I stop to debug
        When I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action                    | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | advised with confirmation | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | advised with confirmation | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | advised with confirmation | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | advised with confirmation | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejected                  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejected                  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejected                  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejected                  | amendment/document_source_updateOtherDocumentDescription   |
