@DCAmendment
@AMM-EditAndReturn
Feature: Applicant / Beneficiary edit and return

    As QA,
    I would like to check for the workflow for edit and return
    so that applicant / beneficiary can do edit and return

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-2753
    @AMM-EditAndReturn-1 
    Scenario Outline: Review Draft 1: can edit all fields and return to Applicant / Beneficiary
        Given <Initiate Party> created amendment for scenario sc11 submit to <Next Party> proceeded by "admin1"
        And <Next Party>'s admin1 login to main page for scenario sc11
        When <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        And I click on the button "actionButton"."<Action Button 1>"
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                           | Updated2 |
            | Beneficiary                                 |          |
            | Beneficiary Address                         | Updated2 |
            | Issuing Bank                                |          |
            | Issuing Bank Address                        | Updated2 |
            | Allow Issuing Bank To Make Changes Directly |          |
            | Advising Bank                               |          |
            | Advising Bank Address                       | Updated2 |
            | Confirmation Instructions                   |          |
            | Confirming Bank                             |          |
            | Confirming Bank Address                     | Updated2 |
            | Available With Bank                         |          |
            | Available With Bank Address                 | Updated2 |

            | Available By                                 | Payment at sight |
            | Negotiation / Deferred Payment Details       |                  |
            | Drafts At                                    |                  |
            | Drawee Bank                                  |                  |
            | Drawee Bank Address                          |                  |
            | Check Negotiation / Deferred Payment Details |                  |
            | Check Draft At                               |                  |

            | Application Date                     | #TODAY_DATE#       |
            | Form Of Documentary Credit           | Irrevocable        |
            | Applicable Rules                     | UCP latest version |
            | Selected Currency                    |                    |
            | Amount                               | 30 000.00          |
            | Max Tolerance (Optional)             | 50.00              |
            | Min Tolerance (Optional)             | 50.00              |
            | Additional Amount Covered (Option)   | Updated2           |
            | Description Of Goods And/Or Services | Updated2           |
            | Expiry Date (YY/MM/DD)               | 2025-01-02         |
            | Expiry Place                         | Updated2           |

            | Partial Shipments (optional) | Conditional |
            | Transhipment (optional)      | Allowed     |

            | Shipment Date / Period  | Shipment period |
            | Latest Date Of Shipment |                 |

            | Shipment Period                                                                   | 50       |

            | Period Of Presentation                                                            | 100      |
            | Type Of Presentation                                                              | Updated2 |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Updated2 |
            | Port Of Loading / Airport Of Departure (optional)                                 | Updated2 |
            | Port Of Discharge / Airport Of Destination (optional)                             | Updated2 |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Updated2 |
        And I click on the button "actionButton"."<Action Button 2>" and submit
        And <Initiate Party>'s maker login to main page for scenario sc11
        And <Initiate Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I can see amendment draft text right column with following values
            | Applicant Address                                                      | Updated2     |
            | Beneficiary Address                                                    | Updated2     |
            | Issuing Bank Address                                                   | Updated2     |
            | Advising Bank Address                                                  | Updated2     |
            | Requested Confirmation Party Address                                   | Updated2     |
            | Nominated Bank Address                                                 | Updated2     |
            | Amount                                                                 | USD 30000.00 |
            | Tolerance                                                              | +50% to -50% |
            | Additional amount covered (optional)                                   | Updated2     |
            | Expiry Date                                                            | 25/01/02     |
            | Expiry Place                                                           | Updated2     |
            | Partial Shipments                                                      | Conditional  |
            | Transhipment                                                           | Allowed      |
            | Shipment Period                                                        | 50           |
            | Description of Goods and / or Services                                 | Updated2     |
            | Period of Presentation                                                 | 100          |
            | Type of Presentation                                                   | Updated2     |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Updated2     |
            | Port of Loading / Airport of Departure                                 | Updated2     |
            | Port of Discharge / Airport of Destination                             | Updated2     |
            | Place of Final Destination / For Transportation to / Place of Delivery | Updated2     |
        And I can see amendment draft text left column with following values for sc11
            | Applicant Address                                                      | #APPLICANT_ADDRESS#                                                               |
            | Beneficiary Address                                                    | #BENEFICIARY_ADDRESS#                                                             |
            | Issuing Bank Address                                                   | #ISSUING_BANK_ADDRESS#                                                            |
            | Advising Bank Address                                                  | #ADVISING_BANK_ADDRESS#                                                           |
            | Requested Confirmation Party Address                                   | #CONFIRMING_BANK_ADDRESS#                                                         |
            | Nominated Bank Address                                                 | #NOMINATED_BANK_ADDRESS#                                                          |
            | Amount                                                                 | USD 10000.00                                                                      |
            | Tolerance                                                              | +15% to -5%                                                                       |
            | Additional amount covered (optional)                                   | Additional Amount Covered (Option)                                                |
            | Expiry Date                                                            | #RANDOM_DATE (YY/MM/DD)#                                                          |
            | Expiry Place                                                           | Hong Kong                                                                         |
            | Partial Shipments                                                      | Allowed                                                                           |
            | Transhipment                                                           | Not allowed                                                                       |
            | Shipment Period                                                        | 12                                                                                |
            | Description of Goods and / or Services                                 | Automation                                                                        |
            | Period of Presentation                                                 | 123                                                                               |
            | Type of Presentation                                                   | 123                                                                               |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port of Loading / Airport of Departure                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port of Discharge / Airport of Destination                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place of Final Destination / For Transportation to / Place of Delivery | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |

        Examples:
            | Initiate Party | Next Party  | Action Button 1 | Action Button 2         |
            | applicant      | beneficiary | editButton      | returnButton            |
            | beneficiary    | applicant   | editButton      | sendToBeneficiaryButton |

    @AMM-EditAndReturn-2
    Scenario Outline: Checker-approver can verify beneficiary / applicant's edited and returned amendment
        Given <Current Party> edited and returned amendment for scenario sc11 proceeded by "maker"
        And <Current Party>'s checkerApprover login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        And I click on the button "actionButton"."verifyButton" and confirm
        And <Next Party>'s maker login to main page for scenario sc11
        And <Next Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I can see amendment draft text right column with following values
            | Applicant Address                                                      | Updated2     |
            | Beneficiary Address                                                    | Updated2     |
            | Issuing Bank Address                                                   | Updated2     |
            | Advising Bank Address                                                  | Updated2     |
            | Requested Confirmation Party Address                                   | Updated2     |
            | Nominated Bank Address                                                 | Updated2     |
            | Amount                                                                 | USD 30000.00 |
            | Tolerance                                                              | +50% to -50% |
            | Additional amount covered (optional)                                   | Updated2     |
            | Expiry Date                                                            | 25/01/02     |
            | Expiry Place                                                           | Updated2     |
            | Partial Shipments                                                      | Conditional  |
            | Transhipment                                                           | Allowed      |
            | Shipment Period                                                        | 50           |
            | Description of Goods and / or Services                                 | Updated2     |
            | Period of Presentation                                                 | 100          |
            | Type of Presentation                                                   | Updated2     |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Updated2     |
            | Port of Loading / Airport of Departure                                 | Updated2     |
            | Port of Discharge / Airport of Destination                             | Updated2     |
            | Place of Final Destination / For Transportation to / Place of Delivery | Updated2     |
        And I can see amendment draft text left column with following values for sc11
            | Applicant Address                                                      | #APPLICANT_ADDRESS#                                                               |
            | Beneficiary Address                                                    | #BENEFICIARY_ADDRESS#                                                             |
            | Issuing Bank Address                                                   | #ISSUING_BANK_ADDRESS#                                                            |
            | Advising Bank Address                                                  | #ADVISING_BANK_ADDRESS#                                                           |
            | Requested Confirmation Party Address                                   | #CONFIRMING_BANK_ADDRESS#                                                         |
            | Nominated Bank Address                                                 | #NOMINATED_BANK_ADDRESS#                                                          |
            | Amount                                                                 | USD 10000.00                                                                      |
            | Tolerance                                                              | +15% to -5%                                                                       |
            | Additional amount covered (optional)                                   | Additional Amount Covered (Option)                                                |
            | Expiry Date                                                            | #RANDOM_DATE (YY/MM/DD)#                                                          |
            | Expiry Place                                                           | Hong Kong                                                                         |
            | Partial Shipments                                                      | Allowed                                                                           |
            | Transhipment                                                           | Not allowed                                                                       |
            | Shipment Period                                                        | 12                                                                                |
            | Description of Goods and / or Services                                 | Automation                                                                        |
            | Period of Presentation                                                 | 123                                                                               |
            | Type of Presentation                                                   | 123                                                                               |
            | Place of Taking in Charge / Dispatch form / Place of Receipt           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port of Loading / Airport of Departure                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port of Discharge / Airport of Destination                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place of Final Destination / For Transportation to / Place of Delivery | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |

        Examples:
            | Current Party | Next Party  |
            | beneficiary   | applicant   |
            | applicant     | beneficiary |

    @AMM-EditAndReturn-3
    Scenario Outline: Checker-approver can reject beneficiary / applicant's edited and returned amendment
        Given <Current Party> edited and returned amendment for scenario sc11 proceeded by "maker"
        And <Current Party>'s checkerApprover login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        When I click on the button "actionButton"."declineButton" and confirm
        And <Current Party>'s maker login to main page for scenario sc11
        And <Current Party> navigate to current dc using contour uuid
        Then I open Draft Text 1
        Then I expect that element "actionButton"."updateButton" is displayed

        Examples:
            | Current Party |
            | beneficiary   |
            | applicant     |