@DCAmendment
@VTX-1881
@AMM-Workflow-NominatedBank
Feature: Amendment workflow (nominated bank)

    As a bank involved in the DC flow,
    I would like to view any amendments issued on the DC and advise or reject each amendments.
    Any rejection by the banks will NOT stop the flow.
    Other banks in the flow will still be able to view and advise the amendments.

    As a Nominated bank/ Advising bank involved in the DC flow, 
    I would like to view any amendments issued on the DC and advise the amendments to the next party.

    Background: Set up scenario context
        Given I setup test scenario context

    @VTX-1994
    @AMM-Workflow-NominatedBank-1
    Scenario: Nominated bank can advise
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."adviseButton" and submit
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

    @VTX-1994
    @AMM-Workflow-NominatedBank-2
    Scenario: Nominated bank checker-approver can verify advise amendment
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker"
            | confirmingBank | advised with confirmation |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

    @VTX-1994
    @AMM-Workflow-NominatedBank-3
    Scenario: Nominated bank checker-approver reject advise amendment
        Given following bank performed following action for amendment and nominatedBank advised amendment for scenario sc11 proceeded by "maker"
            | confirmingBank | advised with confirmation |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

    @VTX-1995
    @AMM-Workflow-NominatedBank-4
    Scenario Outline: Nominated bank can reject amendment after confirming bank accept / reject amendment
        Given following bank performed following action for amendment and confirmingBank <Previous Party Action> amendment for scenario sc11 proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."rejectButton" and submit
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Previous Party Action     |
            | advised with confirmation |
            | rejected                  |

    @VTX-1995
    @AMM-Workflow-NominatedBank-5
    Scenario Outline: Nominated bank checkerApprover can verify reject amendment
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker"
            | confirmingBank | <Confirming Bank Action> |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        Then I can see the dc has amendment sub status "Advising bank to review"
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

        Examples:
            | Confirming Bank Action    |
            | advised with confirmation |
            | rejected                  |

    @VTX-1995
    @AMM-Workflow-NominatedBank-6
    Scenario Outline: Nominated bank checkerApprover can reject reject amendment
        Given following bank performed following action for amendment and nominatedBank rejected amendment for scenario sc11 proceeded by "maker"
            | confirmingBank | <Confirming Bank Action> |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."declineButton" and confirm
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        Then I expect that element "actionButton"."updateButton" is displayed
        And I expect that element "actionButton"."discardButton" is displayed

        Examples:
            | Confirming Bank Action    |
            | advised with confirmation |
            | rejected                  |

    @VTX-1994
    @VTX-1995
    @AMM-Workflow-NominatedBank-7
    Scenario Outline: Nominated bank can advise / reject amendment with attachment change
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker.checkerApprover"
            |  |  |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed


        Examples:
            | Original Attachment Number | New Attachment Number | Action Button | Reference                    |
            | 2                          | 2                     | adviseButton  | amendment/unchangeAttachment |
            | 2                          | 1                     | adviseButton  | amendment/removeAttachment   |
            | 2                          | 3                     | adviseButton  | amendment/addAttachment      |
            | 2                          | 2                     | rejectButton  | amendment/unchangeAttachment |
            | 2                          | 1                     | rejectButton  | amendment/removeAttachment   |
            | 2                          | 3                     | rejectButton  | amendment/addAttachment      |

    @VTX-1994
    @VTX-1995
    @AMM-Workflow-NominatedBank-8
    Scenario Outline: Nominated bank checker approver can verify advise / reject amendment with attachment update
        Given following bank performed following action for amendment and nominatedBank <Action> amendment for scenario sc11 with original <Original Attachment Number> attachment and updated <New Attachment Number> attachment proceeded by "maker"
            | confirmingBank | advised with confirmation |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        And I scroll to element "dcForm"."attachmentsContainer"
        Then I expect the element "dcForm"."attachmentsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed


        Examples:
            | Original Attachment Number | New Attachment Number | Action   | Reference                    |
            | 2                          | 2                     | advised  | amendment/unchangeAttachment |
            | 2                          | 1                     | advised  | amendment/removeAttachment   |
            | 2                          | 3                     | advised  | amendment/addAttachment      |
            | 2                          | 2                     | rejected | amendment/unchangeAttachment |
            | 2                          | 1                     | rejected | amendment/removeAttachment   |
            | 2                          | 3                     | rejected | amendment/addAttachment      |

    @VTX-1994
    @VTX-1995
    @AMM-Workflow-NominatedBank-9
    Scenario Outline: Nominated bank maker can advise / reject amendment with document source change
        Given following bank performed following action for amendment and confirmingBank advised with confirmation amendment for scenario sc11 with following document source proceeded by "maker.checkerApprover"
            | field                                | value                                           | updatedValue                                   |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."<Action Button>" and submit
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."verifyButton" is displayed
        And I expect that element "actionButton"."declineButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action Button | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | adviseButton  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | adviseButton  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | adviseButton  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | adviseButton  | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejectButton  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejectButton  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejectButton  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejectButton  | amendment/document_source_updateOtherDocumentDescription   |

    @VTX-1994
    @VTX-1995
    @AMM-Workflow-NominatedBank-10
    Scenario Outline: Nominated bank checkerApprover can verify amendment with document source change
        Given following bank performed following action for amendment and nominatedBank <Action> amendment for scenario sc11 with following document source proceeded by "maker"
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And nominatedBank's checkerApprover login to main page for scenario sc11
        And nominatedBank navigate to current amendment 1 using contour uuid
        When I click on the button "actionButton"."verifyButton" and confirm
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current amendment 1 using contour uuid
        And I scroll to element "amendmentDraftText"."dcDetailsContainer"
        And I pause for 2500ms
        Then I expect the element "amendmentDraftText"."dcDetailsContainer" to match reference "<Reference>"
        And I expect that element "actionButton"."adviseButton" is displayed
        And I expect that element "actionButton"."rejectButton" is displayed

        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions                            | Action   | Reference                                                  |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | advised  | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | advised  | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | advised  | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | advised  | amendment/document_source_updateOtherDocumentDescription   |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 3                                     | Other Doc 1,Other Doc 2,Other Doc 3   | Other Doc Description 1,Other Doc Description 2,Other Doc Description 3 | rejected | amendment/document_source_addOtherDocument                 |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Updated                     | Updated                                | Updated                                   | Updated                          | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description 1,Other Doc Description 2                         | rejected | amendment/document_source_changeDocumentSource_Description |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                                                 | rejected | amendment/document_source_removeOtherDocument              |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 2                                     | Other Doc 1,Other Doc 2               | Other Doc Description Updated 1, Other Doc Description Updated 2        | rejected | amendment/document_source_updateOtherDocumentDescription   |

