Feature: DC Cancellation SC11 (Beneficiary initiates cancellation, nominated bank rejects cancellation)
    As a QA, I want to test sc11 - (nominated bank in version 7.0)

    Scenario: Applicant creates a DC
        Given I setup custom test scenario context
            | partyRole      | party |
            | applicant      | corpa |
            | issuingBank    | banka |
            | confirmingBank | bankc |
            | nominatedBank  | banke |
            | advisingBank   | bankb |
            | beneficiary    | corpb |
        Given advising bank advised dc for scenario sc11

    Scenario: Beneficiary initiates request for cancellation
        And beneficiary admin1 login and open current dc
        And I am at New p2p message under DC
        And I select message type as Request for cancellation
        When I set "Cancellation" to the inputfield "p2pMessage"."cancellationMessage"
        And I click on the button "p2pMessage"."sendButton"
        And I click on the button "sendMessagePopup"."confirmButton"
        Then the element "p2pMessage"."sendButton" does not exist

    Scenario Outline: All parties verify request for cancellation message except issuing bank
        Given <party> admin1 login and open current dc
        And I am at New p2p message under DC
        When I open p2p message which has subject "Request for cancellation" from listing
        And I click on the button "p2pMessage"."approveButton"
        And I click on the button "p2pMessage"."confirmApproveButton"
        Then the element "p2pMessage"."confirmApproveButton" does not exist
        Then the element "p2pMessage"."approveButton" does not exist
        Examples:
            | party          |
            | applicant      |
            | confirmingBank |
            | advising Bank  |
            | issuingBank    |

    Scenario: Nominated Bank declines request for cancellation
        And nominatedBank admin1 login and open current dc
        And I am at New p2p message under DC
        When I open p2p message which has subject "Request for cancellation" from listing
        And I click on the button "p2pMessageView"."rejectRequestButton"
        And I click on the button "p2pMessageView"."confirmApproveButton"
        Then I can view body of Request for cancellation and see the following messages
            | UI Type        | Message                            |
            | #OTHER_BUBBLE# | DC cancellation has been rejected. |
