Feature: DC Issuance E2E sc11 (mixed node versions)
    As a QA, I want to test sc11 - (Advising Bank in version 7.0)

    Scenario: Applicant creates a DC
        Given I setup custom test scenario context
            | partyRole      | party |
            | applicant      | corpa |
            | issuingBank    | banka |
            | confirmingBank | bankc |
            | nominatedBank  | bankd |
            | advisingBank   | banke |
            | beneficiary    | corpb |
        Given applicant created dc for scenario sc11 proceeded by "admin1"

    Scenario: Issuing bank advise DC
        When issuingBank's admin1 login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."issueButton"
        When I set "BWC_DI_5" to the inputfield "dcForm"."issuedDcRefenceInput"
        And I set "Additional clause from issuing bank" to the inputfield "dcForm"."additionalConditionsFromIssuingBankInput"
        And I set "Instructions to paying bank" to the inputfield "dcForm"."instructionToPayingBankInput"
        And I click on the button "actionButton"."previewButton" and submit
        Then I can see the dc has main status "Issued"

    Scenario: Confirm bank advise with confirmation
        And confirmingBank's admin1 login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseWithoutConfirmationButton"
        When I set "BWC_DI_5" to the inputfield "dcForm"."confirmedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        Then I can see the dc has main status "Issued and advised"


    Scenario: Nominated bank advise DC
        And nominatedBank's admin1 login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseButton"
        When I set "BWC_DI_5" to the inputfield "dcForm"."nominatedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        Then I can see the dc has main status "Issued and advised"

    Scenario: Advising bank advise DC
        And advisingBank's admin1 login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseButton"
        When I set "BWC_DI_5" to the inputfield "dcForm"."advisedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        Then I can see the dc has main status "Issued and advised"