Feature: Applicant create DC sc1

    As a QA,
    I want to create DC with document source and check for each step
    so that DC can be submitted with expected document source
    Background: Set up scenario context
        Given I setup test scenario context

    @ISS_DOCSRC_C1T1
    Scenario: Applicant create DC for SC1
        Given applicant's maker login to main page for scenario sc1
        And I navigate to create dc page
        And I fill in dc for scenario sc1 with following values
            | Applicant Address                           | #APPLICANT_ADDRESS#     |
            | Beneficiary                                 | #BENEFICIARY#           |
            | Beneficiary Address                         | #BENEFICIARY_ADDRESS#   |
            | Issuing Bank                                | #ISSUING_BANK#          |
            | Issuing Bank Address                        | #ISSUING_BANK_ADDRESS#  |
            | Allow Issuing Bank To Make Changes Directly |                         |
            | Advising Bank                               | #ADVISING_BANK#         |
            | Advising Bank Address                       | #ADVISING_BANK_ADDRESS# |

            | Confirmation Instructions | Without |
            # | Confirming Bank             | #CONFIRMING_BANK#         |
            # | Confirming Bank Address     | #CONFIRMING_BANK_ADDRESS# |

            | Available By Negotiation | Check |

            # | Check Negotiation Payment Details | Check                                  |
            # | Negotiation Payment Details       | Negotiation / Deferred Payment Details |
            | Check Drafts At | Check                 |
            | Drafts At       | Negotiation Drafts At |

            | Negotiation Drawee Bank         | #BANKA#                         |
            | Negotiation Drawee Bank Address | #BANKA_ADDRESS#                 |
            | Available By Payment Conditions | Available By Payment Conditions |

            | Available With Bank         | #NOMINATED_BANK#         |
            | Available With Bank Address | #NOMINATED_BANK_ADDRESS# |

            | Applicable Rules                   | eUCP latest version                |
            | Selected Currency                  | USD                                |
            | Amount                             | 10000.00                           |
            | Max Tolerance (Optional)           | 15.00                              |
            | Min Tolerance (Optional)           | 5.00                               |
            | Additional Amount Covered (Option) | Additional Amount Covered (Option) |
            | Expiry Date (YY/MM/DD)             | #RANDOM_DATE#                      |
            | Expiry Place                       | Hong Kong                          |

            | Partial Shipments (optional) | Allowed     |
            | Transhipment (optional)      | Not allowed |

            | Shipment Date / Period  | Latest date of shipment |
            | Latest Date Of Shipment | 2021-04-10              |

            # | Shipment Date / Period | Shipment period |
            # | Shipment Period        |                 |

            | Description Of Goods And/Or Services | Automation |

            | Period Of Presentation                                                            | 123                                                                               |
            | Type Of Presentation                                                              | 123                                                                               |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port Of Loading / Airport Of Departure (optional)                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port Of Discharge / Airport Of Destination (optional)                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |
        And I fill in document source with following values
            | Tick - Transport Document            | Tick                                            |
            | Tick - Certificate of Origin         | Tick                                            |
            | Tick - Packing List                  | Tick                                            |
            | Select Transport Document            | Others, please specify                          |
            | Other Transport Document             | Other Transport Document                        |
            | Invoice Description                  | Invoice Description                             |
            | Transport Document Description       | Transport Document Description                  |
            | Certificate of Origin Description    | Certificate of Origin Description               |
            | Packing List Description             | Packing List Description                        |
            | Other Required Document Count        | 2                                               |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc1
        And applicant navigate to current dc using unique expiry date
        Then I expect the document to match reference "create_dc/sc1"
