Feature: DC Issuance (DC Form) Feature

    As a user, I want to see the DC form with correct format and option

    Background: Set up scenario context
        Given I setup test scenario context

    Scenario: Create DC from UI
        Given applicant's maker login to main page for scenario sc5
        And I navigate to create dc page
        And I fill in dc for scenario sc5 with following values
            | Applicant Address                           | #APPLICANT_ADDRESS#       |
            | Beneficiary                                 | #BENEFICIARY#             |
            | Beneficiary Address                         | #BENEFICIARY_ADDRESS#     |
            | Issuing Bank                                | #ISSUING_BANK#            |
            | Issuing Bank Address                        | #ISSUING_BANK_ADDRESS#    |
            | Allow Issuing Bank To Make Changes Directly |                           |
            | Advising Bank                               | #ADVISING_BANK#           |
            | Advising Bank Address                       | #ADVISING_BANK_ADDRESS#   |
            | Confirmation Instructions                   | Confirm                   |
            | Confirming Bank                             | #CONFIRMING_BANK#         |
            | Confirming Bank Address                     | #CONFIRMING_BANK_ADDRESS# |
            | Available With Bank                         | #NOMINATED_BANK#          |
            | Available With Bank Address                 | #NOMINATED_BANK_ADDRESS#  |

            | Available By Payment At Sight     | Check                                  |
            | Available By Deferred Payment     | Check                                  |
            | Deferred Payment Details          | Deferred Payment Details               |
            | Available By Acceptance           | Check                                  |
            | Acceptance Draft At               | 123                                    |
            | Acceptance Drawee Bank            | #BANKB#                                |
            | Available By Negotiation          | Check                                  |
            | Check Negotiation Payment Details | Check                                  |
            | Negotiation Payment Details       | Negotiation / Deferred Payment Details |
            # | Negotiation Drafts At Check | Check                 |
            # | Negotiation Drafts At       | Negotiation Drafts At |
            # | Negotiation Drawee Bank         | #BANKA#                         |
            # | Negotiation Drawee Bank Address | #BANKA_ADDRESS#                 |
            | Available By Payment Conditions   | Available By Payment Conditions        |
            | Available With Bank               | #NOMINATED_BANK#                       |
            | Available With Bank Address       | #NOMINATED_BANK_ADDRESS#               |

            | Applicable Rules                     | eUCP latest version |
            | Selected Currency                    | USD                 |
            | Amount                               | 10000.00            |
            | Max Tolerance (Optional)             | 15.00               |
            | Min Tolerance (Optional)             | 5.00                |
            | Additional Amount Covered (Option)   |                     |
            | Description Of Goods And/Or Services | Automation          |
            | Expiry Date (YY/MM/DD)               | #RANDOM_DATE#       |
            | Expiry Place                         | Hong Kong           |

            | Partial Shipments (optional) | Allowed     |
            | Transhipment (optional)      | Not allowed |

            | Shipment Date / Period  | Latest date of shipment |
            | Latest Date Of Shipment | 2021-04-10              |

            | Shipment Period | 12 |

            | Period Of Presentation                                                            | 123 |
            | Type Of Presentation                                                              | 123 |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | 123 |
            | Port Of Loading / Airport Of Departure (optional)                                 | 123 |
            | Port Of Discharge / Airport Of Destination (optional)                             | 123 |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | 123 |
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario sc5
        And applicant navigate to current dc using unique expiry date
        Then I expect the document to match reference "create_dc/sc5"
