Feature: DC Issuance (Happy) Feature

    As a QA,
    I want to create DC and check each steps
    so that DC can be submitted with expected value

    Background: Clear random date and setup test scenario context
        Given I setup test scenario context
    #Pending on local - missing NOMINATED_BANK
    @ISS_FLOW_C1T2
    Scenario Outline: Create dc from UI by applicant
        Given applicant's maker login to main page for scenario <Dc Scenario>
        And I navigate to create dc page
        And I fill in dc for scenario <Dc Scenario> with following values
            | Applicant Address                           | #APPLICANT_ADDRESS#         |
            | Beneficiary                                 | #BENEFICIARY#               |
            | Beneficiary Address                         | #BENEFICIARY_ADDRESS#       |
            | Issuing Bank                                | #ISSUING_BANK#              |
            | Issuing Bank Address                        | #ISSUING_BANK_ADDRESS#      |
            | Allow Issuing Bank To Make Changes Directly |                             |
            | Advising Bank                               | #ADVISING_BANK#             |
            | Advising Bank Address                       | #ADVISING_BANK_ADDRESS#     |
            | Confirmation Instructions                   | <Confirmation Instructions> |
            | Confirming Bank                             | #CONFIRMING_BANK#           |
            | Confirming Bank Address                     | #CONFIRMING_BANK_ADDRESS#   |
            | Available With Bank                         | #NOMINATED_BANK#            |
            | Available With Bank Address                 | #NOMINATED_BANK_ADDRESS#    |

            | Available By                                 | Negotiation                            |
            | Negotiation / Deferred Payment Details       | Negotiation / Deferred Payment Details |
            | Drafts At                                    | Drafts At                              |
            | Drawee Bank                                  | #BANKA#                                |
            | Drawee Bank Address                          | #BANKA_ADDRESS#                        |
            | Check Negotiation / Deferred Payment Details | Check                                  |
            | Check Draft At                               |                                        |

            | Applicable Rules                     | eUCP latest version                |
            | Selected Currency                    | USD                                |
            | Amount                               | 10000.00                           |
            | Max Tolerance (Optional)             | 15.00                              |
            | Min Tolerance (Optional)             | 5.00                               |
            | Additional Amount Covered (Option)   | Additional Amount Covered (Option) |
            | Description Of Goods And/Or Services | Automation                         |
            | Expiry Date (YY/MM/DD)               | #RANDOM_DATE#                      |
            | Expiry Place                         | Hong Kong                          |

            | Partial Shipments (optional) | Allowed     |
            | Transhipment (optional)      | Not allowed |

            | Shipment Date / Period  | Latest date of shipment |
            | Latest Date Of Shipment | 2021-04-10              |

            | Shipment Period                                                                   |                                                                                   |

            | Period Of Presentation                                                            | 123                                                                               |
            | Type Of Presentation                                                              | 123                                                                               |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port Of Loading / Airport Of Departure (optional)                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port Of Discharge / Airport Of Destination (optional)                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |
                And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And applicant's checkerApprover login to main page for scenario <Dc Scenario>
        And applicant navigate to current dc using unique expiry date
        Then I can see the page as following screenshots
            | page   | element                  | refImage                                                 |
            | dcForm | corporatesContainer      | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/corporatesContainer      |
            | dcForm | banksContainer           | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/banksContainer           |
            | dcForm | keyTermsContainer        | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/keyTermsContainer        |
            | dcForm | shipmentDetailsContainer | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/shipmentDetailsContainer |
            | dcForm | dcDetailsContainer       | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/dcDetailsContainer       |
            | dcForm | attachmentsContainer     | dc_issuance_happy/ISS_FLOW_C1T2/<Dc Scenario>/attachmentsContainer     |
        Examples:
            | Dc Scenario | Confirmation Instructions |
            | sc1         | Without                   |
            | sc5         | Confirm                   |
            | sc11        | May add                   |
