Feature: Document source for DC Issuance (Happy flow) Issuing Bank

  As a QA,
  I want to create DC with document source and check for each step
  so that DC can be submitted with expected document source
  Background: Set up scenario context
    Given I setup test scenario context

  @ISS_DOCSRC_C1T4 @https://contour.atlassian.net/browse/VTX-6563
  Scenario: Issuing Bank checker-approver can verify with document source
    Given issuingBank issued dc for scenario sc1 with following document source proceeded by "maker"
      | field                                | value                                           |
      | Tick - Transport Document            | Tick                                            |
      | Tick - Certificate of Origin         | Tick                                            |
      | Tick - Packing List                  | Tick                                            |
      | Select Transport Document            | Others, please specify                          |
      | Other Transport Document             | Other Transport Document                        |
      | Invoice Description                  | Invoice Description                             |
      | Transport Document Description       | Transport Document Description                  |
      | Certificate of Origin Description    | Certificate of Origin Description               |
      | Packing List Description             | Packing List Description                        |
      | Other Required Document Count        | 2                                               |
      | Other Required Document Names        | Other Doc 1,Other Doc 2                         |
      | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 |
    And issuingBank's checkerApprover login to main page for scenario sc1
    And issuingBank navigate to current dc using contour uuid
    When I click on the button "actionButton"."verifyButton"
    And I click on the button "actionButton"."confirmButton"
    And I expect that element "actionButton"."verifyButton" does not exist
    And advisingBank's maker login to main page for scenario sc1
    And advisingBank navigate to current dc using contour uuid
    Then I can see the page as following screenshots
      | page   | element                   | refImage                                                    |
      | dcForm | corporatesContainer       | dc_documentSource/ISS_DOCSRC_C1T4/corporatesContainer       |
      | dcForm | banksContainer            | dc_documentSource/ISS_DOCSRC_C1T4/banksContainer            |
      | dcForm | keyTermsContainer         | dc_documentSource/ISS_DOCSRC_C1T4/keyTermsContainer         |
      | dcForm | shipmentDetailsContainer  | dc_documentSource/ISS_DOCSRC_C1T4/shipmentDetailsContainer  |
      | dcForm | dcDetailsContainer        | dc_documentSource/ISS_DOCSRC_C1T4/dcDetailsContainer        |
      | dcForm | attachmentsContainer      | dc_documentSource/ISS_DOCSRC_C1T4/attachmentsContainer      |
      | dcForm | internalCommentsContainer | dc_documentSource/ISS_DOCSRC_C1T4/internalCommentsContainer |

