Feature: Verify file attachment size and types while Beneficiary initiates Presentation
    As a QA, I want to test the attachment size limit and file type for a DP. This includes testing of malicious

    Scenario Outline: Beneficiary initiates presentation with multiple attachments and different file types
        Given I setup test scenario context
        Given beneficiary accepted amendment for scenario sc11 proceeded by "admin1" with following document source
            | field                                | value                                           | updatedValue                                   |
            | confirmingBank                       | advised with confirmation                       |                                                |
            | nominatedBank                        | advised                                         |                                                |
            | advisingBank                         | advised                                         |                                                |
            | Tick - Transport Document            | Tick                                            | <Updated Tick - Transport Document>            |
            | Tick - Certificate of Origin         | Tick                                            | <Updated Tick - Certificate of Origin>         |
            | Tick - Packing List                  | Tick                                            | <Updated Tick - Packing List>                  |
            | Select Transport Document            | Others, please specify                          | <Updated Select Transport Document>            |
            | Other Transport Document             | Other Transport Document                        | <Updated Other Transport Document>             |
            | Invoice Description                  | Invoice Description                             | <Updated Invoice Description>                  |
            | Transport Document Description       | Transport Document Description                  | <Updated Transport Document Description>       |
            | Certificate of Origin Description    | Certificate of Origin Description               | <Updated Certificate of Origin Description>    |
            | Packing List Description             | Packing List Description                        | <Updated Packing List Description>             |
            | Other Required Document Count        | 2                                               | <Updated Other Required Document Count>        |
            | Other Required Document Names        | Other Doc 1,Other Doc 2                         | <Updated Other Required Document Names>        |
            | Other Required Document Descriptions | Other Doc Description 1,Other Doc Description 2 | <Updated Other Required Document Descriptions> |
        And beneficiary's maker login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        And I click sub side menu option "DC"
        And I click sub side menu sub-option "DC form"
        When I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        When I fill in dp overview with following information for scenario "sc11"
            | Drawing Amount  | 10000            |
            | Present to      | #NOMINATED_BANK# |
            | Present through | #ADVISING_BANK#  |
        And I click on the button "actionButton"."saveAndNextButton"
        And I fill in dp cover letter by "beneficiary" with following information
            | Instruction | Payment |
        And I click sub side menu sub-option "Invoice"
        When I set "100001" to the inputfield "dpInvoice"."amount"
        And I upload "test/util/pdf/6.9.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        #1. Uploading 1 pdf file  > 7MB
        Then the element "dpInvoice"."fileAttachmentSizeError" contains the text "The file(s) you’re trying to upload exceeds the 7 MB limit. Please reduce the total size of the file(s) and try again."

        And I upload "test/util/pdf/2009.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I upload "test/util/pdf/3884$#%@^&!878.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I upload "test/util/pdf/dpInvoiceamountTestUSD273.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I upload "test/util/pdf/PNG1_7KB.png" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I upload "test/util/pdf/Dejav878.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        Then I can see the following attachment and remove button with following values
            | 2009.pdf                      | DISPLAYED |
            | 3884$#%@^&!878.pdf            | DISPLAYED |
            | dpInvoiceamountTestUSD273.pdf | DISPLAYED |
        #2.Uploading multiple pdf files and PNG file for invoice with total size  > 7MB
        Then the element "dpInvoice"."fileAttachmentSizeError" contains the text "The file(s) you’re trying to upload exceeds the 7 MB limit. Please reduce the total size of the file(s) and try again."
        And I click on the button "dpInvoice"."addInvoiceButton"
        When I set "20001" to the inputfield "dpInvoice"."amount"
        And I upload "test/util/pdf/pdfDc2.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I click on the button "actionButton"."saveAndNextButton"
        #3.Uploading pdf files > 7MB in total across DP
        And I fill in dp other document "Transport Document" with following information
            | Document           | Electronic record                    |
            | Transport document | Document                             |
            | Date of shipment   | 01-09-2021                           |
            | Port of loading    | Automation testing loading           |
            | Port of discharge  | Automation testing loading discharge |
            | Upload file        | test/util/pdf/pdfAmendment1.pdf      |
        And I fill in dp certificate of origin "Certificate of origin" with following information
            | Document           | Electronic record                    |
            | Transport document | Certificate of origin                |
            | Date of shipment   | 01-09-2021                           |
            | Port of loading    | Automation testing loading           |
            | Port of discharge  | Automation testing loading discharge |
            | Upload file        | test/util/pdf/6.6.pdf                |

        And I fill in dp packing list "Packing List" with following information
            | Document           | Electronic record                    |
            | Transport document | Packing List                         |
            | Date of shipment   | 01-09-2021                           |
            | Port of loading    | Automation testing loading           |
            | Port of discharge  | Automation testing loading discharge |
            | Upload file        | test/util/pdf/pdfAmendment3.pdf      |

        And I fill in dp packing list "Other Doc 1" with following information
            | Document           | Electronic record                    |
            | Transport document | Packing List                         |
            | Date of shipment   | 01-09-2021                           |
            | Port of loading    | Automation testing loading           |
            | Port of discharge  | Automation testing loading discharge |
            | Upload file        | test/util/pdf/pdfAmendment3.pdf      |

        Then the element "actionButton"."submitPresentationButton" is not enabled
        And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
        And I click on the button "actionButton"."submitPresentationButton"
        Then the element "dpInvoice"."totalAttachmentSizeError" contains the text "Total attachment size for a presentation should not exceed 7 MB."
        And I click sub side menu sub-option "Invoice"
        When I remove 1 row of attachment
        And I click on the button "actionButton"."saveAndNextButton"
        And I click sub side menu sub-option "Certificate of origin"
        #4.Test pdf with embedded content
        When I remove 1 row of attachment
        And I upload "test/util/pdf/embed800.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I click on the button "actionButton"."saveAndNextButton"
        And I click on the button "actionButton"."submitPresentationButton"
        Then the element "dpInvoice"."embeddedFileError" contains the text "Attachment(s) failed to upload. PDF document has embedded attachments."
        And I click sub side menu sub-option "Certificate of origin"
        When I remove 1 row of attachment
        And I upload "test/util/pdf/pdf-example-password.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I click on the button "actionButton"."saveAndNextButton"
        And I click on the button "actionButton"."submitPresentationButton"
        Then the element "dpInvoice"."passwordProtectedError" contains the text "Attachment(s) failed to upload. PDF document is password protected."
        And I click sub side menu sub-option "Certificate of origin"
        #5.Test pdf upload with embedded script
        When I remove 1 row of attachment
        And I upload "test/util/pdf/embeddedjs.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I click on the button "actionButton"."saveAndNextButton"
        And I click on the button "actionButton"."submitPresentationButton"
        Then the element "dpInvoice"."embeddedJavaScriptError" contains the text "Attachment(s) failed to upload. PDF document has embedded javascript."
        And I click sub side menu sub-option "Certificate of origin"
        When I remove 1 row of attachment
        And I upload "test/util/pdf/pdfAmendment3.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
        And I click on the button "actionButton"."saveAndNextButton"
        And I click on the button "actionButton"."submitPresentationButton"
        And I scroll to and click element "actionButton"."submitButton"
        Then I pause for 6000ms
        Then I can see the dc has dp status "Draft in progress"
        And I can see the dc has dp sub status "Your Checker to review"
        Examples:
            | Updated Tick - Transport Document | Updated Tick - Certificate of Origin | Updated Tick - Packing List | Updated Select Transport Document | Updated Other Transport Document | Updated Invoice Description | Updated Transport Document Description | Updated Certificate of Origin Description | Updated Packing List Description | Updated Other Required Document Count | Updated Other Required Document Names | Updated Other Required Document Descriptions |
            | Tick                              | Tick                                 | Tick                        | Others, please specify            | Other Transport Document         | Invoice Description         | Transport Document Description         | Certificate of Origin Description         | Packing List Description         | 1                                     | Other Doc 1                           | Other Doc Description 1                      |
