Feature: Beneficiary can present a DC without invoice
Starting 7.0,  I want to test the following scenarios
https://contour.atlassian.net/browse/VTX-5751 and https://contour.atlassian.net/browse/VTX-5752


Feature: Beneficiary can present a DC without invoice
    As a QA, I want to test if a DP can be presented without an invoice

    Scenario: Beneficiary creates presentation without invoice
        Given I setup test scenario context
        And advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"
        Given beneficiary's admin1 login to main page for scenario sc11
        And beneficiary navigate to current dc using contour uuid
        When I click on the button "actionButton"."presentButton"
        And I click sub side menu option "DP 1"
        #7.0 Feature There is no option to select the document source [Contour/essDOcs]
        Then the element "dpOverview"."selectDocumentSource" does not exist
        #7.0 added feature:Drawing amount in the DP overview page which is mandatory
        When I fill in dp overview with following information for scenario "sc11"
            | Present to      | #NOMINATED_BANK# |
            | Present through | #ADVISING_BANK#  |
        Then the element "actionButton"."saveAndNextButton" is not enabled
        When I fill in dp overview with following information for scenario "sc11"
            | Drawing Amount  | 10000            |
            | Present to      | #NOMINATED_BANK# |
            | Present through | #ADVISING_BANK#  |
        And I click on the button "actionButton"."saveAndNextButton"
        And I fill in dp cover letter by "beneficiary" with following information
            | Instruction | Payment |
        And I click sub side menu sub-option "Invoice"
        Then the element "dpInvoice"."amount" is empty
        Then the element "dpInvoice"."quantity" is empty
        Then the element "dpInvoice"."invoice" is empty
        #7.0 Feature to add mailing mode for invoice documents
        When I click on the element "dpInvoice"."invoiceMailingType"
        When I pick "Wave BL" to the contourSelect "dpInvoice"."modeOfInvoiceTransfer"
        When I set "WaveBL Ref 1234" to the inputfield "dpInvoice"."referenceNumber"
        And I click on the button "actionButton"."saveAndNextButton"
        #Invoice is not mandatory. Empty invoice amount is acceptable
        Then the element "dpInvoice"."errorMessage" does not exist
        And I certify presentation is complete and submit presentation
        Then I can see the dc has dp status "Bank review"

    Scenario: Presenting Bank forwards presentation
        When I pause for 3500ms
        And advisingBank's admin1 login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Presenting bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"


    Scenario: Nominated Bank forwards presentation
        When I pause for 3500ms
        And nominatedBank's admin1 login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        When I fill in the present to bank with following information for scenario "sc11"
            | Present to | #CONFIRMING_BANK# |
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Nominated bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the button "actionButton"."previewButton"
        And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"

    Scenario: confirming Bank forwards presentation
        When I pause for 3500ms
        And confirmingBank's admin1 login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I wait for element "actionButton"."forwardButton" to be visible
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Requested confirmation party"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
        And I wait for element "actionButton"."previewButton" to be visible
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"

    Scenario: Issuing Bank accepts presentation
        And issuingBank's admin1 login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I click on the button "actionButton"."acceptButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Accepted"
        And I can see the dc has dp sub status "Please review"
