@DCPresentation
Feature: Issuing bank maker role can accept a DP.

    Issuing bank can accept holding DP forwarded by other parties

    Background: Setup scenario context
        Given I setup test scenario context

    @VTX-1812
    @DP-IssuingBank-Accept-1
    Scenario Outline: When Issuing bank is a DP holder, only issuing bank see Accept and Return buttons. Other cannot see them.
        Given beneficiary present DP to "issuingBank" through "null" at dc sc1
        Given issuingBank's admin1 login to main page for scenario sc1
        Then I click on the element "sideMenu"."dcExport"
        And issuingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I set "NominatedBankRef" to the inputfield "dpOverview"."bankReferenceNumber"
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Nominated bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"
        And <ViewParty> <ViewRole> login and open DP1 at current DC
        # When I scroll to element "dpOverview"."auditLogSection"
        #Change to to button root once we have data id
        Then I expect that element "actionButton"."acceptButton" <ShouldDisplay> exist
        And I expect that element "actionButton"."returnButton" <ShouldDisplay> exist
        Examples:
            | ViewParty    | ViewRole | ShouldDisplay |
            | issuingBank  | maker    | does          |
            | advisingBank | maker    | does not      |

    @VTX-1812
    @DP-IssuingBank-Accept-2
    Scenario: Issuing bank's all roles account can accept DP
        Given beneficiary present DP to "issuingBank" through "null" at dc sc1
        Given issuingBank's admin1 login to main page for scenario sc1
        Then I click on the element "sideMenu"."dcExport"
        And issuingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I set "NominatedBankRef" to the inputfield "dpOverview"."bankReferenceNumber"
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Nominated bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"
        And issuingBank admin1 login and open DP1 at current DC
        When I click on the button "actionButton"."acceptButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Accepted"
        Then importParty refresh the browser
        And I can see the dc has dp sub status "Please review"

    @VTX-1812
    @DP-IssuingBank-Accept-3
    Scenario Outline: Issuing bank's maker role can create a pending acceptance DP
        Given beneficiary present DP to "issuingBank" through "null" at dc sc1
        Given issuingBank's admin1 login to main page for scenario sc1
        Then I click on the element "sideMenu"."dcExport"
        And issuingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I set "NominatedBankRef" to the inputfield "dpOverview"."bankReferenceNumber"
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Nominated bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"
        And issuingBank <AcceptRole> login and Accept DP1 at current DC
        Then I can see the dc has dp status "Bank review"
        And I can see the dc has dp sub status "<SubStatus>"
        Examples:
            | AcceptRole   | SubStatus               |
            | maker        | Your Checker to review  |
            | makerChecker | Your Approver to review |

    @VTX-1812
    @DP-IssuingBank-Accept-4
    Scenario Outline: After DP has been accepted by issuing bank, issuing bank can see UI to set payment due date.
        Given beneficiary present DP to "issuingBank" through "null" at dc sc1
        Given issuingBank's admin1 login to main page for scenario sc1
        Then I click on the element "sideMenu"."dcExport"
        And issuingBank navigate to current dc using contour uuid
        And I click sub side menu option "DP 1"
        And I set "NominatedBankRef" to the inputfield "dpOverview"."bankReferenceNumber"
        And I click on the button "actionButton"."forwardButton"
        And I click sub side menu sub-option "Cover letter by Nominated bank"
        Then the element "dpInvoice"."principalAmount" is empty
        When I set "10001" to the inputfield "dpInvoice"."principalAmount"
        And I click on the button "actionButton"."saveButton"
        Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
        When I set "101" to the inputfield "dpInvoice"."totalAmount"
        And I click on the button "actionButton"."saveButton"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"
        Then I can see the dc has dp status "Bank review"
        And issuingBank admin1 login and Accept DP1 at current DC
        Then I can see the dc has dp status "Accepted"
        And I can see the dc has dp sub status "Please review"
        And <ViewParty> <ViewRole> login and open DP1 at current DC
        Then I expect the element "dpOverview"."paymentDueDateSection" to match reference "<VRRef>"
        Examples:
            | ViewParty   | ViewRole | VRRef                                                            |
            | issuingBank | maker    | dp/dp-issuingBank-accept-4/issuingBank/setPaymentDueDateEnabled  |
            | beneficiary | maker    | dp/dp-issuingBank-accept-4/beneficiary/setPaymentDueDateDisabled |
