@VTX_5149
Feature: DC Issuance E2E sc11
    As a tester, I want to verify sc11 flow e2e

    Scenario: CorpA create DC
        Given I setup test scenario context
        And applicant's maker login to main page for scenario sc11
        And I navigate to create dc page
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                           | #APPLICANT_ADDRESS#       |
            | Beneficiary                                 | #BENEFICIARY#             |
            | Beneficiary Address                         | #BENEFICIARY_ADDRESS#     |
            | Issuing Bank                                | #ISSUING_BANK#            |
            | Issuing Bank Address                        | #ISSUING_BANK_ADDRESS#    |
            | Allow Issuing Bank To Make Changes Directly |                           |
            | Advising Bank                               | #ADVISING_BANK#           |
            | Advising Bank Address                       | #ADVISING_BANK_ADDRESS#   |
            | Confirmation Instructions                   | Confirm                   |
            | Confirming Bank                             | #CONFIRMING_BANK#         |
            | Confirming Bank Address                     | #CONFIRMING_BANK_ADDRESS# |
            | Available With Bank                         | #NOMINATED_BANK#          |
            | Available With Bank Address                 | #NOMINATED_BANK_ADDRESS#  |
            | Available By Negotiation          | Check                                  |
            | Check Negotiation Payment Details | Check                                  |
            | Negotiation Payment Details       | Negotiation / Deferred Payment Details |
            | Applicable Rules                     | eUCP latest version |
            | Selected Currency                    | USD                 |
            | Amount                               | 10000.00            |
            | Max Tolerance (Optional)             | 15.00               |
            | Min Tolerance (Optional)             | 5.00                |
            | Additional Amount Covered (Option)   |                     |
            | Description Of Goods And/Or Services | Automation          |
            | Expiry Date (YY/MM/DD)               | #RANDOM_DATE#       |
            | Expiry Place                         | Hong Kong           |

            | Partial Shipments (optional) | Allowed     |
            | Transhipment (optional)      | Not allowed |

            | Shipment Date / Period  | Latest date of shipment |
            | Latest Date Of Shipment | 2021-04-10              |

            | Shipment Period | 12 |

            | Period Of Presentation                                                            | 123 |
            | Type Of Presentation                                                              | 123 |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | 123 |
            | Port Of Loading / Airport Of Departure (optional)                                 | 123 |
            | Port Of Discharge / Airport Of Destination (optional)                             | 123 |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | 123 |
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And I pause for 3000ms
        When I save the latest UUID in DC list page
        And applicant's checker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And applicant's approver login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        And I click on the button "actionButton"."approveButton" and confirm


    Scenario: Issuing bank issue DC
        When I pause for 3500ms
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."issueButton"
        When I set "123" to the inputfield "dcForm"."issuedDcRefenceInput"
        And I set "Additional clause from issuing bank" to the inputfield "dcForm"."additionalConditionsFromIssuingBankInput"
        And I set "Instructions to paying bank" to the inputfield "dcForm"."instructionToPayingBankInput"
        And I click on the button "actionButton"."previewButton" and submit
        And issuingBank's checker login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And issuingBank's approver login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Confirm bank confirm DC
        When I pause for 3500ms
        And confirmingBank's maker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseWithoutConfirmationButton"
        When I set "123" to the inputfield "dcForm"."confirmedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        And confirmingBank's checker login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And confirmingBank's approver login to main page for scenario sc11
        And confirmingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Nominated bank confirm DC
        When I pause for 3500ms
        And nominatedBank's maker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseButton"
        When I set "123" to the inputfield "dcForm"."nominatedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        And nominatedBank's checker login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And nominatedBank's approver login to main page for scenario sc11
        And nominatedBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."approveButton" and confirm

    Scenario: Advising bank advise DC
        When I pause for 3500ms
        And advisingBank's maker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."adviseButton"
        When I set "123" to the inputfield "dcForm"."advisedDcReferenceInput"
        And I click on the button "actionButton"."previewButton" and submit
        And advisingBank's checker login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."verifyButton" and confirm
        And advisingBank's approver login to main page for scenario sc11
        And advisingBank navigate to current dc using contour uuid
        Then I pause for 2000ms
         Then I can see the page as following screenshots
            | page   | element                  | refImage                                                   |
            | dcForm | corporatesContainer      | dc_issuance/e2e/sc11/advisingBank/corporatesContainer      |
            | dcForm | banksContainer           | dc_issuance/e2e/sc11/advisingBank/banksContainer           |
            | dcForm | shipmentDetailsContainer | dc_issuance/e2e/sc11/advisingBank/shipmentDetailsContainer |
            | dcForm | dcDetailsContainer       | dc_issuance/e2e/sc11/advisingBank/dcDetailsContainer       |
            | dcForm | attachmentsContainer     | dc_issuance/e2e/sc11/advisingBank/attachmentsContainer     |
        And I click on the button "actionButton"."approveButton" and confirm


    Scenario: Applicant re-verify
        Given applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        #Then I expect the document to match reference "/end2end/create_dc/sc11/final"
        Then I pause for 2000ms
        Then I can see the page as following screenshots
            | page   | element                  | refImage                                            |
            | dcForm | corporatesContainer      | dc_issuance/e2e/sc11/final/corporatesContainer      |
            | dcForm | banksContainer           | dc_issuance/e2e/sc11/final/banksContainer           |
            | dcForm | shipmentDetailsContainer | dc_issuance/e2e/sc11/final/shipmentDetailsContainer |
            | dcForm | dcDetailsContainer       | dc_issuance/e2e/sc11/final/dcDetailsContainer       |
            | dcForm | attachmentsContainer     | dc_issuance/e2e/sc11/final/attachmentsContainer     |
        