# Automate the Presentation test cases in Presentation tab from https://voltrontrade.sharepoint.com/:x:/r/sites/CC-Team-QA/_layouts/15/doc2.aspx?sourcedoc=%7B60978D58-62A7-4D6C-A389-8234B527738B%7D&file=Manual_Test_Cases.xlsx&action=default&mobileredirect=true&cid=da90addf-7ac0-4563-9e2c-98f5f78dc9bf

Feature: Verify end to end happy scenario while Beneficiary initiates Presentation
    As a QA, I want to test VTX-5151

    Scenario: Applicant creates DC
        Given I setup test scenario context
        Given applicant's admin1 login to main page for scenario sc11
        And I navigate to create dc page
        And I fill in dc for scenario sc11 with following values
            | Applicant Address                                                                 | #APPLICANT_ADDRESS#                                                               |
            | Beneficiary                                                                       | #BENEFICIARY#                                                                     |
            | Beneficiary Address                                                               | #BENEFICIARY_ADDRESS#                                                             |
            | Issuing Bank                                                                      | #ISSUING_BANK#                                                                    |
            | Issuing Bank Address                                                              | #ISSUING_BANK_ADDRESS#                                                            |
            | Allow Issuing Bank To Make Changes Directly                                       |                                                                                   |
            | Advising Bank                                                                     | #ADVISING_BANK#                                                                   |
            | Advising Bank Address                                                             | #ADVISING_BANK_ADDRESS#                                                           |
            | Confirmation Instructions                                                         | Confirm                                                                           |
            | Confirming Bank                                                                   | #CONFIRMING_BANK#                                                                 |
            | Confirming Bank Address                                                           | #CONFIRMING_BANK_ADDRESS#                                                         |
            | Available With Bank                                                               | #NOMINATED_BANK#                                                                  |
            | Available With Bank Address                                                       | #NOMINATED_BANK_ADDRESS#                                                          |
            | Applicable Rules                                                                  | eUCP latest version                                                               |
            | Selected Currency                                                                 | USD                                                                               |
            | Amount                                                                            | 10000.00                                                                          |
            | Max Tolerance (Optional)                                                          | 15.00                                                                             |
            | Min Tolerance (Optional)                                                          | 5.00                                                                              |
            | Additional Amount Covered (Option)                                                | Additional Amount Covered (Option)                                                |
            | Description Of Goods And/Or Services                                              | Automation                                                                        |
            | Expiry Date (YY/MM/DD)                                                            | #RANDOM_DATE#                                                                     |
            | Expiry Place                                                                      | Hong Kong                                                                         |
            | Partial Shipments (optional)                                                      | Allowed                                                                           |
            | Transhipment (optional)                                                           | Not allowed                                                                       |
            | Shipment Date / Period                                                            | Latest date of shipment                                                           |
            | Latest Date Of Shipment                                                           | 2021-12-10                                                                        |
            | Shipment Period                                                                   |                                                                                   |
            | Period Of Presentation                                                            | 123                                                                               |
            | Type Of Presentation                                                              | 123                                                                               |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)           |
            | Port Of Loading / Airport Of Departure (optional)                                 | Port Of Loading / Airport Of Departure (optional)                                 |
            | Port Of Discharge / Airport Of Destination (optional)                             | Port Of Discharge / Airport Of Destination (optional)                             |
            | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) | Place Of Final Destination / For Transportation To / Place Of Delivery (optional) |
        And I fill in Available By with following values
            | Tick - Payment at sight | Tick |
        And I fill in document source with following values
            | Tick - Transport Document    | Tick                   |
            | Select Transport Document    | Others, please specify |
            | Tick - Certificate of Origin | Tick                   |
            | Tick - Packing List          | Tick                   |
        And I set "The name of the carrier, or their agent, is shown on the document" to the inputfield "dcForm"."documentRequiredTransportDocumentDescriptionInput"
        When I enable network inspector
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        And I get UUID from applicant admin1 submit response for scenario sc1

    Scenario: Issuing bank issue DC
        And issuingBank's admin1 login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        And I click on the button "actionButton"."issueButton"
        When I set "123" to the inputfield "dcForm"."issuedDcRefenceInput"
        And I set "Additional clause from issuing bank" to the inputfield "dcForm"."additionalConditionsFromIssuingBankInput"
        And I set "Instructions to paying bank" to the inputfield "dcForm"."instructionToPayingBankInput"
        And I click on the button "actionButton"."previewButton"
        And I click on the button "actionButton"."submitButton"

Scenario: Confirm bank confirm DC
    When I pause for 4500ms
    And confirmingBank's admin1 login to main page for scenario sc11
    And confirmingBank navigate to current dc using contour uuid
    And I click on the button "actionButton"."adviseWithoutConfirmationButton"
    When I set "123" to the inputfield "dcForm"."confirmedDcReferenceInput"
    And I click on the button "actionButton"."previewButton" and submit

Scenario: Nominated bank advises DC
    When I pause for 4500ms
    And nominatedBank's admin1 login to main page for scenario sc11
    And nominatedBank navigate to current dc using contour uuid
    And I click on the button "actionButton"."adviseButton"
    When I set "123" to the inputfield "dcForm"."nominatedDcReferenceInput"
    And I click on the button "actionButton"."previewButton" and submit

Scenario: advising bank advises DC
    When I pause for 2500ms
    And advisingBank's admin1 login to main page for scenario sc11
    And advisingBank navigate to current dc using contour uuid
    And I click on the button "actionButton"."adviseButton"
    When I set "123" to the inputfield "dcForm"."advisedDcReferenceInput"
    And I click on the button "actionButton"."previewButton"
    And I click on the button "actionButton"."submitButton"

Scenario: Beneficiary Maker initiated presentation
    Given beneficiary's admin1 login to main page for scenario sc11
    And beneficiary navigate to current dc using contour uuid
    And I click on the button "actionButton"."presentButton"
    When I fill in dp overview with following information for scenario "sc11"
        | Documents source | Contour          |
        | Present to       | #NOMINATED_BANK# |
        | Present through  | #ADVISING_BANK#  |
    And I click on the button "actionButton"."saveAndNextButton"
    And I fill in dp cover letter by "beneficiary" with following information
        | Instruction | Payment |
    And I click sub side menu sub-option "Invoice"
    Then the element "dpInvoice"."amount" is empty
    Then the element "dpInvoice"."quantity" is empty
    Then the element "dpInvoice"."invoice" is empty
    And I click on the button "actionButton"."saveAndNextButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete all required fields"
    When I set "100001" to the inputfield "dpInvoice"."amount"
    And I upload "test/util/pdf/pdfDc1.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
    And I upload "test/util/pdf/pdfDc2.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
    And I upload "test/util/pdf/PNG1_7KB.png" to contourFileUpload "dpInvoice"."dpUploadFiles"
    Then I can see the following attachment and remove button with following values
        | pdfDc1.pdf | DISPLAYED |
        | pdfDc2.pdf | DISPLAYED |
    And I click on the button "dpInvoice"."saveDraft"
    Then the element "dpInvoice"."draftSuccessMessage" contains the text "Draft has been saved"
    # Check if dp draft has been saved with the values DP1_1
    Given beneficiary's maker login to main page for scenario sc11
    And beneficiary navigate to current dc using contour uuid
    Then the element "actionButton"."presentButton" is not displayed
    Then the element "dpOverview"."selectDocumentSource" is not empty
    Then the element "dpOverview"."selectPresentTo" is not empty
    Then the element "dpOverview"."selectPresentThrough" is not empty
    And I click sub side menu option "DC"
    And I click sub side menu sub-option "DC form"
    Then I expect the element "hint"."hintMessage2" to match reference "dp/dc_form/remindPendingPresentationAlert"
    And I click on the button "actionButton"."presentButton"
    And I click sub side menu sub-option "Invoice"
    #Then the element "dpInvoice"."amount" is empty
    When I set "100001" to the inputfield "dpInvoice"."amount"
    And I upload "test/util/pdf/pdfDc1.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
    And I upload "test/util/pdf/pdfDc2.pdf" to contourFileUpload "dpInvoice"."dpUploadFiles"
    Then I can see the following attachment and remove button with following values
        | pdfDc1.pdf | DISPLAYED |
        | pdfDc2.pdf | DISPLAYED |
    And I click on the button "dpInvoice"."addInvoiceButton"
    And I click on the button "actionButton"."saveAndNextButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete all required fields"
    And I click on the button "dpInvoice"."deleteInvoiceButton"
    Then I accept the alert
    #DP1_2
    And I click on the button "actionButton"."saveAndNextButton"
    Then the element "dpInvoice"."documentConditions" is not empty
    And I click on the button "actionButton"."saveAndNextButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete all required fields"
    And I fill in dp other document "Other transport document" with following information
        | Document | Electronic record |
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete all required fields"
    Then the element "dpOtherDocument"."inputPortOfLoading" is not empty
    Then the element "dpOtherDocument"."inputPortOfDischarge" is not empty
    And I fill in dp other document "Other transport document" with following information
        | Document           | Electronic record                    |
        | Transport document | Document                             |
        | Date of shipment   | 01-09-2025                           |
        | Port of loading    | Automation testing loading           |
        | Port of discharge  | Automation testing loading discharge |
        | Upload file        | test/util/pdf/pdfAmendment1.pdf      |
    And I fill in dp certificate of origin "Certificate of origin" with following information
        | Document           | Electronic record                    |
        | Transport document | Certificate of origin                |
        | Date of shipment   | 01-09-2025                           |
        | Port of loading    | Automation testing loading           |
        | Port of discharge  | Automation testing loading discharge |
        | Upload file        | test/util/pdf/pdfAmendment2.pdf      |
    And I fill in dp packing list "Packing List" with following information
        | Document           | Electronic record                    |
        | Transport document | Packing List                         |
        | Date of shipment   | 01-09-2025                           |
        | Port of loading    | Automation testing loading           |
        | Port of discharge  | Automation testing loading discharge |
        | Upload file        | test/util/pdf/pdfAmendment3.pdf      |
    Then the element "actionButton"."submitPresentationButton" is not enabled
    And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
    And I click on the button "actionButton"."submitPresentationButton"
    Then the element "dpNoticeOfCompletion"."disclaimerMessage" contains the text "By submitting this request, you confirm that the terms and conditions you had agreed with your bank relating to the request applies."
    Then I click on the button "dpInvoice"."internalComment"
    When I set "First comment" to the inputfield "dpInvoice"."addComment"
    And I click on the button "dpInvoice"."attachComment"
    Then I click on the button "dpInvoice"."editComment"
    When I set "second comment" to the inputfield "dpInvoice"."addComment"
    And I click on the button "dpInvoice"."attachComment"
    And I click on the button "dpInvoice"."removeComment"
    And I scroll to and click element "actionButton"."submitButton"
    Then I can see the dc has dp status "Draft in progress"
    And I can see the dc has dp sub status "Checker to review"

Scenario: Beneficiary checkerApprover verify presentation
    Given beneficiary's checkerApprover login to main page for scenario sc11
    And beneficiary navigate to current dc using contour uuid
    Then I click on the button "dpInvoice"."verifyButton"
    Then I set "Verified and approved" to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"

Scenario: Presenting Bank's maker forwards presentation
    When I pause for 3500ms
    And advisingBank's maker login to main page for scenario sc11
    And advisingBank navigate to current dc using contour uuid
    And I scroll to and click element "actionButton"."forwardButton"
    And I click sub side menu sub-option "Cover letter by Presenting bank"
    Then the element "dpInvoice"."principalAmount" is empty
    When I set "10001" to the inputfield "dpInvoice"."principalAmount"
    And I click on the button "actionButton"."saveButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
    When I set "101" to the inputfield "dpInvoice"."totalAmount"
    And I click on the button "actionButton"."saveButton"
    And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
    And I click on the button "actionButton"."previewButton"
    Then I click on the button "dpInvoice"."internalComment"
    When I set "First comment" to the inputfield "dpInvoice"."addComment"
    And I click on the button "dpInvoice"."attachComment"
    Then I click on the button "dpInvoice"."editComment"
    When I set "second comment" to the inputfield "dpInvoice"."addComment"
    And I click on the button "dpInvoice"."attachComment"
    And I click on the button "dpInvoice"."removeComment"
    And I scroll to and click element "actionButton"."submitButton"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Checker to review"

Scenario: Presenting Bank's checker verifies presentation
    Given advisingBank's checker login to main page for scenario sc11
    And advisingBank navigate to current dc using contour uuid
    Then I click on the button "dpInvoice"."verifyButton"
    Then I set "Verified " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Approver to review"

Scenario: Presenting Bank's approver approves presentation
    Given advisingBank's approver login to main page for scenario sc11
    And advisingBank navigate to current dc using contour uuid
    Then I click on the button "actionButton"."approveButton"
    Then I set "Approved " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"


Scenario: Nominated Bank's maker forwards presentation
    When I pause for 3500ms
    And nominatedBank's maker login to main page for scenario sc11
    And nominatedBank navigate to current dc using contour uuid
    When I fill in the present to bank with following information for scenario "sc11"
        | Present to | #CONFIRMING_BANK# |
    And I click sub side menu sub-option "Cover letter by Presenting bank"
    Then the element "dpInvoice"."principalAmount" is not enabled
    Then the element "dpInvoice"."totalAmount" is not enabled
    And I click on the button "actionButton"."forwardButton"
    And I click sub side menu sub-option "Cover letter by Nominated bank"
    Then the element "dpInvoice"."principalAmount" is empty
    When I set "10001" to the inputfield "dpInvoice"."principalAmount"
    And I click on the button "actionButton"."saveButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
    When I set "101" to the inputfield "dpInvoice"."totalAmount"
    And I click on the button "actionButton"."saveButton"
    And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
    And I click on the button "actionButton"."previewButton"
    And I scroll to and click element "actionButton"."submitButton"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Checker to review"

Scenario: Nominated Bank's checker verifies presentation
    Given nominatedBank's checker login to main page for scenario sc11
    And nominatedBank navigate to current dc using contour uuid
    Then I click on the button "dpInvoice"."verifyButton"
    Then I set "Verified " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Approver to review"

Scenario:Nominated Bank's  approver approves presentation
    Given nominatedBank's approver login to main page for scenario sc11
    And nominatedBank navigate to current dc using contour uuid
    Then I click on the button "actionButton"."approveButton"
    Then I set "Approved " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"

Scenario: confirming Bank forwards presentation
    When I pause for 3500ms
    And confirmingBank's maker login to main page for scenario sc11
    And confirmingBank navigate to current dc using contour uuid
    And I click on the button "actionButton"."forwardButton"
    And I click sub side menu sub-option "Cover letter by Requested confirmation party"
    Then the element "dpInvoice"."principalAmount" is empty
    When I set "10001" to the inputfield "dpInvoice"."principalAmount"
    And I click on the button "actionButton"."saveButton"
    Then the element "dpInvoice"."errorMessage" contains the text "Please complete the cover letter"
    When I set "101" to the inputfield "dpInvoice"."totalAmount"
    And I click on the button "actionButton"."saveButton"
    And I click on the button "actionButton"."previewButton"
    And I click on the element "dpNoticeOfCompletion"."radioCertifyPresentationComplete"
    And I scroll to and click element "actionButton"."submitButton"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Checker to review"

Scenario: Confirming Bank's checker verifies presentation
    Given confirmingBank's checker login to main page for scenario sc11
    And confirmingBank navigate to current dc using contour uuid
    Then I click on the button "dpInvoice"."verifyButton"
    Then I set "Verified " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"
    And I can see the dc has dp sub status "Approver to review"

Scenario:Confirming Bank's approver approves presentation
    Given confirmingBank's approver login to main page for scenario sc11
    And  confirmingBank navigate to current dc using contour uuid
    Then I click on the button "actionButton"."approveButton"
    Then I set "Approved " to the inputfield "dpInvoice"."draftComment"
    And I click on the button "dpInvoice"."confirmComment"
    Then I can see the dc has dp status "Bank review"

Scenario: Issuing Bank accepts presentation
    And issuingBank's admin1 login to main page for scenario sc11
    And issuingBank navigate to current dc using contour uuid
    And I click on the button "actionButton"."acceptButton"
    And I click on the button "actionButton"."submitButton"
    Then I can see the dc has dp status "Accepted"
    And I can see the dc has dp sub status "Maker to review"