@VTX-4440
Feature: Test forgotUsername Feature
    As a user, I want to test the forgotUsername functionality
    
    Scenario: Verify forgotUsername link page elements
        Given I am in forgot username page
        Then I expect the viewport to match reference "login/forgotUsernamepage"

    Scenario Outline: Verify forgotUsernamepage UI for negative scenarios
        When I clear the inputfield "forgotUsername"."emailInput"
        When I set "<Email>" to the inputfield "forgotUsername"."emailInput"
        And  I click on the button "forgotUsername"."recoverUsername"
        Then the element "forgotUsername"."emptyemailError" matches the text "Please enter a valid email address."
        Then I expect the viewport to match reference "<VRRef>"
        Examples:
            | Email         | VRRef                                    |
            |               | login/forgotUsername/onlyText            |
            | abc           | login/forgotUsername/onlyText            |
            | 123           | login/forgotUsername/onlyNumbers         |
            | abc@          | login/forgotUsername/emptyemailafter@    |
            | abc@test      | login/forgotUsername/emailWithoutDomain  |
            | abc@.         | login/forgotUsername/dotAfter@           |
            | abc@test.     | login/forgotUsername/noDomain            |
            | @@@$###^&*!@# | login/forgotUsername/punctuations        |
            | ###@test.com  | login/forgotUsername/punctuationsBefore@ |

    Scenario: Verify links in happy scenario and multiple attempt errors for forgotUsername functionality
        When I pause for 5000ms
        When I set "maker@test.com" to the inputfield "forgotUsername"."emailInput"
        When I click on the button "forgotUsername"."recoverUsername"
        Then the element "forgotUsername"."bannerImage" matches the text "We've sent an email with your username."
        When I click on the button "forgotUsername"."returnLogin"
        Then the page url contain "/ui/login"
        Given I am in forgot username page
        When I set "maker@test.com" to the inputfield "forgotUsername"."emailInput"
        When I click on the button "forgotUsername"."recoverUsername"
        #Test sending multiple attempts in a less timeframe
        Then the element "forgotUsername"."bannerImage" matches the text "There was a system error. Please try again later."
        #To make sure there is sufficient timegap between requests
        When I pause for 5000ms
        When I set "maker@test.com" to the inputfield "forgotUsername"."emailInput"
        When I click on the button "forgotUsername"."recoverUsername"
        When I click on the link "forgotUsername"."tryHere"
        Then the page url contain "/ui/username/recover"
        