Feature: Test Node Admin Login,Logout,My Profile Feature
    As a user, I want to test the login functionality for node Admin console

    Background: Set up scenario context
        Given I open nodeAdmin login page

    Scenario Outline: Verify login functionality for non admin users [https://contour.atlassian.net/browse/CTM-139]
        When I clear the inputfield "login"."usernameInput"
        When I set "<Email>" to the inputfield "login"."usernameInput"
        When I clear the inputfield "login"."passwordInput"
        When I set "<Password>" to the inputfield "login"."passwordInput"
        And I click on the button "login"."loginButton"
        Then the element "login"."loginError" contains the text "You do not have permission to log in. If you think this is incorrect, please contact your administrator for support."
        Examples:
            | Email                | Password |
            | maker@banka.contour  | password |
            | admin@banka.contour  | password |
            | admin2@banka.contour | password |



    Scenario: Verify Login/Logout functionality for node admin users
        When I set "<Email>" to the inputfield "login"."usernameInput"
        When I set "password" to the inputfield "login"."passwordInput"
        When I click on the button "login"."loginButton"
        Then the page url contain "/nodeadmin/admins"
        Then I click on the button "nodeAdmin"."nodeAdminAvatarButton"
        Then I click on the element "nodeAdmin"."nodeAdminLogoutButton"
        Then the page url contain "/nodeadmin/login"
        Examples:
            | Email                     | Password |
            | superadmin@banka.contour  | password |
            | superadmin2@banka.contour | password |


    Scenario: Verify My profile->Account Overview [https://contour.atlassian.net/browse/CTM-208]

        When I set "<Email>" to the inputfield "login"."usernameInput"
        When I set "password" to the inputfield "login"."passwordInput"
        When I click on the button "login"."loginButton"
        Then the page url contain "/nodeadmin/admins"
        Then I click on the button "nodeAdmin"."nodeAdminAvatarButton"
        Then I click on the element "nodeAdmin"."nodeAdminProfileButton"
        Then I expect the element "nodeAdmin"."accountView" to match reference "nodeAdmin/accountView"
        Then I expect the element "nodeAdmin"."accountDetails" to match reference "nodeAdmin/accountDetails" while hiding element "nodeAdmin"."lastLoggedTime"
        Then I click on the button "nodeAdmin"."nodeAdminAvatarButton"
        Then I click on the element "nodeAdmin"."nodeAdminLogoutButton"
        Then the page url contain "/nodeadmin/login"

        Examples:
            | Email                    | Password |
            | superadmin@banka.contour | password |

    Scenario: Verify My profile->Login Tab UI [https://contour.atlassian.net/browse/CTM-208]
        Given I open nodeAdmin login page
        When I set "<Email>" to the inputfield "login"."usernameInput"
        When I set "password" to the inputfield "login"."passwordInput"
        When I click on the button "login"."loginButton"
        Then the page url contain "/nodeadmin/admins"
        Then I click on the button "nodeAdmin"."nodeAdminAvatarButton"
        Then I click on the element "nodeAdmin"."nodeAdminProfileButton"
        Then I click on the element "nodeAdmin"."loginTab"
        Then I expect the element "nodeAdmin"."passwordView" to match reference "nodeAdmin/passwordUpdateView"
        Examples:
            | Email                    | Password |
            | superadmin@banka.contour | password |


    Scenario:Verify Access issues while redirecting to nodeAdmin console from identity admin[https://contour.atlassian.net/browse/CTM-208]
        Given I open login page
        When I set "<Email>" to the inputfield "login"."usernameInput"
        When I set "password" to the inputfield "login"."passwordInput"
        When I click on the button "login"."loginButton"
        Then the page url contain "/request/lclist"
        Given I change to nodeadmin URL
        Then the page url contain "<urlAccess>"
        Then I click on the button <button>
        Then I click on the element <element>
        Then the page url contain <url>

        Examples:
            | Email                    | urlAccess         | button                              | element                             | url                |
            | superadmin@corpa.contour | /nodeadmin/admins | "nodeAdmin"."nodeAdminAvatarButton" | "nodeAdmin"."nodeAdminLogoutButton" | "/nodeadmin/login" |
            | maker@corpa.contour      | /error/noaccess   | "nodeAdmin"."backButton"            | "nodeAdmin"."identityAvatar"        | "/request/lclist"  |

