@P2PMsg
@VTX-1906
@VTX-1908
Feature: Approver role accounts can view and approve p2p general message with/without attachment.

  As a approver role of applicant, beneficiary, issuing bank, advising bank, nominated bank, or requested confirmation party,
  I would like to approve general p2p message submitted to other parties


  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "admin1"

  @P2PDC-Creation-Approve-1
  Scenario Outline: Approver role account can see UI for verifying a pending p2p General message with/wihout attachment but non approver roles cannot
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | Test approver can see UI for verifying a pending p2p message |
      | To         | applicant,beneficiary,issuingBank,advisingBank               |
      | Message    | test message                                                 |
      | Attachment | <Attachment>                                                 |
    And <Party> <VerifyRole> login and Verify p2p message "#P2P_LATEST_MESSAGE#" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <Party> <ApproveRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can see p2p General message at listing with the following values
      | Sender                | <Party>              |
      | Subject               | #P2P_LATEST_SUBJECT# |
      | Pending Message Count | 1                    |
      | Have Pending Icon     | #YES#                |
      | Have Delivered Icon   | #NO#                 |
      | Have Attachment Icon  | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type       | Sender  | Sent Datetime | Message      | Attachment   | Buttons   |
      | #PENDING_BAR# |         |               |              |              |           |
      | #MY_BUBBLE#   | <Party> | #TIME_STAMP#  | test message | <Attachment> | <Buttons> |
    Examples:
      | Party     | CreateRole | VerifyRole | ApproveRole | MessageIcon    | Attachment                 | HaveAttachmentIcon | Buttons                          |
      | applicant | maker      | checker    | approver    | #ICON_PENDING# | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              | #APPROVE_BUTTON#,#REJECT_BUTTON# |
      | applicant | maker      | checker    | approver    | #ICON_PENDING# |                            | #NO#               | #APPROVE_BUTTON#,#REJECT_BUTTON# |

  @P2PDC-Creation-Approve-2
  Scenario Outline: Approver role account can approve pending p2p General mesasge with/wihout attachment
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | Test approver can approve pending p2p message  |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <Attachment>                                   |
    And <Party> <VerifyRole> login and Verify p2p message "#P2P_LATEST_MESSAGE#" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <Party> <ApproveRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Approve at message "#P2P_LATEST_MESSAGE#"
    And I click on the button "approvePopup"."confirmButton"
    And I pause for 3000ms
    Then I can see p2p General message at listing with the following values
      | Sender                 | <Party>              |
      | Subject                | #P2P_LATEST_SUBJECT# |
      | Deliverd Message Count | 1                    |
      | Have Pending Icon      | #NO#                 |
      | Have Delivered Icon    | #YES#                |
      | Have Attachment Icon   | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type     | Sender  | Sent Datetime | Message      | Attachment   | Buttons |
      | #MY_BUBBLE# | <Party> | #TIME_STAMP#  | test message | <Attachment> |         |
    Examples:
      | Party     | CreateRole | VerifyRole | ApproveRole | Attachment                 | HaveAttachmentIcon |
      | applicant | maker      | checker    | approver    | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              |
      | applicant | maker      | checker    | approver    |                            | #NO#               |
