@P2PMsg
@VTX-1906
@VTX-1908
@P2PDC-Creation-Create
Feature: Create a general p2p message with/without attachments

  As a user, I should be able to add an attachment to a P2P message.
  For example, as an advising bank I may want to send the beneficiary a copy of my bank schedule with instructions on presentations.
  Zeplin: https://zpl.io/bPJBR46

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc11 proceeded by "maker.checkerApprover"

  @P2PDC-Creation-Create-1
  Scenario Outline: A party can send a p2p message with/wihtout attachments
    Given <SendParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I fill in p2p General message with the following values
      | Subject    | <Subject>             |
      | To         | applicant,beneficiary |
      | Message    | test message          |
      | Attachment | <AttachedFiles>       |
    And I click on the button "p2pMessage"."sendButton"
    And I click on the button "sendMessagePopup"."confirmButton"
    And I pause for 2000ms
    Then I can see p2p General message at listing with the following values
      | Sender                  | <SendParty>            |
      | Sent Date               | #P2P_LATEST_SENT_DATE# |
      | Subject                 | #P2P_LATEST_SUBJECT#   |
      | Delivered Message Count | 1                      |
      | Have Delivered Icon     | #YES#                  |
      | Have Attachment Icon    | <HaveAttachmentIcon>   |
    Then I can view body of General message and see the following messages
      | UI Type     | Sender      | Message      | Attachment      | Buttons | Have Reject Label | Reject Comment |
      | #MY_BUBBLE# | <SendParty> | test message | <AttachedFiles> |         | #NO#              |                |
    Examples:
      | SendParty    | Subject                                                               | AttachedFiles              | HaveAttachmentIcon |
      | applicant    | Test subject for to applicant deliver message with atttachments       | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              |
      | beneficiary  | Test subject for to beneficiary deliver message with atttachments     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              |
      | issuingBank  | Test subject for to issuingBank deliver message with atttachments     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              |
      | advisingBank | Test subject for to advisingBank deliver message with atttachments    | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              |
      | applicant    | Test subject for to applicant deliver message without atttachments    |                            | #NO#               |
      | beneficiary  | Test subject for to beneficiary deliver message without atttachments  |                            | #NO#               |
      | issuingBank  | Test subject for to issuingBank deliver message without atttachments  |                            | #NO#               |
      | advisingBank | Test subject for to advisingBank deliver message without atttachments |                            | #NO#               |

  @P2PDC-Creation-Create-2
  Scenario Outline: A maker role can create a pending p2p message with/wihtout attachments
    Given <SendParty> <MakerRole> login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject    | <Subject>             |
      | To         | applicant,beneficiary |
      | Message    | Original message      |
      | Attachment | <AttachedFiles>       |
    Then I can see p2p General message at listing with the following values
      | Sender                | <SendParty>            |
      | Sent Date             | #P2P_LATEST_SENT_DATE# |
      | Subject               | #P2P_LATEST_SUBJECT#   |
      | Pending Message Count | 1                      |
      | Have Pending Icon     | #YES#                  |
      | Have Attachment Icon  | <HaveAttachmentIcon>   |
    Then I can view body of General message and see the following messages
      | UI Type       | Sender      | Message          | Attachment      | Buttons | Have Reject Label | Reject Comment |
      | #PENDING_BAR# |             |                  |                 |         |                   |                |
      | #MY_BUBBLE#   | <SendParty> | Original message | <AttachedFiles> |         | #NO#              |                |
    Examples:
      | SendParty    | MakerRole | AttachedFiles              | HaveAttachmentIcon | Subject                                                               |
      | applicant    | maker     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              | Test subject for to applicant pending message with atttachments       |
      | beneficiary  | maker     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              | Test subject for to beneficiary pending message with atttachments     |
      | issuingBank  | maker     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              | Test subject for to issuingBank pending message with atttachments     |
      | advisingBank | maker     | Doc1_1MB.pdf,Doc2_62KB.pdf | #YES#              | Test subject for to advisingBank pending message with atttachments    |
      | applicant    | maker     |                            | #NO#               | Test subject for to applicant pending message without atttachments    |
      | beneficiary  | maker     |                            | #NO#               | Test subject for to beneficiary pending message without atttachments  |
      | issuingBank  | maker     |                            | #NO#               | Test subject for to issuingBank pending message without atttachments  |
      | advisingBank | maker     |                            | #NO#               | Test subject for to advisingBank pending message without atttachments |


  @P2PDC-Creation-Create-3
  @VTX-3245
  Scenario: A general p2p message UI should display correctly
    Given I have a screen that is 1344 by 1080 pixels
    And applicant maker login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I fill in p2p General message with the following values
      | Subject    | Test ui for general message dispalying correctly                            |
      | To         | applicant,beneficiary,nominatedBank,issuingBank,confirmingBank,advisingBank |
      | Message    | Original message                                                            |
      | Attachment | Doc1_1MB.pdf,Doc2_62KB.pdf,Doc3_62KB.pdf,Doc5_62KB.pdf                      |
    Then I expect the viewport to match reference "p2p/dc/p2pdc-creation-create-3/uiDisplayForGeneralMessageWithHalfWidthBrowser"