@P2PMsg
@VTX-2637
@P2PDC-Creation-Status
Feature: a p2p message wihout reply can be mark and read and unread

  - Messages will only be marked as ‘read’ if a user with Maker functionality opens the P2P message.
  - A Maker can mark a message as ‘unread’ after the message is opened.
  - New P2P messages will be highlighted. Call-to-action and unread messages will share the same UI logic.
  - Read and Unread is at the company level
  - CTA is on the Maker, Checker, Approver level
  - A message with a CTA cannot be marked as read if the User does not complete the CTA request
  - A message without a CTA can be marked read/unread
  - An unread message will have a bold highlight of the last sender and subject, and a red CTA bar

  Background: Set up DC for tesing p2p message
    Given I setup test scenario context
    And issuing bank issued dc for scenario sc1

  @P2PDC-Creation-Status-1
  Scenario Outline: a p2p message can be marked as read after maker role opens it but other roles cannot, the read status is at company level
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | Test only marker can mark a message as read by open it |
      | To      | applicant,beneficiary,issuingBank,advisingBank         |
      | Message | test message                                           |
    And I pause for 3000ms
    Given <ReadThreadParty> <FirstReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<NoReadReference>"
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button "dcSideMenu"."dcForm"
    And I click on the button "dcSideMenu"."p2pMessage"
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<FirstReadReference>"
    Given <ReadThreadParty> <SecondReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<SecondReadReference>"
    Given <ReadThreadParty> <ThirdReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<ThirdReadReference>"

    Examples:
      | CreateThreadParty | Subject                   | ReadThreadParty | FirstReadThreadRole | NoReadReference                          | FirstReadReference                                   | SecondReadThreadRole | SecondReadReference                               | ThirdReadThreadRole | ThirdReadReference                                   |
      | applicant         | test subject #SHORT_UUID# | beneficiary     | maker               | p2p/dc/creation-status-1/e1/noReadStatus | p2p/creation-status-1/e1/readStatusOpenedByMaker     | checker              | p2p/creation-status-1/e1/readStatusForCheckerView | approver            | p2p/creation-status-1/e1/readStatusForApproverView   |
      | applicant         | test subject #SHORT_UUID# | beneficiary     | checker             | p2p/dc/creation-status-1/e2/noReadStatus | p2p/creation-status-1/e2/unReadStatusOpenedByChecker | maker                | p2p/creation-status-1/e2/unreadStatusForMakerView | approver            | p2p/creation-status-1/e2/unreadStatusForApproverView |

  Scenario Outline: only maker role can see mark as read/unread ui at the p2p message
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | Test only maker role can see read/unread ui at the p2p message |
      | To      | applicant,beneficiary,issuingBank,advisingBank                 |
      | Message | test message #SHORT_UUID#                                      |
    And I pause for 3000ms
    Given <CreateThreadParty> <ReadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I see Option at message with subject "#P2P_LATEST_SUBJECT#" <IsExist>
    Examples:
      | CreateThreadParty | ReadRole | IsExist   |
      | applicant         | maker    | Exist     |
      | applicant         | approver | Not Exist |
      | applicant         | checker  | Not Exist |


  @P2PDC-Creation-Status-2
  Scenario Outline: maker role can mark as read via ui at the p2p message
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message #SHORT_UUID#                      |
    And I pause for 3000ms
    Given <MarkingThreadParty> <MarkingRole> login and open current dc
    And I am at P2P message listing under DC
    #toggle to read
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I move to element "p2pMessageListing"."searchInput"
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRReference1>"
    Given <MarkingThreadParty> <FirstViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRReference2>"
    Given <MarkingThreadParty> <SecondViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRReference3>"
    Examples:
      | CreateThreadParty | MarkingThreadParty | MarkingRole | FirstViewRole | SecondViewRole | VRReference1                                            | VRReference2                                        | VRReference3                                         |
      | applicant         | beneficiary        | maker       | checker       | approver       | p2p/dc/creation-status-2/readMessageMarkedByMakerWithUI | p2p/dc/creation-status-2/readMessageWhenCheckerView | p2p/dc/creation-status-2/readMessageWhenApproverView |

  @P2PDC-Creation-Status-3
  Scenario Outline: maker role can mark p2p message as unread via ui at the p2p message
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message #SHORT_UUID#                      |
    And I pause for 3000ms
    Given <MarkingThreadParty> <MarkingRole> login and open current dc
    And I am at P2P message listing under DC
    #toggle to read
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I pause for 3000ms
    #toggle to unread
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I move to element "p2pMessageListing"."searchInput"
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRUnreadReference1>"
    Given <MarkingThreadParty> <FirstViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRUnreadReference2>"
    Given <MarkingThreadParty> <SecondViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRUnreadReference3>"
    Examples:
      | CreateThreadParty | MarkingThreadParty | MarkingRole | FirstViewRole | SecondViewRole | VRUnreadReference1                                          | VRUnreadReference2                                    | VRUnreadReference3                                     |
      | applicant         | beneficiary        | maker       | checker       | approver       | p2p/dc/creation-status-3/unreadMessageToggleToUnreadByMaker | p2p/dc/creation-status-3/unreadMessageWhenCheckerView | p2p/dc/creation-status-3/unreadMessageWhenApproverView |


  @P2PDC-Creation-Status-4
  Scenario Outline: a call to action ui always shows for users who have action to do during p2p message creation either with read/unread status.
    Given <CreateThreadParty> <CreateThreadRole> login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message #SHORT_UUID#                      |
    And I pause for 3000ms
    And I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Given <CreateThreadParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRReference>"
    Examples:
      | CreateThreadParty | CreateThreadRole | MarkThreadRole | ViewRole | VRReference                                                    |
      | applicant         | maker            | maker          | checker  | p2p/dc/creation-status-4/e1/callToActionAtReadMesageForChecker |
      | applicant         | maker            | maker          | approver | p2p/dc/creation-status-4/noCallToActionAtReadMesageForApprover |
