@P2PMsg
@VTX-1906
@VTX-1908
@P2PDC-Creation-Download
Feature: Attached files at p2p General message and its replies can be downloaded either from messages tab or files tab

  As a user, I should be able to add attachments to a p2p General message.
  For example, as an advising bank I may want to send the beneficiary a copy of my bank schedule with instructions on presentations.
  Zeplin: https://zpl.io/bPJBR46

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

  VR Test at files tab
  @P2PDC-Creation-Download-1
  Scenario Outline: Attached files at the delivered message can be seen at Files tab by all parties
    Given <SenderParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <ViewParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the element "p2pMessageView"."filesTab"
    Then I expect the Files tab view to match reference "<VRRef>"
    Examples:
      | SenderParty  | ViewParty   | ViewRole | CreateSubject                                                          | AttachmentFiles            | VRRef                                                      |
      | applicant    | beneficiary | maker    | Test download view at delivered message files tab sent by applicant    | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-1/e1/2FilesAtFilesTabForDelivered |
      | issuingBank  | applicant   | maker    | Test download view at delivered message files tab sent by issuingBank  | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-1/e2/2FilesAtFilesTabForDelivered |
      | advisingBank | issuingBank | maker    | Test download view at delivered message files tab sent by advisingBank | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-1/e3/2FilesAtFilesTabForDelivered |

  @P2PDC-Creation-Download-2
  Scenario Outline: Attached files at the pending message can be seen at Files tab only by sender party
    Given <SendParty> <SendRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <SendParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the element "p2pMessageView"."filesTab"
    Then I expect the Files tab view to match reference "<VRRef>"
    Examples:
      | SendParty   | SendRole | ViewRole | CreateSubject                                                       | AttachmentFiles            | VRRef                                                    |
      | applicant   | maker    | checker  | Test download view at pending message  files tab sent by applicant  | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-2/e1/2FilesAtFilesTabForPending |
      | issuingBank | maker    | approver | Test download view t pending message  files tab sent by issuingBank | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-2/e2/2FilesAtFilesTabForPending |


  @P2PDC-Creation-Download-3
  #Download Test at files tab
  Scenario Outline: Attached files at the delivered message can be downloaded at Files tab by all parties
    Given <SenderParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <ViewParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the element "p2pMessageView"."filesTab"
    Then I can download files "<AttachmentFiles>" at p2p Files tab view
    Examples:
      | SenderParty  | ViewParty   | ViewRole | CreateSubject                                                      | AttachmentFiles            |
      | applicant    | beneficiary | maker    | Test download at delivered message  files tab sent by aplicant     | Doc1_1MB.pdf,Doc2_62KB.pdf |
      | advisingBank | issuingBank | maker    | Test download at delivered message  files tab sent by advisingBank | Doc1_1MB.pdf,Doc2_62KB.pdf |

  @P2PDC-Creation-Download-4
  Scenario Outline: Attached files at the pending message can be downloaded at Files tab by sender party only
    Given <SendParty> maker login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <SendParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the element "p2pMessageView"."filesTab"
    Then I can download files "<AttachmentFiles>" at p2p Files tab view
    Examples:
      | SendParty    | ViewRole | CreateSubject                                                     | AttachmentFiles            |
      | applicant    | checker  | Test download at pending files tab  view tab sent by applicant    | Doc1_1MB.pdf,Doc2_62KB.pdf |
      | advisingBank | checker  | Test download at pending files tab  view tab sent by advisingBank | Doc1_1MB.pdf,Doc2_62KB.pdf |

  @P2PDC-Creation-Download-5
  #VR Test at messages tab
  Scenario Outline: Attached files at the delivered message can be seen at Message tab by all parties
    Given <SenderParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <ViewParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I expect the Message view to match reference "<VRRef>"
    Examples:
      | SenderParty | ViewParty    | ViewRole | CreateSubject                                                           | AttachmentFiles            | VRRef                                                        |
      | applicant   | beneficiary  | maker    | Test download view at delivered message messages tab sent by applicant  | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-5/e1/2FilesAtMessageTabForDelivered |
      | issuingBank | advisingBank | maker    | Test download view  at delivered message messages tab sent by applicant | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-5/e2/2FilesAtMessageTabForDelivered |

  @P2PDC-Creation-Download-6
  Scenario Outline: Attached files at the pending message can be seen at Message tab by sender only
    Given <SendParty> maker login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <SendParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I expect the Message view to match reference "<VRRef>"
    Examples:
      | SendParty   | ViewRole | CreateSubject                                                           | AttachmentFiles            | VRRef                                                      |
      | applicant   | checker  | Test download view at pending message  messages tab sent by applicant   | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-6/e1/2FilesAtMessageTabForPending |
      | issuingBank | checker  | Test download view at pending message  messages tab sent by issuingBank | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-download-6/e2/2FilesAtMessageTabForPending |

  @P2PDC-Creation-Download-7
  #Download test at message tab
  Scenario Outline: Attached files at the delivered message can be downloaded at Message tab by all parties
    Given <SenderParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <ViewParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can download files "<AttachmentFiles>" at p2p message "test message"
    Examples:
      | SenderParty | ViewParty    | ViewRole | CreateSubject                                                        | AttachmentFiles            |
      | applicant   | beneficiary  | maker    | Test download at delivered message  messages tab sent by applicant   | Doc1_1MB.pdf,Doc2_62KB.pdf |
      | issuingBank | advisingBank | maker    | Test download at delivered message  messages tab sent by issuingBank | Doc1_1MB.pdf,Doc2_62KB.pdf |

  @P2PDC-Creation-Download-8
  Scenario Outline: Attached files at the pending message can be downloaded at Message tab by send party only
    Given <SendParty> maker login and create p2p General message at current dc under DC with the following values
      | Subject    | <CreateSubject>                                |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <AttachmentFiles>                              |
    And <SendParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can download files "<AttachmentFiles>" at p2p message "test message"
    Examples:
      | SendParty   | ViewRole | CreateSubject                                                      | AttachmentFiles            |
      | applicant   | maker    | Test download at pending message  messages tab sent by applicant   | Doc1_1MB.pdf,Doc2_62KB.pdf |
      | issuingBank | maker    | Test download at pending message  messages tab sent by issuingBank | Doc1_1MB.pdf,Doc2_62KB.pdf |