@P2PMsg
@VTX-1906
@VTX-1908
Feature: Maker role account can edit rejected p2p General message and send again

  As a maker role account, I would like to edit and submit rejected message

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

  # @P2PDC-Creation-Edit-1
  # Scenario Outline: Only maker role account can see edit and discard UI at rejected message with/without attachments and other roles cannot
  #   Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
  #     | Subject    | <Subject>                                      |
  #     | To         | applicant,beneficiary,issuingBank,advisingBank |
  #     | Message    | <Message>                                      |
  #     | Attachment | <AttachedFiles>                                |
  #   And <Party> <VerifyRole> login and Reject p2p message "<Message>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
  #   And <Party> <ViewRole> login and open current dc
  #   And I am at P2P message listing under DC
  #   When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
  #   Then I can view body of General message and see the following messages
  #     | UI Type       | Sender  | Sent Datetime              | Message   | Attachment      | Buttons          |
  #     | #PENDING_BAR# |         |                            |           |                 |                  |
  #     | #MY_BUBBLE#   | <Party> | #P2P_LATEST_SENT_DATETIME# | <Message> | <AttachedFiles> | <MessageButtons> |
  #   Examples:
  #     | Party     | CreateRole | Subject                                                       | Message         | VerifyRole | ViewRole | AttachedFiles              | MessageButtons                 |
  #     | applicant | maker      | Test edit and discard UI at rejected message view by maker    | orginal message | checker    | maker    | Doc1_1MB.pdf,Doc2_62KB.pdf | #EDIT_BUTTON#,#DISCARD_BUTTON# |
  #     | applicant | maker      | Test edit and discard UI at rejected message view by checker  | orginal message | checker    | checker  | Doc1_1MB.pdf,Doc2_62KB.pdf |                                |
  #     | applicant | maker      | Test edit and discard UI at rejected message view by approver | orginal message | checker    | approver | Doc1_1MB.pdf,Doc2_62KB.pdf |                                |

  @VTX-3314
  @P2PDC-Creation-Edit-2
  Scenario Outline: Can see attached files (if have), message edit text area while editing the rejected message with/without attachment
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | VR test for editing rejected message           |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | <AttachedFiles>                                |
    And <Party> <VerifyRole> login and Reject p2p message "<Message>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <Party> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Edit at message "#P2P_LATEST_MESSAGE#"
    And I scroll to element "p2pMessage"."sendButton"
    Then I expect the element "p2pMessageView"."viewRoot" to match reference "<VRRef>"
    Examples:
      | Party       | CreateRole | Message          | VerifyRole      | ViewRole     | AttachedFiles              | VRRef                                                                 |
      | applicant   | maker      | original message | checker         | maker        | Doc1_1MB.pdf,Doc2_62KB.pdf | p2p/dc/creation-edit-2/e1/2FilesEditingAtMessageTabWithAttachment     |
      | issuingBank | maker      | original message | checkerApprover | makerChecker |                            | p2p/dc/creation-edit-2/e2/2FilesEditingAtMessageTabWithoutAttachmdent |


  @P2PDC-Creation-Edit-3
  @VTX-3335
  Scenario Outline: Only maker role account can edit and re-send rejected message with/without attachments for approval
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <OriginalMessage>                              |
      | Attachment | <OriginalAttachment>                           |
    And <Party> <VerifyRole> login and Reject p2p message "<OriginalMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <Party> <EditRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Edit at message "<OriginalMessage>"
    And I set "<EditedMessage>" to the inputfield "p2pMessage"."viewMessageTextArea"
    When I attach files "<AddedFiles>" to p2p message
    When I remove files "<RemovedFiles>" from p2p message
    When I click on the button "p2pMessage"."sendButton"
    And I click on the button "updateAndSendMessagePopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type       | Sender  | Message         | Attachment   | Buttons |
      | #PENDING_BAR# |         |                 |              |         |
      | #MY_BUBBLE#   | <Party> | <EditedMessage> | <FinalFiles> |         |
    Examples:
      | Party     | CreateRole | Subject                      | OriginalMessage  | OriginalAttachment         | VerifyRole | EditRole | EditedMessage     | RemovedFiles | AddedFiles    | FinalFiles                  |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf | Doc3_62KB.pdf | Doc2_62KB.pdf,Doc3_62KB.pdf |

  @VTX-3351
  @VTX-2110
  @P2PDC-Creation-Edit-4
  Scenario Outline: Can cancel editted rejected message
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <OriginalMessage>                              |
      | Attachment | <OriginalAttachment>                           |
    And <Party> <VerifyRole> login and Reject p2p message "<OriginalMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <Party> <EditRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Edit at message "<OriginalMessage>"
    And I attach files "<AddedFiles>" to p2p message
    And I remove files "<RemovedFiles>" from p2p message
    And I set "<EditedMessage>" to the inputfield "p2pMessage"."viewMessageTextArea"
    And I click on the button "p2pMessage"."closeButton"
    And I click on the button "leavePopup"."<PopupButton>"
    Then I expect the Message view to match reference "<VRRef>"
    Examples:
      | Party     | CreateRole | Subject                              | OriginalMessage  | OriginalAttachment         | VerifyRole | EditRole | EditedMessage     | RemovedFiles | AddedFiles    | PopupButton | VRRef                                                    |
      | applicant | maker      | Test edit and cancel editted message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf | Doc3_62KB.pdf | leaveButton | p2p/dc/creation-edit-4/e1/editP2PMessageAndDiscardChange |
      | applicant | maker      | Test edit and cancel editted message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf | Doc3_62KB.pdf | stayButton  | p2p/dc/creation-edit-4/e2/editP2PMessageAndStayEdit      |
