@P2PMsg
@VTX-1906
@VTX-1908
Feature: Checker role accounts can view and verify general p2p message with/without attachment.

  As a checker of applicant, beneficiary, issuing bank, advising bank, nominated bank, or requested confirmation party,
  I would like to view and be able to verify p2p general message

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"


  @P2PDC-Creation-Verify-1
  Scenario Outline: Checker role account can see UI for verifying a pending p2p General message with/wihout attachment but non checker roles cannot
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | test subject #SHORT_UUID#                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <Attachment>                                   |
    And <Party> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can see p2p General message at listing with the following values
      | Sender                | <Party>              |
      | Subject               | #P2P_LATEST_SUBJECT# |
      | Pending Message Count | 1                    |
      | Have Pending Icon     | #YES#                |
      | Have Delivered Icon   | #NO#                 |
      | Have Attachment Icon  | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type       | Sender  | Sent Datetime | Message      | Attachment   | Buttons   |
      | #PENDING_BAR# |         |               |              |              |           |
      | #MY_BUBBLE#   | <Party> | #TIME_STAMP#  | test message | <Attachment> | <Buttons> |
    Examples:
      | Party     | CreateRole | ViewRole | Attachment    | HaveAttachmentIcon | Buttons                         |
      | applicant | maker      | checker  | Doc2_62KB.pdf | #YES#              | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | applicant | maker      | checker  |               | #NO#               | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | applicant | maker      | approver | Doc2_62KB.pdf | #YES#              |                                 |
      | applicant | maker      | approver |               | #NO#               |                                 |

  @P2PDC-Creation-Verify-2
  Scenario Outline: Checker role account can verify pending p2p General mesasge with/wihout attachment
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | test subject #SHORT_UUID#                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | test message                                   |
      | Attachment | <Attachment>                                   |
    And <Party> <VerifyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "#P2P_LATEST_MESSAGE#"
    And I click on the button "verifyPopup"."confirmButton"
    Then I can see p2p General message at listing with the following values
      | Sender                | <Party>              |
      | Subject               | #P2P_LATEST_SUBJECT# |
      | Pending Message Count | 1                    |
      | Have Pending Icon     | #YES#                |
      | Have Delivered Icon   | #NO#                 |
      | Have Attachment Icon  | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type       | Sender  | Sent Datetime | Message      | Attachment   | Buttons |
      | #PENDING_BAR# |         |               |              |              |         |
      | #MY_BUBBLE#   | <Party> | #TIME_STAMP#  | test message | <Attachment> |         |
    Examples:
      | Party     | CreateRole | VerifyRole | Attachment    | HaveAttachmentIcon |
      | applicant | maker      | checker    | Doc2_62KB.pdf | #YES#              |
      | applicant | maker      | checker    |               | #NO#               |

  @P2PDC-Creation-Verify-3
  Scenario Outline: Only checker role can see verify UI for edited message sent by maker role
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <OriginalMessage>                              |
      | Attachment | <OriginalAttachment>                           |
    And <Party> <VerifyRole> login and Reject p2p message "<OriginalMessage>" with subject "<Subject>" at current dc under DC
    And <Party> <EditRole> login and Edit p2p message "<OriginalMessage>" with subject "<Subject>" at current dc under DC with the following values
      | Edited Message | <EditedMessage> |
      | Remove Files   | <RemovedFiles>  |
      | Add Files      | <AddedFiles>    |
    And <Party> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "<Subject>" from listing
    And I move to element "p2pMessageListing"."searchInput"
    Then I can see p2p General message at listing with the following values
      | Sender                | <Party>              |
      | Subject               | <Subject>            |
      | Pending Message Count | 1                    |
      | Have Pending Icon     | #YES#                |
      | Have Delivered Icon   | #NO#                 |
      | Have Attachment Icon  | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type       | Sender  | Message         | Attachment   | Buttons   |
      | #PENDING_BAR# |         |                 |              |           |
      | #MY_BUBBLE#   | <Party> | <EditedMessage> | <FinalFiles> | <Buttons> |
    Examples: checker role can see verify UI
      | Party     | CreateRole | Subject                      | OriginalMessage  | OriginalAttachment         | VerifyRole | EditRole | EditedMessage     | RemovedFiles               | AddedFiles    | ViewRole | FinalFiles                  | HaveAttachmentIcon | Buttons                         |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf               | Doc3_62KB.pdf | checker  | Doc2_62KB.pdf,Doc3_62KB.pdf | #YES#              | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf,Doc2_62KB.pdf |               | checker  |                             | #NO#               | #VERIFY_BUTTON#,#REJECT_BUTTON# |
    Examples: other role can not see verify UI
      | Party     | CreateRole | Subject                      | OriginalMessage  | OriginalAttachment         | VerifyRole | EditRole | EditedMessage     | RemovedFiles               | AddedFiles    | ViewRole | FinalFiles                  | HaveAttachmentIcon | Buttons |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf               | Doc3_62KB.pdf | approver | Doc2_62KB.pdf,Doc3_62KB.pdf | #YES#              |         |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf,Doc2_62KB.pdf |               | maker    |                             | #NO#               |         |

  @P2PDC-Creation-Verify-4
  Scenario Outline: Checker role can verify edited message sent by maker role
    Given <Party> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <OriginalMessage>                              |
      | Attachment | <OriginalAttachment>                           |
    And <Party> <VerifyRole> login and Reject p2p message "<OriginalMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    Given <Party> <EditRole> login and Edit p2p message "<OriginalMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Edited Message | <EditedMessage> |
      | Remove Files   | <RemovedFiles>  |
      | Add Files      | <AddedFiles>    |
    Given <Party> <VerifyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "<EditedMessage>"
    And I click on the button "verifyPopup"."confirmButton"
    Then I can see p2p General message at listing with the following values
      | Sender                | <Party>              |
      | Subject               | <Subject>            |
      | Pending Message Count | 1                    |
      | Have Pending Icon     | #YES#                |
      | Have Delivered Icon   | #NO#                 |
      | Have Attachment Icon  | <HaveAttachmentIcon> |
    And I can view body of General message and see the following messages
      | UI Type       | Sender  | Message         | Attachment   | Buttons |
      | #PENDING_BAR# |         |                 |              |         |
      | #MY_BUBBLE#   | <Party> | <EditedMessage> | <FinalFiles> |         |
    Examples:
      | Party     | CreateRole | Subject                      | OriginalMessage  | OriginalAttachment         | VerifyRole | EditRole | EditedMessage     | RemovedFiles | AddedFiles    | FinalFiles                  | HaveAttachmentIcon |
      | applicant | maker      | Test edit and resend message | original message | Doc1_1MB.pdf,Doc2_62KB.pdf | checker    | maker    | edited message v1 | Doc1_1MB.pdf | Doc3_62KB.pdf | Doc2_62KB.pdf,Doc3_62KB.pdf | #YES#              |
