@P2PMsg
@VTX-2638
Feature: P2P message and reply ordering

  As a user, I would like to p2p messages to be ordered by sent timestamp and seperate into pending and delivered section.

  Background: Setup dc for testing p2p
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"


  @P2PDC-Ordering-1
  Scenario Outline: All delivered replies should be ordered by approved timestamp. Most recent message is starting from the bottom up
    Given <CreateParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message                                   |
    And I pause for 3000ms
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 1000ms
    Given <ReplyParty> admin1 login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 2 |
    And I pause for 1000ms
    And I reply p2p General message with the following values
      | Message | reply message 3 |
    And I pause for 1000ms
    Then I can view body of General message and see the following messages
      | UI Type          | Sender        | Message         | Attachment | Buttons |
      | <MESSAGE_BUBBLE> | <CreateParty> | test message    |            |         |
      | <REPLY_BUBBLE_1> | <CreateParty> | reply message 1 |            |         |
      | <REPLY_BUBBLE_2> | <ReplyParty>  | reply message 2 |            |         |
      | <REPLY_BUBBLE_3> | <ReplyParty>  | reply message 3 |            |         |
    Examples:
      | CreateParty | ReplyParty  | MESSAGE_BUBBLE | REPLY_BUBBLE_1 | REPLY_BUBBLE_2 | REPLY_BUBBLE_3 |
      | applicant   | beneficiary | #OTHER_BUBBLE# | #OTHER_BUBBLE# | #MY_BUBBLE#    | #MY_BUBBLE#    |

  @P2PDC-Ordering-2
  Scenario Outline: All pending replies should be ordered by created timestamp that most recent one is starting from the bottom up after pending bar
    Given <CreateParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message                                   |
    And I pause for 2000ms
    Given <ReplyParty> <ReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 1000ms
    And I reply p2p General message with the following values
      | Message | reply message 2 |
    And I pause for 1000ms
    And I reply p2p General message with the following values
      | Message | reply message 3 |
    And I pause for 1000ms
    Then I can view body of General message and see the following messages
      | UI Type          | Sender        | Message         | Attachment | Buttons |
      | <MESSAGE_BUBBLE> | <CreateParty> | test message    |            |         |
      | #PENDING_BAR#    |               |                 |            |         |
      | <REPLY_BUBBLE_1> | <ReplyParty>  | reply message 1 |            |         |
      | <REPLY_BUBBLE_2> | <ReplyParty>  | reply message 2 |            |         |
      | <REPLY_BUBBLE_3> | <ReplyParty>  | reply message 3 |            |         |
    Examples:
      | CreateParty | ReplyParty  | ReplyRole | MESSAGE_BUBBLE | REPLY_BUBBLE_1 | REPLY_BUBBLE_2 | REPLY_BUBBLE_3 |
      | applicant   | beneficiary | maker     | #OTHER_BUBBLE# | #MY_BUBBLE#    | #MY_BUBBLE#    | #MY_BUBBLE#    |


  @P2PDC-Ordering-3
  Scenario Outline: All devliered replies are ordered based on approved timestamp
    Given <CreateParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message                                   |
    And I pause for 2000ms
    Given <ReplyParty> <PendingReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 1000ms
    And I reply p2p General message with the following values
      | Message | reply message 2 |
    And I pause for 1000ms
    And I reply p2p General message with the following values
      | Message | reply message 3 |
    And I pause for 1000ms
    Given <ReplyParty> <ApproveReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "reply message 3"
    And I click on the button "verifyPopup"."confirmButton"
    And I pause for 1000ms
    And I click on the button Verify at message "reply message 1"
    And I click on the button "verifyPopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type          | Sender        | Message         | Attachment | Buttons                          |
      | <MESSAGE_BUBBLE> | <CreateParty> | test message    |            |                                  |
      | <REPLY_BUBBLE_3> | <ReplyParty>  | reply message 3 |            |                                  |
      | <REPLY_BUBBLE_1> | <ReplyParty>  | reply message 1 |            |                                  |
      | #PENDING_BAR#    |               |                 |            |                                  |
      | <REPLY_BUBBLE_2> | <ReplyParty>  | reply message 2 |            | #REJECT_BUTTON#, #VERIFY_BUTTON# |
    Given <ViewOnlyParty> <ViewOnlyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type        | Sender        | Message         | Attachment | Buttons |
      | #OTHER_BUBBLE# | <CreateParty> | test message    |            |         |
      | #OTHER_BUBBLE# | <ReplyParty>  | reply message 3 |            |         |
      | #OTHER_BUBBLE# | <ReplyParty>  | reply message 1 |            |         |
    Examples:
      | CreateParty | ReplyParty  | PendingReplyRole | ApproveReplyRole | ViewOnlyParty | ViewOnlyRole | MESSAGE_BUBBLE | REPLY_BUBBLE_1 | REPLY_BUBBLE_2 | REPLY_BUBBLE_3 |
      | applicant   | beneficiary | maker            | checkerApprover  | issuingBank   | maker        | #OTHER_BUBBLE# | #MY_BUBBLE#    | #MY_BUBBLE#    | #MY_BUBBLE#    |

  @P2PDC-Ordering-4
  Scenario Outline: After finished delivering a message, the delivered message should be move to above pending bar
    Given <CreateParty> maker login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message                                   |
    And I pause for 1000ms
    Then I can view body of General message and see the following messages
      | UI Type       | Sender        | Message      | Attachment | Buttons |
      | #PENDING_BAR# |               |              |            |         |
      | #MY_BUBBLE#   | <CreateParty> | test message |            |         |
    Given <CreateParty> checker login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "test message"
    And I click on the button "verifyPopup"."confirmButton"
    And I pause for 1000ms
    Then I can view body of General message and see the following messages
      | UI Type       | Sender        | Message      | Attachment | Buttons |
      | #PENDING_BAR# |               |              |            |         |
      | #MY_BUBBLE#   | <CreateParty> | test message |            |         |
    Given <CreateParty> approver login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Approve at message "test message"
    And I click on the button "approvePopup"."confirmButton"
    And I pause for 1000ms
    Then I can view body of General message and see the following messages
      | UI Type     | Sender        | Message      | Attachment | Buttons |
      | #MY_BUBBLE# | <CreateParty> | test message |            |         |
    Examples:
      | CreateParty |
      | applicant   |
