@P2PMsg
@VTX-1906
@VTX-1908
Feature: Approver role accounts can view and approve pending reply with/without attachment.

  As a approver, I would like to approve pending replies at General message verified by checker role

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

  @P2PDC-Reply-Approve-1
  Scenario Outline: Only approver role account can see UI for approving a pending edited reply with/wihout attachment but non approver roles cannot
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | Original message                               |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <OriginReplyMessage> |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <RejectRole> login and Reject p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <ReplyParty> <EditRole> login and Edit p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Edited Message | <EditedReplyMessage> |
      | Remove Files   | <RemovedFiles>       |
      | Add Files      | <AddedFiles>         |
    Given <ReplyParty> <ApproveRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message              | Attachment             | Buttons   |
      | <MessageBubble> | <CreateParty> | Original message     | <MessageAttachedFiles> |           |
      | #PENDING_BAR#   |               |                      |                        |           |
      | <ReplyBubble>   | <ReplyParty>  | <EditedReplyMessage> | <FinalFiles>           | <Buttons> |
    Examples:
      | CreateParty | Subject                    | MessageAttachedFiles       | ReplyParty   | ReplyRole | OriginReplyMessage        | ReplyAttachedFiles | RejectRole      | EditRole     | EditedReplyMessage      | RemovedFiles  | AddedFiles    | ApproveRole | FinalFiles    | MessageBubble  | ReplyBubble | Buttons                         |
      | applicant   | Test approve pending reply | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary  | maker     | Original reply message #1 | Doc3_62KB.pdf      | checker         | makerChecker | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | approver    | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | issuingBank | Test approve pending reply | Doc1_1MB.pdf,Doc2_62KB.pdf | advisingBank | maker     | Original reply message #1 | Doc3_62KB.pdf      | checkerApprover | maker        | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | maker       | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# |                                 |

  @P2PDC-Reply-Approve-2
  Scenario Outline: Approver role account can approve a pending edited reply with/wihout attachment but non approver roles cannot
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | Original message                               |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <OriginReplyMessage> |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <RejectRole> login and Reject p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <ReplyParty> <EditRole> login and Edit p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Edited Message | <EditedReplyMessage> |
      | Remove Files   | <RemovedFiles>       |
      | Add Files      | <AddedFiles>         |
    Given <ReplyParty> <ApproveRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Approve at message "<EditedReplyMessage>"
    And I click on the button "approvePopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message              | Attachment             | Buttons |
      | <MessageBubble> | <CreateParty> | Original message     | <MessageAttachedFiles> |         |
      | <ReplyBubble>   | <ReplyParty>  | <EditedReplyMessage> | <FinalFiles>           |         |

    Examples:
      | CreateParty | Subject                    | MessageAttachedFiles       | ReplyParty  | ReplyRole | OriginReplyMessage        | ReplyAttachedFiles | RejectRole | EditRole     | EditedReplyMessage      | RemovedFiles  | AddedFiles    | ApproveRole | FinalFiles    | MessageBubble  | ReplyBubble |
      | applicant   | Test approve pending reply | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | Original reply message #1 | Doc3_62KB.pdf      | checker    | makerChecker | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | approver    | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | applicant   | Test approve pending reply | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | Original reply message #1 | Doc3_62KB.pdf      | checker    | makerChecker | Edited reply message #1 | Doc3_62KB.pdf |               | approver    |               | #OTHER_BUBBLE# | #MY_BUBBLE# |
