@P2PMsg
@VTX-1906
@VTX-1908
Feature: Send a reply to p2p General message with/without attachments

  As a user, I should be able to reply a p2p General messaage with/without attachment.
  For example, as an advising bank I may want to send the beneficiary a copy of my bank schedule with instructions on presentations.
  Zeplin: https://zpl.io/bPJBR46

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

  @P2PDC-Reply-Create-1
  Scenario Outline: A party can send a reply to delivered p2p message with/wihtout attachments
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> admin1 login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "<Subject>" from listing
    And I reply p2p General message with the following values
      | Message    | <ReplyMessage>       |
      | Attachment | <ReplyAttachedFiles> |
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message        | Attachment             | Buttons | Have Reject Label | Reject Comment |
      | <MessageBubble> | <CreateParty> | <Message>      | <MessageAttachedFiles> |         | #NO#              |                |
      | <ReplyBubble>   | <ReplyParty>  | <ReplyMessage> | <ReplyAttachedFiles>   |         | #NO#              |                |
    Examples:
      | CreateParty  | ReplyParty  | Subject                 | Message          | ReplyMessage              | MessageAttachedFiles       | ReplyAttachedFiles | HaveAttachmentIcon | MessageBubble  | ReplyBubble |
      | applicant    | beneficiary | Test message with reply | Original message | Original Reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf | Doc3_62KB.pdf      | #YES#              | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | beneficiary  | applicant   | Test message with reply | Original message | Original Reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf |                    | #YES#              | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | advisingBank | issuingBank | Test message with reply | Original message | Original Reply message #1 |                            | Doc3_62KB.pdf      | #YES#              | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | issuingBank  | applicant   | Test message with reply | Original message | Original Reply message #1 |                            |                    | #NO#               | #OTHER_BUBBLE# | #MY_BUBBLE# |


  @P2PDC-Reply-Create-2
  Scenario Outline: A maker role cannot send a reply to pending p2p message with/without attachements
    Given <CreateParty> <CreateRole> login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | Doc1_1MB.pdf,Doc2_62KB.pdf                     |
    And <CreateParty> <ReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "<Subject>" from listing
    Then I expect the Message view to match reference "<VRRef>"
    Examples:
      | CreateParty | CreateRole   | Subject                                | Message          | ReplyRole    | VRRef                            |
      | applicant   | maker        | Test pending message cannot have reply | Original message | makerChecker | p2p/reply/applicantNoUIToReply   |
      | beneficiary | makerChecker | Test pending message cannot have reply | Original message | maker        | p2p/reply/beneficiaryNoUIToReply |

  @P2PDC-Reply-Create-3
  Scenario Outline: A maker role account can send a pending reply to a delivered p2p message wiht/without attacments
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "<Subject>" from listing
    And I reply p2p General message with the following values
      | Message    | <ReplyMessage>       |
      | Attachment | <ReplyAttachedFiles> |
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message        | Attachment             | Buttons | Have Reject Label | Reject Comment |
      | <MessageBubble> | <CreateParty> | <Message>      | <MessageAttachedFiles> |         | #NO#              |                |
      | #PENDING_BAR#   |               |                |                        |         |                   |                |
      | <ReplyBubble>   | <ReplyParty>  | <ReplyMessage> | <ReplyAttachedFiles>   |         | #NO#              |                |
    Examples:
      | CreateParty | Subject                                 | Message          | MessageAttachedFiles       | ReplyParty   | ReplyRole    | ReplyMessage              | ReplyAttachedFiles | MessageBubble  | ReplyBubble |
      | applicant   | Test pending reply at delivered message | Original message | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary  | maker        | Original Reply message #1 | Doc3_62KB.pdf      | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | issuingBank | Test pending reply at delivered message | Original message |                            | advisingBank | makerChecker | Original Reply message #1 |                    | #OTHER_BUBBLE# | #MY_BUBBLE# |

  @P2PDC-Reply-Create-4
  @VTX-3350
  Scenario Outline: A reply should show upload errors when uploading files that are not pdfs
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject | <Subject>                                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | <Message>                                      |
    And <ReplyParty> <ReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "<Subject>" from listing
    And I attach files "<InvalidFiles>" to p2p message
    Then I expect the Message view to match reference "<VRRef>"
    Examples:
      | CreateParty | Subject                                  | Message          | InvalidFiles  | ReplyParty   | ReplyRole | VRRef                                                 |
      | applicant   | Test uploading non pdf file              | Original message | PNG1_7KB.png  | beneficiary  | maker     | p2p/reply-create-4/beneficiaryReplyUploadNonPDFFile   |
      | issuingBank | Test uploading bigger pdf file than 10MB | Original message | Doc4_11MB.pdf | advisingBank | maker     | p2p/reply-create-4/advisingBankReplyUpload11MBPDFFile |
