@P2PMsg
@VTX-2637
Feature: a p2p message with reply can be mark and read and unread

  - Messages will only be marked as ‘read’ if a user with Maker functionality opens the P2P message.
  - A Maker can mark a message as ‘unread’ after the message is opened.
  - New P2P messages will be highlighted. Call-to-action and unread messages will share the same UI logic.
  - Read and Unread is at the company level
  - CTA is on the Maker, Checker, Approver level
  - A message with a CTA cannot be marked as read if the User does not complete the CTA request
  - A message without a CTA can be marked read/unread
  - An unread message will have a bold highlight of the last sender and subject, and a red CTA bar

  Background: Setup dc for p2p testing
    Given I setup test scenario context
    And issuing bank issued dc for scenario sc1

  @P2PDC-Reply-Status-1
  Scenario Outline: a p2p message with reply can be marked as read after maker role opens it but other roles cannot, the read status is at company level
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | Test that only maker can mark message with reply as read by open it |
      | To      | applicant,beneficiary,issuingBank,advisingBank                      |
      | Message | test message                                                        |
    And I pause for 3000ms
    Given <ReplyThreadParty> admin1 login and open current dc
    And I am at P2P message listing under DC
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 3000ms
    Given <ReadThreadParty> <FirstReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button "dcSideMenu"."dcForm"
    And I click on the button "dcSideMenu"."p2pMessage"
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<FirstReadReference>"
    Given <ReadThreadParty> <SecondReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<SecondReadReference>"
    Given <ReadThreadParty> <ThirdReadThreadRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<ThirdReadReference>"
    Examples:
      | CreateThreadParty | ReplyThreadParty | ReadThreadParty | FirstReadThreadRole | FirstReadReference                                    | SecondReadThreadRole | SecondReadReference                                   | ThirdReadThreadRole | ThirdReadReference                                     |
      | applicant         | beneficiary      | issuingBank     | maker               | p2p/dc/reply-status-1/e1/readMessageMarkedOpenByMaker | checker              | p2p/dc/reply-status-1/e1/readMessageViewedByChecker   | approver            | p2p/dc/reply-status-1/e1/readMessageViewedByApprover   |
      | applicant         | beneficiary      | issuingBank     | checker             | p2p/dc/reply-status-1/e2/unreadMessageOpenByChecker   | maker                | p2p/dc/reply-status-1/e2/unreadMessageViewedByMaker   | approver            | p2p/dc/reply-status-1/e2/unreadMessageViewedByApprover |
      | applicant         | beneficiary      | issuingBank     | approver            | p2p/dc/reply-status-1/e3/unreadMessageOpenByApprover  | checker              | p2p/dc/reply-status-1/e3/unreadMessageViewedByChecker | maker               | p2p/dc/reply-status-1/e3/unreadMessageViewedByMaker    |


  @P2PDC-Reply-Status-2
  Scenario Outline: maker role can mark p2p message with reply as read via ui
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | Test that only maker can mark message with reply as read by UI |
      | To      | applicant,beneficiary,issuingBank,advisingBank                 |
      | Message | test message #SHORT_UUID#                                      |
    And I pause for 3000ms
    Given <ReplyThreadParty> admin1 login and open current dc
    And I am at P2P message listing under DC
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 3000ms
    Given <MarkingThreadParty> <MarkingRole> login and open current dc
    And I am at P2P message listing under DC
    When I toggle read status at message with subject "#P2P_LATEST_SUBJECT#"
    And I move to element "p2pMessageListing"."searchInput"
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<FirstVRReference>"
    Given <MarkingThreadParty> <FirstViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<SecondVRReference>"
    Given <MarkingThreadParty> <SecondViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<ThirdVRReference>"
    Examples:
      | CreateThreadParty | ReplyThreadParty | MarkingThreadParty | MarkingRole | FirstViewRole | SecondViewRole | FirstVRReference                                 | SecondVRReference                                | ThirdVRReference                                  |
      | applicant         | beneficiary      | issuingBank        | maker       | checker       | approver       | p2p/dc/reply-status-2/e1/readStatusToggleByMaker | p2p/dc/reply-status-2/e1/readStatusViewByChecker | p2p/dc/reply-status-2/e1/readStatusViewByApprover |

  @P2PDC-Reply-Status-3
  Scenario Outline: a call to action ui always shows for users who have action to do with reply in p2p message either with read/unread status.
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID#                      |
      | To      | applicant,beneficiary,issuingBank,advisingBank |
      | Message | test message #SHORT_UUID#                      |
    And I pause for 3000ms
    Given <ReplyParty> <ReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Given <ReplyParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    Then I expect message with subject "#P2P_LATEST_SUBJECT#" to match reference "<VRReference>"
    Examples:
      | CreateThreadParty | ReplyParty  | ReplyRole | ViewRole | VRReference                                                     |
      | applicant         | beneficiary | maker     | checker  | p2p/dc/reply-status-3/e1/callToActionAtReadMesageForChecker     |
      | applicant         | beneficiary | maker     | approver | p2p/dc/reply-status-3/E2s/noCallToActionAtReadMesageForApprover |
