@P2PMsg
@VTX-2636
Feature: checker and approver role user can reject a pending reply to general p2p message, then maker can discard the message

  As a checker of applicant, beneficiary, issuing bank, advising bank, nominated bank, or requested confirmation party,
  I would like to verify reply general message
  Background: Setup screen size and setup DC to be used for testing
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "admin1"


 @P2PDC-Reject-Status-1
  Scenario Outline: all party's checker and approver role can add internal comment when rejects a reply submited by maker
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID# |
      | To      | applicant,beneficiary     |
      | Message | test message              |
    And I pause for 3000ms
    Given <CreateReplyParty> <CreateReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 3000ms
    Given <CreateReplyParty> <VerifyReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Reject at message "#P2P_LATEST_REPLY#"
    When I set "<RejectComment>" to the inputfield "rejectPopup"."commentInput"
    When I click on the button "rejectPopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type       | Sender              | Message       | Attachment | Buttons | Have Reject Label | Reject Comment |
      | #MY_BUBBLE#   | <CreateThreadParty> | test message  |            |         | #NO#              |                |
      | #PENDING_BAR# |                     |               |            |         |                   |                |
      | #MY_BUBBLE#   | <CreateThreadParty> | reply message |            |         | #YES#             | reject reason  |
    Examples:
      | CreateThreadParty | CreateReplyParty | CreateReplyRole | VerifyReplyRole | RejectComment |
      | applicant         | applicant        | maker           | checker         | reject reason |
      | applicant         | applicant        | maker           | checkerApprover | reject reason |
      | applicant         | applicant        | makerChecker    | approver        | reject reason |

 @P2PDC-Reject-Status-2
  Scenario Outline: all party's maker role can see internal comment, edit button, and discard button at rejected reply
    Given <CreateThreadParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID# |
      | To      | applicant,beneficiary     |
      | Message | test message              |
    And I pause for 3000ms
    Given <CreateReplyParty> <CreateReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    And I pause for 3000ms
    Given <CreateReplyParty> <VerifyReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Reject at message "#P2P_LATEST_REPLY#"
    When I set "<RejectComment>" to the inputfield "rejectPopup"."commentInput"
    When I click on the button "rejectPopup"."confirmButton"
    Given <CreateReplyParty> <CreateReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type       | Sender              | Message       | Attachment | Buttons                        | Have Reject Label | Reject Comment |
      | #MY_BUBBLE#   | <CreateThreadParty> | test message  |            |                                | #NO#              |                |
      | #PENDING_BAR# |                     |               |            |                                |                   |                |
      | #MY_BUBBLE#   | <CreateThreadParty> | reply message |            | #EDIT_BUTTON#,#DISCARD_BUTTON# | #YES#             | reject reason  |
    Examples:
      | CreateThreadParty | CreateReplyParty | CreateReplyRole | VerifyReplyRole | RejectComment |
      | applicant         | applicant        | maker           | checker         | reject reason |
      | applicant         | applicant        | maker           | checkerApprover | reject reason |
      | applicant         | applicant        | makerChecker    | approver        | reject reason |


 @P2PDC-Reject-Status-3
  Scenario Outline: all party's maker role can discard rejected reply done by checker or approver role
    Given <CreateReplyParty> admin1 login and open current dc
    And I am at New p2p message under DC
    And I select message type as General message
    When I create p2p General message with the following values
      | Subject | test subject #SHORT_UUID# |
      | To      | applicant,beneficiary     |
      | Message | test message              |
    When I pause for 3000ms
    Given <CreateReplyParty> <CreateReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I reply p2p General message with the following values
      | Message | reply message 1 |
    When I pause for 3000ms
    Given <CreateReplyParty> <VerifyReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Reject at message "#P2P_LATEST_REPLY#"
    When I click on the button "rejectPopup"."confirmButton"
    Given <CreateReplyParty> <CreateReplyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Discard at message "#P2P_LATEST_REPLY#"
    And I click on the button "discardPopup"."confirmButton"
    And I refresh P2P page
    And I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type     | Sender              | Message      | Attachment | Buttons | Have Reject Label | Reject Comment |
      | #MY_BUBBLE# | <CreateThreadParty> | test message |            |         |                   |                |
    Examples:
      | CreateThreadParty | CreateReplyParty | CreateReplyRole | VerifyReplyRole | RejectComment |
      | applicant         | applicant        | maker           | checker         | reject reason |
      | applicant         | applicant        | makerChecker    | approver        | reject reason |

