@P2PMsg
@VTX-1906
@VTX-1908
Feature: Checker role user can verify pending replies at General message sent by maker role

  As a checker, I would like to verify pending replies at General message sent by maker role

  Background: Setup scenario context and dc to create p2p message at
    Given I setup test scenario context
    And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

  @P2PDC-Verify-Status-1
  Scenario Outline: Checker role account can see UI for verifying a pending reply for General message with/wihout attachment but non checker roles cannot
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <Reply>              |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <VerifyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message   | Attachment             | Buttons   |
      | <MessageBubble> | <CreateParty> | <Message> | <MessageAttachedFiles> |           |
      | #PENDING_BAR#   |               |           |                        |           |
      | <ReplyBubble>   | <ReplyParty>  | <Reply>   | <ReplyAttachedFiles>   | <Buttons> |
    Examples:
      | CreateParty  | Subject                   | Message          | Reply                     | MessageAttachedFiles       | ReplyParty  | ReplyRole | VerifyRole | ReplyAttachedFiles | MessageBubble  | ReplyBubble | Buttons                         |
      | applicant    | Test verify pending reply | Original message | Original reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | checker    | Doc3_62KB.pdf      | #OTHER_BUBBLE# | #MY_BUBBLE# | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | issuingBank  | Test verify pending reply | Original message | Original reply message #1 |                            | issuingBank | maker     | checker    |                    | #MY_BUBBLE#    | #MY_BUBBLE# | #VERIFY_BUTTON#,#REJECT_BUTTON# |
      | advisingBank | Test verify pending reply | Original message | Original reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf | issuingBank | maker     | maker      | Doc3_62KB.pdf      | #OTHER_BUBBLE# | #MY_BUBBLE# |                                 |
      | beneficiary  | Test verify pending reply | Original message | Original reply message #1 |                            | beneficiary | maker     | approver   |                    | #MY_BUBBLE#    | #MY_BUBBLE# |                                 |

  @P2PDC-Verify-Status-2
  Scenario Outline: Checker role account can verify pending reply sent by maker with/wihout attachment
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | <Message>                                      |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <Reply>              |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <VerifyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "<Reply>"
    And I click on the button "verifyPopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message   | Attachment             | Buttons |
      | <MessageBubble> | <CreateParty> | <Message> | <MessageAttachedFiles> |         |
      | #PENDING_BAR#   |               |           |                        |         |
      | <ReplyBubble>   | <ReplyParty>  | <Reply>   | <ReplyAttachedFiles>   |         |
    Examples:
      | CreateParty | Subject                   | Message          | Reply                     | MessageAttachedFiles       | ReplyParty  | ReplyRole | VerifyRole      | ReplyAttachedFiles | MessageBubble  | ReplyBubble |
      | applicant   | Test verify pending reply | Original message | Original reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | checker         | Doc3_62KB.pdf      | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | issuingBank | Test verify pending reply | Original message | Original reply message #1 | Doc1_1MB.pdf,Doc2_62KB.pdf | issuingBank | maker     | checkerApprover | Doc3_62KB.pdf      | #MY_BUBBLE#    | #MY_BUBBLE# |
      | beneficiary | Test verify pending reply | Original message | Original reply message #1 |                            | applicant   | maker     | checker         | Doc3_62KB.pdf      | #OTHER_BUBBLE# | #MY_BUBBLE# |
      | issuingBank | Test verify pending reply | Original message | Original reply message #1 |                            | issuingBank | maker     | checkerApprover |                    | #MY_BUBBLE#    | #MY_BUBBLE# |

  @P2PDC-Verify-Status-3
  Scenario Outline: Only checker role can see verify UI for edited reply sent by maker role
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | Original message                               |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <OriginReplyMessage> |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <VerifyRole> login and Reject p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <ReplyParty> <EditRole> login and Edit p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Edited Message | <EditedReplyMessage> |
      | Remove Files   | <RemovedFiles>       |
      | Add Files      | <AddedFiles>         |
    Given <ReplyParty> <ViewRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message              | Attachment             | Buttons   |
      | <MessageBubble> | <CreateParty> | Original message     | <MessageAttachedFiles> |           |
      | #PENDING_BAR#   |               |                      |                        |           |
      | <ReplyBubble>   | <ReplyParty>  | <EditedReplyMessage> | <FinalFiles>           | <Buttons> |
    Examples:
      | CreateParty | Subject                   | OriginalMessage  | MessageAttachedFiles       | ReplyParty  | ReplyRole | OriginReplyMessage        | ReplyAttachedFiles | VerifyRole      | EditRole | EditedReplyMessage      | RemovedFiles  | AddedFiles    | FinalFiles    | MessageBubble  | ReplyBubble | Buttons                         | ViewRole |
      | applicant   | Test verify pending reply | Original message | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | Original reply message #1 | Doc3_62KB.pdf      | checker         | maker    | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# | #VERIFY_BUTTON#,#REJECT_BUTTON# | checker  |
      | applicant   | Test verify pending reply | Original message | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | Original reply message #1 | Doc3_62KB.pdf      | checkerApprover | maker    | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# |                                 | approver |

  @P2PDC-Verify-Status-4
  Scenario Outline: Checker role can see verify edited reply sent by maker role
    Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
      | Subject    | <Subject>                                      |
      | To         | applicant,beneficiary,issuingBank,advisingBank |
      | Message    | Original message                               |
      | Attachment | <MessageAttachedFiles>                         |
    And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Message    | <OriginReplyMessage> |
      | Attachment | <ReplyAttachedFiles> |
    And <ReplyParty> <VerifyRole> login and Reject p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
    And <ReplyParty> <EditRole> login and Edit p2p message "<OriginReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
      | Edited Message | <EditedReplyMessage> |
      | Remove Files   | <RemovedFiles>       |
      | Add Files      | <AddedFiles>         |
    Given <ReplyParty> <VerifyRole> login and open current dc
    And I am at P2P message listing under DC
    When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
    And I click on the button Verify at message "<EditedReplyMessage>"
    And I click on the button "verifyPopup"."confirmButton"
    Then I can view body of General message and see the following messages
      | UI Type         | Sender        | Message              | Attachment             | Buttons |
      | <MessageBubble> | <CreateParty> | Original message     | <MessageAttachedFiles> |         |
      | #PENDING_BAR#   |               |                      |                        |         |
      | <ReplyBubble>   | <ReplyParty>  | <EditedReplyMessage> | <FinalFiles>           |         |
    Examples:
      | CreateParty | Subject                   | MessageAttachedFiles       | ReplyParty  | ReplyRole | OriginReplyMessage        | ReplyAttachedFiles | VerifyRole | EditRole | EditedReplyMessage      | RemovedFiles  | AddedFiles    | FinalFiles    | MessageBubble  | ReplyBubble |
      | applicant   | Test verify pending reply | Doc1_1MB.pdf,Doc2_62KB.pdf | beneficiary | maker     | Original reply message #1 | Doc3_62KB.pdf      | checker    | maker    | Edited reply message #1 | Doc3_62KB.pdf | Doc5_62KB.pdf | Doc5_62KB.pdf | #OTHER_BUBBLE# | #MY_BUBBLE# |
