@P2PMsg
@VTX-2110
Feature: View P2P message UI

    As a user, I should be able to view that there is a P2P message associated with a transaction at any point

    Background: Set up scenario context
        Given I setup test scenario context
        And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"

    @P2PDC-UI-1
    @VTX-3201
    @VTX-3203
    Scenario Outline: P2P message display with many conversation bubbles with/without attachments
        Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
            | Subject    | Test display bubbles                           |
            | To         | applicant,beneficiary,issuingBank,advisingBank |
            | Message    | Original message                               |
            | Attachment | <MessageAttachment>                            |
        And <ReplyParty> admin1 login and open current dc
        And I am at P2P message listing under DC
        When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
        And I reply p2p General message with the following values
            | Message    | reply 1            |
            | Attachment | <ReplyAttachment1> |
        And I reply p2p General message with the following values
            | Message    | reply 2            |
            | Attachment | <ReplyAttachment2> |
        And I reply p2p General message with the following values
            | Message    | reply 3            |
            | Attachment | <ReplyAttachment3> |
        And I reply p2p General message with the following values
            | Message    | reply 4            |
            | Attachment | <ReplyAttachment4> |
        And I reply p2p General message with the following values
            | Message    | reply 5            |
            | Attachment | <ReplyAttachment5> |
        When I move to p2p message "reply 5"
        And I scroll to p2p message "Original message"
        Then I expect the Message view to match reference "<VRRef>"
        Examples:
            | CreateParty | ReplyParty  | VRRef                                             | MessageAttachment | ReplyAttachment1 | ReplyAttachment2 | ReplyAttachment3 | ReplyAttachment4 | ReplyAttachment5 |
            | applicant   | issuingBank | p2p/dc/ui-1/e1/longConversationWithAttachments    | Doc1_1MB.pdf      | Doc2_62KB.pdf    | Doc3_62KB.pdf    | Doc5_62KB.pdf    | Doc6_62KB.pdf    | Doc7_62KB.pdf    |
            | applicant   | issuingBank | p2p/dc/ui-1/e2/longConversationWithoutAttachments |                   |                  |                  |                  |                  |                  |


    @VTX3202
    @P2PDC-UI-2
    Scenario Outline: P2P Mesage switching
        Given <CreateParty> admin1 login and open current dc
        And I am at New p2p message under DC
        And I select message type as General message
        When I create p2p General message with the following values
            | Subject    | <Subject1>                                     |
            | To         | applicant,beneficiary,issuingBank,advisingBank |
            | Message    | Original message 1                             |
            | Attachment | <MessageAttachment1>                           |
        And I pause for 4000ms
        When I click on the button "p2pMessageListing"."newButton"
        And I select message type as General message
        When I create p2p General message with the following values
            | Subject    | <Subject2>                                     |
            | To         | applicant,beneficiary,issuingBank,advisingBank |
            | Message    | Original message 2                             |
            | Attachment | <MessageAttachment2>                           |
        And I open p2p message which has subject "<Subject1>" from listing
        Then I expect the Message view to match reference "<VRRef1>"
        And I open p2p message which has subject "<Subject2>" from listing
        Then I expect the Message view to match reference "<VRRef2>"
        Examples:
            | CreateParty | Subject1              | MessageAttachment1          | Subject2              | MessageAttachment2          | VRRef1                                              | VRRef2                                           |
            | applicant   | P2P general message 1 | Doc2_62KB.pdf,Doc3_62KB.pdf | P2P general message 2 | Doc5_62KB.pdf,Doc6_62KB.pdf | p2p/dc/ui-2/e1/p2pMessageSubject1WithAttachments    | p2p/ui-2/e1/p2pMessageSubject2WithAttachments    |
            | applicant   | P2P general message 1 |                             | P2P general message 2 |                             | p2p/dc/ui-2/e2/p2pMessageSubject1WithoutAttachments | p2p/ui-2/e2/p2pMessageSubject2WithoutAttachments |

    @VTX-3254
    @VTX-3291
    @P2PDC-UI-3
    Scenario Outline: Send button disabled if subject, recipients and message have not been filled
        Given <CreateParty> admin1 login and open current dc
        And I am at New p2p message under DC
        And I select message type as General message
        When I fill in p2p General message with the following values
            | Subject | <Subject>    |
            | To      | <Recipients> |
            | Message | <Message>    |
        Then I expect that element "p2pMessage"."sendButton" <Enabled> enabled
        Examples:
            | CreateParty | Subject   | Recipients                                     | Message      | Enabled |
            | applicant   |           |                                                |              | is not  |
            | applicant   | Subject 2 |                                                |              | is not  |
            | applicant   | Subject 3 | applicant,beneficiary,issuingBank,advisingBank |              | is not  |
            | applicant   | Subject 4 | applicant,beneficiary,issuingBank,advisingBank | Test message | is      |

    @VTX-3280
    @P2PDC-UI-4
    Scenario Outline: Close button at p2p message should notify user with leave message popup
        Given <CreateParty> admin1 login and open current dc
        And I am at New p2p message under DC
        And I select message type as General message
        When I fill in p2p General message with the following values
            | Subject | <Subject>    |
            | To      | <Recipients> |
            | Message | <Message>    |
        And I click on the button "p2pMessage"."closeButton"
        And I click on the button "leavePopup"."<ActionButton>"
        Then I expect the Message view to match reference "<VRRef>"
        Examples:
            | CreateParty | Subject   | Recipients                                     | Message      | VRRef                                                | ActionButton |
            | applicant   | Subject 1 | applicant,beneficiary,issuingBank,advisingBank | Test message | p2p/dc/ui-4/e1/noNewP2PMessageUI                     | leaveButton  |
            | applicant   | Subject 1 | applicant,beneficiary,issuingBank,advisingBank | Test message | p2p/dc/ui-4/e2/notClearedAllP2PMessage               | stayButton   |
            | applicant   | Subject 1 | applicant,beneficiary,issuingBank,advisingBank |              | p2p/dc/ui-4/e3/notClearedRecipientsSubjectP2PMessage | stayButton   |
            | applicant   | Subject 1 |                                                |              | p2p/dc/ui-4/e4/notClearedSubjectP2PMessage           | stayButton   |
            | applicant   |           |                                                |              | p2p/dc/ui-4/e5/blankP2PMessage                       | stayButton   |

    @VTX-3386
    @P2PDC-UI-5
    Scenario Outline: Click at new message button should not do anything if already at create new message ui
        Given <CreateParty> admin1 login and open current dc
        And I am at New p2p message under DC
        And I select message type as General message
        When I fill in p2p General message with the following values
            | Subject | Subject 1                                      |
            | To      | applicant,beneficiary,issuingBank,advisingBank |
            | Message | Message 1                                      |
        And I click on the button "p2pMessageListing"."newButton"
        Then I expect the Message view to match reference "<VRRef>"
        Examples:
            | CreateParty | VRRef                                       |
            | applicant   | p2p/dc/ui-5/e1/noChangedIfClickAtNewMessage |

    @VTX-3476
    @P2PDC-UI-6
    Scenario Outline: Display empty/stand by view if no message or create new message selected
        Given <CreateParty> admin1 login and open current dc
        And I am at P2P message listing under DC
        Then I expect the Message view to match reference "<VRRef>"
        Examples:
            | CreateParty | VRRef                          |
            | applicant   | p2p/dc/ui-6/e1/standByViewPort |

