@P2PMsg
Feature: Maker role user can edit rejected reply at General message and send again

    As a maker role account, I would like to eidt and submit rejected reply

    Background: Setup scenario context and dc to create p2p message at
        Given I setup test scenario context
        And issuingBank issued dc for scenario sc1 proceeded by "maker.checkerApprover"


    @P2PDC-Reply-Edit-1
    Scenario Outline: Only maker role account can see edit and discard UI at rejected reply with/without attachments and other roles cannot
        Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
            | Subject | <Subject>                                      |
            | To      | applicant,beneficiary,issuingBank,advisingBank |
            | Message | Original message                               |
        And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
            | Message    | <ReplyMessage>       |
            | Attachment | <ReplyAttachedFiles> |
        And <ReplyParty> <VerifyRole> login and Reject p2p message "<ReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
        And <ReplyParty> <ViewRole> login and open current dc
        And I am at P2P message listing under DC
        When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
        Then I can view body of General message and see the following messages
            | UI Type        | Sender        | Message          | Buttons          | Attachment           |
            | #OTHER_BUBBLE# | <CreateParty> | Original message |                  |                      |
            | #PENDING_BAR#  |               |                  |                  |                      |
            | #MY_BUBBLE#    | <ReplyParty>  | <ReplyMessage>   | <MessageButtons> | <ReplyAttachedFiles> |
        Examples:
            | CreateParty  | Subject                                                       | ReplyParty   | ReplyRole | ReplyMessage            | VerifyRole      | ViewRole | MessageButtons                 | ReplyAttachedFiles          |
            | applicant    | Test edit and discard UI at rejected message view by maker    | beneficiary  | maker     | Orginal reply message#1 | checker         | maker    | #EDIT_BUTTON#,#DISCARD_BUTTON# | Doc2_62KB.pdf,Doc3_62KB.pdf |
            | issuingBank  | Test edit and discard UI at rejected message view by maker    | advisingBank | maker     | Orginal reply message#1 | checker         | maker    | #EDIT_BUTTON#,#DISCARD_BUTTON# |                             |
            | beneficiary  | Test edit and discard UI at rejected message view by checker  | applicant    | maker     | Orginal reply message#1 | checkerApprover | checker  |                                | Doc3_62KB.pdf               |
            | advisingBank | Test edit and discard UI at rejected message view by approver | issuingBank  | maker     | Orginal reply message#1 | makerChecker    | approver |                                |                             |

    @P2PDC-Reply-Edit-2
    Scenario Outline: Only maker role account can edit rejected reply with/without attachments and resend for approval
        Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
            | Subject | <Subject>                                      |
            | To      | applicant,beneficiary,issuingBank,advisingBank |
            | Message | Original message                               |
        And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
            | Message    | <OriginalReplyMessage> |
            | Attachment | <ReplyAttachedFiles>   |
        And <ReplyParty> <VerifyRole> login and Reject p2p message "<OriginalReplyMessage>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
        And <ReplyParty> <EditRole> login and open current dc
        And I am at P2P message listing under DC
        When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
        And I click on the button Edit at message "<OriginalReplyMessage>"
        And I set "<EditedReplyMessage>" to the inputfield "p2pMessage"."viewMessageTextArea"
        When I attach files "<AddedFiles>" to p2p message
        When I remove files "<RemovedFiles>" from p2p message
        When I click on the button "p2pMessage"."sendButton"
        And I click on the button "updateAndSendMessagePopup"."confirmButton"
        Then I can view body of General message and see the following messages
            | UI Type        | Sender        | Message              | Attachment   | Buttons |
            | #OTHER_BUBBLE# | <CreateParty> | Original message     |              |         |
            | #PENDING_BAR#  |               |                      |              |         |
            | #MY_BUBBLE#    | <ReplyParty>  | <EditedReplyMessage> | <FinalFiles> |         |
        Examples:
            | CreateParty | Subject                               | ReplyParty   | ReplyRole | OriginalReplyMessage    | EditedReplyMessage     | VerifyRole | EditRole | ReplyAttachedFiles         | AddedFiles    | RemovedFiles | FinalFiles                  |
            | applicant   | Test edit and resend rejected message | beneficiary  | maker     | Orginal reply message#1 | Edited reply message#1 | checker    | maker    | Doc1_1MB.pdf,Doc2_62KB.pdf | Doc5_62KB.pdf | Doc1_1MB.pdf | Doc2_62KB.pdf,Doc5_62KB.pdf |
            | issuingBank | Test edit and resend rejected message | advisingBank | maker     | Orginal reply message#1 | Edited reply message#1 | checker    | maker    |                            | Doc5_62KB.pdf |              | Doc5_62KB.pdf               |

    @VTX-3393
    @VTX-3392
    @VTX-3401
    @P2PDC-Reply-Edit-3
    Scenario Outline: Error messages from uploading invalid files should be cleared after click edit rejected message again
        Given <CreateParty> admin1 login and create p2p General message at current dc under DC with the following values
            | Subject | <Subject>                                      |
            | To      | applicant,beneficiary,issuingBank,advisingBank |
            | Message | Original message                               |
        And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
            | Message | <OriginalReplyMessage1> |
        And <ReplyParty> <ReplyRole> login and Reply to message subject "#P2P_LATEST_SUBJECT#" at current dc under DC with the following values
            | Message | <OriginalReplyMessage2> |
        And <ReplyParty> <RejectRole> login and Reject p2p message "<OriginalReplyMessage1>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
        And <ReplyParty> <RejectRole> login and Reject p2p message "<OriginalReplyMessage2>" with subject "#P2P_LATEST_SUBJECT#" at current dc under DC
        And <ReplyParty> <EditRole> login and open current dc
        And I am at P2P message listing under DC
        When I open p2p message which has subject "#P2P_LATEST_SUBJECT#" from listing
        And I click on the button Edit at message "<OriginalReplyMessage1>"
        When I attach files "<AddedFiles>" to p2p message
        And I click on the button "p2pMessage"."cancelButton"
        And I click on the button "cancelPopup"."confirmButton"
        Then I expect the Message view to match reference "<VRRef>"
        Examples:
            | CreateParty | Subject                                                      | ReplyParty  | ReplyRole | OriginalReplyMessage1     | OriginalReplyMessage2     | RejectRole | EditRole     | AddedFiles                                                           | VRRef                                             |
            | applicant   | Test error message clear with non pdf after click edit reply | beneficiary | maker     | Original reply message #1 | Original reply message #2 | checker    | makerChecker | Doc2_62KB.pdf,Doc2_62KB.pdf,Doc3_62KB.pdf,Doc4_11MB.pdf,PNG1_7KB.png | p2p/dc/reply-edit-3/noErrorMessageAfterCancelEdit |
