@P2PMsg
@VTX-1812
Feature: Bank parties' maker role account can notify other arties including beneficiary and applicant about DP discrepancy with notice of discrepancy p2p

    As a bank user, I would like to send notice of discrepancy to notify other parties about discrepancies in DP
    Background: Beneficiary submit DP to nominated bank
        Given I setup test scenario context
        And beneficiary present DP to "issuingBank" through "null" at dc sc1

    @P2PNod-Creation-Create-1
    Scenario Outline: Banks parties can see Notice of discrepancy p2p message at DP
        Given <ViewParty> <ViewRole> login and open DP1 at current DC
        And I am at New p2p message under DP
        When I click on the button "p2pMessage"."messageTypeDropdown"
        Then I expect that element "p2pMessage"."noticeOfDiscrepancyType" <IsDisplayed> displayed
        Examples:
            | ViewParty    | ViewRole | IsDisplayed |
            | issuingBank  | maker    | is          |
            | advisingBank | maker    | is          |
            | applicant    | maker    | is not      |
            | beneficiary  | maker    | is not      |

    @P2PNod-Creation-Create-2
    Scenario Outline: Banks parties can submit Notice of discrepancy at DP to other parties including corporates and all fields have correct data format
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        When I fill in p2p Notice of discrepancy with the following values
            | To                                  | applicant,beneficiary,issuingBank,advisingBank                                                                                                                                      |
            | Principal amount                    | 1000                                                                                                                                                                                |
            | Additional amount                   | 1000                                                                                                                                                                                |
            | Charges to be deducted              | #CHECKED#                                                                                                                                                                           |
            | Charges to be deducted Amount       | 1000                                                                                                                                                                                |
            | Charges to be deducted Charges code | #AGENT#,#COMM#,#CORCOM#,#DISC#,#INSUR#,#POST#,#STAMP#,#TELECHAR#,#WAREHOUS#                                                                                                         |
            | Charges to be deducted Details      | Details of charges to be deducted                                                                                                                                                   |
            | Charges to be added                 | #CHECKED#                                                                                                                                                                           |
            | Charges to be added Amount          | 1000                                                                                                                                                                                |
            | Charges to be added Charges code    | #ACCPTCOM#,#ADVCOM#,#AMNDCOM#,#CONFCOM#,#CORCOM#,#DEFCOM#,#DSCRPCOM#,#HANDLCOM#,#INTEREST#,#MISC#,#NEGCOM#,#NOTFCOM#,#PAYCOM#,#POST#,#PREADCOM#,#SEE72Z#,#SEE77#,#STAMP#,#TELECHAR# |
            | Charges to be added Details         | Details of charges to be addded                                                                                                                                                     |
            | Total amount to be paid             | 1000                                                                                                                                                                                |
            | Account with bank                   | Acount1234567890                                                                                                                                                                    |
            | Sender to receiver information      | Info from sender to receiver                                                                                                                                                        |
            | Notice of discrepancies             | Notice of discrepancies                                                                                                                                                             |
        And I click on the button "p2pMessage"."sendButton"
        And I click on the button "sendMessagePopup"."confirmButton"
        And I wait until loading icon is hidden
        When I open p2p message which has subject "Notice of discrepancy" from listing
        * I scroll to element "noticeOfDiscrepancyView"."firstSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef1>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."secondSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef2>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."thirdSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef3>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."fourthSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef4>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        Examples:
            | SendParty    | VRRef1                                                           | VRRef2                                                           | VRRef3                                                           | VRRef4                                                           |
            | issuingBank  | p2p/dp/p2pnod-creation-create-2/e1/nodSnapSection1AtIssuingBank  | p2p/dp/p2pnod-creation-create-2/e1/nodSnapSection2AtIssuingBank  | p2p/dp/p2pnod-creation-create-2/e1/nodSnapSection3AtIssuingBank  | p2p/dp/p2pnod-creation-create-2/e1/nodSnapSection4AtIssuingBank  |
            | advisingBank | p2p/dp/p2pnod-creation-create-2/e2/nodSnapSection1AtAdvisingBank | p2p/dp/p2pnod-creation-create-2/e2/nodSnapSection2AtAdvisingBank | p2p/dp/p2pnod-creation-create-2/e2/nodSnapSection3AtAdvisingBank | p2p/dp/p2pnod-creation-create-2/e2/nodSnapSection4AtAdvisingBank |

    @P2PNod-Creation-Create-3
    Scenario Outline: All recipients can view Notice of discrepancy at DP submited by a bank party
        Given <SendParty> admin1 login and send Notice of discrepancy at DP1 of current DC with the following values
            | To                                  | applicant,beneficiary,issuingBank,advisingBank                                                                                                                                      |
            | Principal amount                    | 1000                                                                                                                                                                                |
            | Additional amount                   | 1000                                                                                                                                                                                |
            | Charges to be deducted              | #CHECKED#                                                                                                                                                                           |
            | Charges to be deducted Amount       | 1000                                                                                                                                                                                |
            | Charges to be deducted Charges code | #AGENT#,#COMM#,#CORCOM#,#DISC#,#INSUR#,#POST#,#STAMP#,#TELECHAR#,#WAREHOUS#                                                                                                         |
            | Charges to be deducted Details      | Details of charges to be deducted                                                                                                                                                   |
            | Charges to be added                 | #CHECKED#                                                                                                                                                                           |
            | Charges to be added Amount          | 1000                                                                                                                                                                                |
            | Charges to be added Charges code    | #ACCPTCOM#,#ADVCOM#,#AMNDCOM#,#CONFCOM#,#CORCOM#,#DEFCOM#,#DSCRPCOM#,#HANDLCOM#,#INTEREST#,#MISC#,#NEGCOM#,#NOTFCOM#,#PAYCOM#,#POST#,#PREADCOM#,#SEE72Z#,#SEE77#,#STAMP#,#TELECHAR# |
            | Charges to be added Details         | Details of charges to be addded                                                                                                                                                     |
            | Total amount to be paid             | 1000                                                                                                                                                                                |
            | Account with bank                   | Acount1234567890                                                                                                                                                                    |
            | Sender to receiver information      | Info from sender to receiver                                                                                                                                                        |
            | Notice of discrepancies             | Notice of discrepancies                                                                                                                                                             |
        And <ViewParty> maker login and open DP1 at current DC
        And I am at P2P message listing under DP
        When I open p2p message which has subject "Notice of discrepancy" from listing
        * I scroll to element "noticeOfDiscrepancyView"."firstSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef1>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."secondSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef2>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."thirdSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef3>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."fourthSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef4>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        Examples:
            | SendParty   | ViewParty    | VRRef1                                                           | VRRef2                                                           | VRRef3                                                           | VRRef4                                                           |
            | issuingBank | applicant    | p2p/dp/p2pnod-creation-create-3/e1/nodSnapSection1AtApplicant    | p2p/dp/p2pnod-creation-create-3/e1/nodSnapSection2AtApplicant    | p2p/dp/p2pnod-creation-create-3/e1/nodSnapSection3AtApplicant    | p2p/dp/p2pnod-creation-create-3/e1/nodSnapSection4AtApplicant    |
            | issuingBank | beneficiary  | p2p/dp/p2pnod-creation-create-3/e2/nodSnapSection1AtBeneficiary  | p2p/dp/p2pnod-creation-create-3/e2/nodSnapSection2AtBeneficiary  | p2p/dp/p2pnod-creation-create-3/e2/nodSnapSection3AtBeneficiary  | p2p/dp/p2pnod-creation-create-3/e2/nodSnapSection4AtBeneficiary  |
            | issuingBank | advisingBank | p2p/dp/p2pnod-creation-create-3/e3/nodSnapSection1AtAdvisingBank | p2p/dp/p2pnod-creation-create-3/e3/nodSnapSection2AtAdvisingBank | p2p/dp/p2pnod-creation-create-3/e3/nodSnapSection3AtAdvisingBank | p2p/dp/p2pnod-creation-create-3/e3/nodSnapSection4AtAdvisingBank |

    @P2PNod-Creation-Create-4
    Scenario Outline: Bank parties can send Notice of discrepancy with only mandatory fields
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        When I fill in p2p Notice of discrepancy with the following values
            | To                      | applicant,beneficiary,issuingBank,advisingBank |
            | Principal amount        | 1000                                           |
            | Notice of discrepancies | Notice of discrepancies                        |
        And I click on the button "p2pMessage"."sendButton"
        And I click on the button "sendMessagePopup"."confirmButton"
        And I wait until loading icon is hidden
        When I open p2p message which has subject "Notice of discrepancy" from listing
        * I scroll to element "noticeOfDiscrepancyView"."firstSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef1>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."secondSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef2>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."thirdSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef3>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."fourthSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef4>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        Examples:
            | SendParty   | VRRef1                                             | VRRef2                                             | VRRef3                                             | VRRef4                                             |
            | issuingBank | p2p/dp/p2pnod-creation-create-4/e1/nodSnapSection1 | p2p/dp/p2pnod-creation-create-4/e1/nodSnapSection2 | p2p/dp/p2pnod-creation-create-4/e1/nodSnapSection3 | p2p/dp/p2pnod-creation-create-4/e1/nodSnapSection4 |

    @VTX-3385
    @VTX-3439
    @P2PNod-Creation-Create-5
    Scenario Outline: Error messages showing up when missing mandatory fields
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        When I fill in p2p Notice of discrepancy with the following values
            | EMPTY |  |
        And I click on the button "p2pMessage"."sendButton"
        Then I expect the element "p2pMessage"."dangerNotification" to match reference "<VRRef>"
        Examples:
            | SendParty   | VRRef                                              |
            | issuingBank | p2p/dp/p2pnod-creation-create-5/e1/nodErrorMessage |

    @P2PNod-Creation-Create-6
    Scenario Outline: Error messages showing up if charges to be added or charges to be added have been checked
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        When I fill in p2p Notice of discrepancy with the following values
            | To                      | applicant,beneficiary,issuingBank,advisingBank |
            | Principal amount        | 1000                                           |
            | Notice of discrepancies | Notice of discrepancies                        |
            | Charges to be deducted  | #CHECKED#                                      |
            | Charges to be added     | #CHECKED#                                      |
        And I click on the button "p2pMessage"."sendButton"
        Then I expect the element "p2pMessage"."dangerNotification" to match reference "<VRRef>"
        Examples:
            | SendParty   | VRRef                                                     |
            | issuingBank | p2p/dp/p2pnod-creation-create-6/e1/nodChargesErrorMessage |


    @P2PNod-Creation-Create-7
    Scenario Outline: Cannot attach files when create a Notice of Discrepancy
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        Then I expect that element "p2pMessage"."attachButton" does not exist
        Examples:
            | SendParty   |
            | issuingBank |

    @P2PNod-Creation-Create-8
    Scenario Outline: All fields have correct data format
        Given <SendParty> admin1 login and open DP1 at current DC
        And I am at New p2p message under DP
        And I select message type as Notice of discrepancy
        When I fill in p2p Notice of discrepancy with the following values
            | To                                  | applicant,beneficiary,issuingBank,advisingBank |
            | Principal amount                    | aA! "#$%&'()*+,-./@[\\]^_`{\|}~1000            |
            | Additional amount                   | aA! "#$%&'()*+,-./@[\\]^_`{\|}~1000            |
            | Charges to be deducted              | #CHECKED#                                      |
            | Charges to be deducted Charges code | #AGENT#                                        |
            | Charges to be deducted Amount       | aA! "#$%&'()*+,-./@[\\]^_`{\|}~1000            |
            | Charges to be deducted Details      | aA1! "#$%&'()*+,-./@[\\]^_`{\|}~               |
            | Charges to be added                 | #CHECKED#                                      |
            | Charges to be added Charges code    | #ACCPTCOM#                                     |
            | Charges to be added Amount          | aA! "#$%&'()*+,-./@[\\]^_`{\|}~1000            |
            | Charges to be added Details         | aA1! "#$%&'()*+,-./@[\\]^_`{\|}~               |
            | Total amount to be paid             | aA! "#$%&'()*+,-./@[\\]^_`{\|}~1000            |
            | Account with bank                   | aA1! "#$%&'()*+,-./@[\\]^_`{\|}~               |
            | Sender to receiver information      | aA1! "#$%&'()*+,-./@[\\]^_`{\|}~               |
            | Notice of discrepancies             | aA1! "#$%&'()*+,-./@[\\]^_`{\|}~               |
        And I click on the button "p2pMessage"."sendButton"
        And I click on the button "sendMessagePopup"."confirmButton"
        And I wait until loading icon is hidden
        When I open p2p message which has subject "Notice of discrepancy" from listing
        * I scroll to element "noticeOfDiscrepancyView"."firstSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef1>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."secondSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef2>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."thirdSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef3>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        * I scroll to element "noticeOfDiscrepancyView"."fourthSnapshotSection"
        * I expect the element "p2pMessage"."messageRoot" to match reference "<VRRef4>" while hiding element "noticeOfDiscrepancyView"."deliveredNoticeOfDiscrepancySentDate"
        Examples:
            | SendParty    | VRRef1                                             | VRRef2                                             | VRRef3                                             | VRRef4                                             |
            | advisingBank | p2p/dp/p2pnod-creation-create-8/e1/nodSnapSection1 | p2p/dp/p2pnod-creation-create-8/e1/nodSnapSection2 | p2p/dp/p2pnod-creation-create-8/e1/nodSnapSection3 | p2p/dp/p2pnod-creation-create-8/e1/nodSnapSection4 |
