Feature: DC Issuance (DC Form) UI Components
    As a QA,
    I want to see the DC form with correct format and option,
    so that user can input text length and value as expected


    Scenario: Login and navigate to create dc page
        Given I setup test scenario context
        And applicant's maker login to main page for scenario sc1
        And I navigate to create dc page

    @ISS_APP_C1T11
    Scenario: Default Value
        When I scroll to element "dcForm"."keyTermsContainer"
        Then I expect the element "dcForm"."keyTermsContainer" to match reference "dc_form/ISS_APP_C1T11/keyTermsContainer" while hiding element "dcForm"."applicationDate"
        And I can see the page as following screenshots
            | page   | element                  | refImage                                       |
            | dcForm | corporatesContainer      | dc_form/ISS_APP_C1T11/corporatesContainer      |
            | dcForm | banksContainer           | dc_form/ISS_APP_C1T11/banksContainer           |
            | dcForm | shipmentDetailsContainer | dc_form/ISS_APP_C1T11/shipmentDetailsContainer |
            | dcForm | dcDetailsContainer       | dc_form/ISS_APP_C1T11/dcDetailsContainer       |
            | dcForm | attachmentsContainer     | dc_form/ISS_APP_C1T11/attachmentsContainer     |

    @ISS_APP_C1T2
    Scenario Outline: Choose from list and typing
        When I set "<Input>" to the contourSelect "dcForm"."<Element>"
        And I scroll to element "dcForm"."<Element>"
        Then I expect the viewport to match reference "<Reference>"
        Examples:
            | Element         | Input | Reference                            |
            | beneficiary     | Go    | dc_form/ISS_APP_C1T2/beneficiary     |
            | issuingBank     | As    | dc_form/ISS_APP_C1T2/issuingBank     |
            | advisingBank    | Mi    | dc_form/ISS_APP_C1T2/advisingBank    |
            | applicableRules | eU    | dc_form/ISS_APP_C1T2/applicableRules |
            | amountCurrency  | HK    | dc_form/ISS_APP_C1T2/amountCurrency  |
            | availableBy     | ati   | dc_form/ISS_APP_C1T2/availableBy     |
            | shipmentDate    | lat   | dc_form/ISS_APP_C1T2/shipmentDate    |

    @ISS_APP_C1T5
    Scenario Outline: Available By / Confirming Instruction : Different options showing different information for user input
        When I scroll to element "dcForm"."availableBy"
        When I pick "<Available by Option>" to the contourSelect "dcForm"."availableBy"
        And I scroll to element "dcForm"."availableByContainer"
        Then I expect the element "dcForm"."availableByContainer" to match reference "<Reference>"
        Examples:
            | Available by Option | Reference                                       |
            | Payment at sight    | dc_form/ISS_APP_C1T5/availableByPaymentAtSight  |
            | Deferred payment    | dc_form/ISS_APP_C1T5/availableByDeferredPayment |
            | Acceptance          | dc_form/ISS_APP_C1T5/availableByAcceptance      |
            | Negotiation         | dc_form/ISS_APP_C1T5/availableByNegotiation     |


    @ISS_APP_C1T10
    Scenario: Confirmation Instruction: May add, confirm and Without
        When I click on the element "dcForm"."confirmationInstructions"
        And I scroll to element "dcForm"."confirmationInstructions"
        Then I expect the viewport to match reference "dc_form/ISS_APP_C1T10/confirmationInstructions"

    @VTX-197
    Scenario: Autofill entity infomation
        When I fill in dc for scenario sc11 with following values
            | Beneficiary               | #BENEFICIARY#     |
            | Issuing Bank              | #ISSUING_BANK#    |
            | Advising Bank             | #ADVISING_BANK#   |
            | Confirmation Instructions | Confirm           |
            | Confirming Bank           | #CONFIRMING_BANK# |
            | Available With Bank       | #NOMINATED_BANK#  |

            | Available By   | Negotiation |
            | Check Draft At | Check       |
            | Drafts At      | 123         |
            | Drawee Bank    | #BANKA#     |
        Then I expect the document to match reference "dc_form/VTX_197/autofillEntityInfo"

    @VTX-2645
    Scenario: Autofill entity infomation
        When I attach files "Doc4_11MB.pdf" to DC form
        And I click on the button "actionButton"."sendToBeneficiaryButton"
        And I click on the button "actionButton"."submitButton"
        Then I expect the element "dcForm"."notificationContainer" to match reference "dc_form/AttachmentError"
