Feature: Workflow-DraftAmendment2(MCA-1) - @VTX5450
As a QA, I want to test Workflow-DraftAmendment2 where applicant initiates an amendment. Issuing bank returns
the amendment, and applicant discards the amendment draft

Scenario: Applicant creates a DC
        Given I setup test scenario context
        Given advisingBank advised dc for scenario sc11 proceeded by "maker.checkerApprover"

Scenario: Applicant creates a draft amendment and sends to issuing bank(MCA-1)
        Given applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        Then I expect the element "hint"."hintMessage" to match reference "draftamendment/corp/reqamendment"
        And I click on the button "actionButton"."amendButton"
          And I fill in dc for scenario sc11 with following values
            | Check Negotiation Payment Details    | Check    |
            | Negotiation Payment Details          | Updated  |
            | Amount                               | 25000.00 |
            | Max Tolerance (Optional)             | 17.00    |
            | Min Tolerance (Optional)             | 8.00     |
            | Expiry Place                         | Updated  |
            | Place Of Taking In Charge / Dispatch Form / Place Of Receipt (optional)| Updated |
            | Port Of Loading / Airport Of Departure (optional)                      | Updated |
        And I click on the button "actionButton"."submitToIssuingBankButton" and submit
        Then applicant proceeds to submit the draft to IssuingBank to complete the flow using mca1 for scenario sc11
        Then I can see the dc has amendment status "Amendment requested"
        Then I can see the dc has amendment sub status "Issuing bank to review"
        And applicant navigate to current dc using contour uuid     
        When I open 1 row of the amendment overview
        Then I expect 1 row detail of the amendment overview to match reference "draftamendment/corp/overviewRowDetails"
       
Scenario: Issuing bank returns the draft amendment(MCA-1)
        And issuingBank's maker login to main page for scenario sc11
        And issuingBank navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        When I click on 1 row view button of the amendment overview
        Then I expect the element "hint"."hintMessage" to match reference "draftamendment/issbank/reqamendment"
        And I click on the button "actionButton"."returnButton" and submit
        Then issuingBank completes the following draftText MCA flow for sc11
                        | role     | buttons                     |
                        | checker  | declineButton,confirmButton |
                        | maker    | updateButton,submitButton   |
                        | checker  | verifyButton,confirmButton  |
                        | approver | declineButton,confirmButton |
                        | maker    | updateButton,submitButton   |
                        | checker  | verifyButton,confirmButton  |
                        | approver | approveButton,confirmButton |
        Then I can see the dc has amendment status "Amendment returned"

  Scenario: Applicant discards the draft amendment(MCA-1)
        Given applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        Then I expect 1 row detail of the amendment overview to match reference "draftamendment/corp/amendmentReturned"
        When I click on 1 row view button of the amendment overview
        Then I expect the element "hint"."hintMessage" to match reference "draftamendment/corp/amendmentReturnedHint"
        And I click on the button "actionButton"."discardButton" and submit
        Then applicant completes the following draftText MCA flow for sc11
                        | role     | buttons                     |
                        | checker  | declineButton,confirmButton |
                        | maker    | updateButton,submitButton   |
                        | checker  | verifyButton,confirmButton  |
                        | approver | declineButton,confirmButton |
                        | maker    | updateButton,submitButton   |
                        | checker  | verifyButton,confirmButton  |
                        | approver | approveButton,confirmButton |
        Then I can see the dc has amendment status "Discarded"
        

  Scenario: Applicant is unable to edit discarded amendment draft
        Given applicant's maker login to main page for scenario sc11
        And applicant navigate to current dc using contour uuid
        When I open 1 row of the amendment overview
        When I click on 1 row view button of the amendment overview
        Then the element "actionButton"."editButton" is not displayed
        Then the element "actionButton"."discardButton" is not displayed
        