import report_portal_token from '../report_portal_token';

var specs = ['../test/features/amendment/functions/*.feature', '../test/features/amendment/workflow/*.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['../test/steps/**/*def.ts'],
  locators: ['../test/pages/**/*.locator.ts'],
  env: 'local',
  vr: {
    dir: '../visual-regression',
    autoSaveBaseline: true,
    compareScreenshot: true,
    beforeScreenshotPause: 300
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '89.0.4389.23' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '89.0.4389.23' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: false,
    token: report_portal_token.agent_token,
    endpoint: 'http://reportportal.pvt.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'Amendment workflow',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bvt' }]
  },
  logLevel: 'error',
  tagExpression: 'not @Pending'
};

export default config;
