var specs = ['../test/features/backwards_compatibility/dc_cancellation/**.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['../test/steps/**/*def.ts'],
  locators: ['../test/pages/**/*.locator.ts'],
  env: 'dev_1',
  vr: {
    dir: '../visual-regression',
    autoSaveBaseline: true,
    compareScreenshot: false,
    beforeScreenshotPause: 300
  },
  // runType: 'chromedriver',
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: {
      chrome: { version: '98.0.4758.80' } // https://chromedriver.chromium.org/
    },
    args: {
      chrome: { version: '98.0.4758.80' } // https://chromedriver.chromium.org/
    }
  },
  reportPortal: {
    enabled: true,
    token: 'c14bd8ad-fd3f-4880-93c7-14545f5e949f',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'BWC-DC',
    launch: 'Working-FE',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bvt' }]
  },
  logLevel: 'trace',
  tagExpression: 'not @Pending',
  debugFailStep: true
};

export default config;
