const specs = ['../test/features/dc_issuance/documentSource/*.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['../test/steps/**/*def.ts'],
  locators: ['../test/pages/**/*.locator.ts'],
  env: 'dev_1',
  vr: {
    dir: '../visual-regression',
    autoSaveBaseline: true,
    compareScreenshot: false,
    beforeScreenshotPause: 300
  },
  runType: 'chromedriver',
  // runType: 'selenium-standalone',
  // standAloneOptions: {
  //   installArgs: {
  //     chrome: { version: '98.0.4758.80' } // https://chromedriver.chromium.org/
  //   },
  //   args: {
  //     chrome: { version: '98.0.4758.80' } // https://chromedriver.chromium.org/
  //   }
  // },
  reportPortal: {
    enabled: false,
    token: 'cba65df8-ab35-4f95-b741-d59bceb09aae',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'DI-DocumentSource',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'diDocumentSource' }]
  },
  logLevel: 'debug',
  tagExpression: 'not @Pending',
  debugFailStep: false
};

export default config;
