import report_portal_token from '../report_portal_token';

var specs = ['../test/features/p2p/generalP2P/**/*.feature', '../test/features/p2p/structuredP2P/**/*.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['../test/steps/**/*def.ts'],
  locators: ['../test/pages/**/*.locator.ts'],
  env: 'local',
  vr: {
    autoSaveBaseline: true,
    compareScreenshot: false,
    beforeScreenshotPause: 300
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '89.0.4389.23' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '89.0.4389.23' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: true,
    token: report_portal_token.agent_token,
    endpoint: 'http://reportportal.pvt.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'P2P General Message Creation',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bvt' }]
  },
  capabilities: [
    {
      maxInstances: 3,
      browserName: 'chrome',
      browserVersion: '89.0',
      'goog:chromeOptions': {
        args: ['--incognito', 'window-size=1920,1080']
      },
      'selenoid:options': {
        enableVNC: true,
        enableVideo: false,
        enableLog: true
      }
    }
  ],
  logLevel: 'error',
  tagExpression: 'not @Pending'
};

export default config;
