var specs = ['./test/features/BNO/viewIdentityDetails.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['./test/steps/**/*def.ts'],
  locators: ['./test/pages/**/*.locator.ts'],
  env: 'dev_1',
  vr: {
    autoSaveBaseline: true,
    compareScreenshot: true,
    beforeScreenshotPause: 300
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '98.0.4758.80' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '98.0.4758.80' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: true,
    token: 'c14bd8ad-fd3f-4880-93c7-14545f5e949f',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'BNO',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bno' }]
  },
  logLevel: 'info',
  tagExpression: 'not @Pending'
};

export default config;
