var specs = ['./test/features/end2end/**/**.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specFileRetries: 3,
  specs: specs,
  stepDefinitions: ['./test/steps/**/*def.ts'],
  locators: ['./test/pages/**/*.locator.ts'],
  env: 'dev_2',
  vr: {
    autoSaveBaseline: false,
    compareScreenshot: true,
    beforeScreenshotPause: 500
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '90.0.4430.24' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '90.0.4430.246' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: true,
    token: '7310fe2d-dc8d-46b0-aaa7-9905d01a0880',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'E2E regression test',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'e2e' }]
  },
  logLevel: 'debug',
  tagExpression: 'not @Pending'
};

export default config;
