var specs = ['./test/features/BNO/**/metering.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['./test/steps/**/*def.ts'],
  locators: ['./test/pages/**/*.locator.ts'],
  env: 'dev_3',
  vr: {
    autoSaveBaseline: true,
    compareScreenshot: false,
    beforeScreenshotPause: 300
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '88.0.4324.96' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '88.0.4324.96' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: false,
    token: 'ff6bae9c-c6f0-4dc1-b78a-236d4c6227fe',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'Metering test',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bvt' }]
  },
  logLevel: 'info',
  tagExpression: 'not @Pending'
};

export default config;
