var specs = ['./test/features/workflow/draft_amendment/**.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['./test/steps/**/*def.ts'],
  locators: ['./test/pages/**/*.locator.ts'],
  env: 'dev_1',
  vr: {
    autoSaveBaseline: false,
    compareScreenshot: true,
    beforeScreenshotPause: 300
  },
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: { drivers: { chrome: { version: '91.0.4472.101' } } }, // drivers to install
    args: {
      drivers: { chrome: { version: '91.0.4472.101' } } // drivers to use
    }
  },
  reportPortal: {
    enabled: false,
    token: 'e704ee00-5d3b-45fe-8e43-d1781effc3f0',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'contour-fe',
    launch: 'Workflow-DraftAmendment',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'draftamendment' }]
  },
  logLevel: 'info',
  tagExpression: 'not @Pending'
};

export default config;
