var specs = ['./test/features/.working/**.feature'];

const config: ContourFETConfig = {
  framework: 'cucumber',
  specs: specs,
  stepDefinitions: ['./test/steps/**/*def.ts'],
  locators: ['./test/pages/**/*.locator.ts'],
  env: 'dev_1',
  vr: {
    autoSaveBaseline: true,
    compareScreenshot: false,
    beforeScreenshotPause: 300
  },
  // runType: 'chromedriver',
  runType: 'selenium-standalone',
  standAloneOptions: {
    installArgs: {
      chrome: { version: '91.0.4472.101' } // https://chromedriver.chromium.org/
    },
    args: {
      chrome: { version: '91.0.4472.101' } // https://chromedriver.chromium.org/
    }
  },
  reportPortal: {
    enabled: false,
    token: '4d19b833-38e8-4788-84b9-e1f268f241bb',
    endpoint: 'http://reportportal.dev.contournetwork.io/api/v1',
    project: 'sample',
    launch: 'Working-FE',
    description: specs.toString(),
    attributes: [{ key: 'run', value: 'bvt' }]
  },
  logLevel: 'trace',
  tagExpression: 'not @Pending',
  debugFailStep: true
};

export default config;
