export default {
  args: {
    props: {
      issuedLCRef: null,
      advisedLCRef: null,
      confirmedLCRef: null,
      applicationDate: '2020-08-03',
      formOfDc: 'IRREVOCABLE',
      applicableRules: 'EUCP_LATEST_VERSION',
      expiryDate: '2021-03-11',
      placePresentation: 'Hong Kong',
      periodPresentation: '123',
      typeOfPresentation: '123',
      issuerClause: null,
      amount: '10000.00 USD',
      additionalAmountsCovered: 'Additional Amount Covered (Option)',
      tolerance: ['15.00', '5.00'],
      placeOfFinalDestination: 'Place Of Destination / For Transportation To / Place Of Delivery',
      placeOfTakingInCharge: 'Place Of Taking In Charge / Dispatch Form / Place Of Receipt',
      shipmentPeriod: null,
      typeCredit: 'NEGOTIABLE_CREDIT',
      draftsAt: null,
      deferredPaymentDetails: 'Negotiation / Deferred Payment Details',
      partialShipment: 'ALLOWED',
      transShipment: 'NOT_ALLOWED',
      incoterms: null,
      portLoading: 'Port Of Loading / Airport Of Departure (optional)',
      portDischarge: 'Port Of Discharge / Airport Of Destination (optional)',
      lastShipmentDate: '2021-12-12',
      goods: 'Automation',
      instructionsToPayingBank: null,
      documentsRequired: [
        { documentType: 'INVOICE', description: 'Invoice Description' },
        { documentType: 'CERTIFICATE_OF_ORIGIN', description: 'Certificate of Origin Description' },
        { documentType: 'PACKING_LIST', description: 'Packing List Description' },
        {
          documentType: 'TRANSPORT_DOCUMENT_OTHER',
          subtype: 'Other Transport Document',
          description: 'Transport Document Description'
        }
      ],
      otherDocumentsRequired: [
        { documentType: 'Other Doc 1', description: 'Other Doc Description 1', subtype: null },
        { documentType: 'Other Doc 2', description: 'Other Doc Description 2', subtype: null }
      ],
      additionalConditions: 'Presentation to be made through Contour application under eUCP',
      detailsCharges: 'All charges outside country',
      confirmation: 'WITHOUT',
      attachments: [],
      parties: {
        applicant: 'OU=Buying, O=Alice Ltd, L=London, C=GB',
        beneficiary: 'OU=Sales, O=Bob Ltd, L=Hong Kong, C=CZ',
        issuer: 'OU=BuyingTrade, O=Bank A plc, L=London, C=GB',
        advisingBank: 'OU=SalesTrade, O=Bank B plc, L=Hong Kong, C=CZ',
        confirmingBank: null,
        availableWithBank: null,
        drawee: null,
        requestedBy: 'OU=Buying, O=Alice Ltd, L=London, C=GB',
        counterparty: 'OU=Sales, O=Bob Ltd, L=Hong Kong, C=CZ'
      },
      partyAddresses: {
        applicant: 'Address, S001, G/F, Lakeside 2, Hong Kong Science Park, Shatin, New Territories, Hong Kong',
        beneficiary: 'Address, S002, G/F, Lakeside 2, Hong Kong Science Park, Shatin, New Territories, Hong Kong',
        issuer: 'Address, S003, G/F, Lakeside 2, Hong Kong Science Park, Shatin, New Territories, Hong Kong',
        advisingBank: 'Address, S004, G/F, Lakeside 2, Hong Kong Science Park, Shatin, New Territories, Hong Kong',
        confirmingBank: null,
        availableWithBank: null,
        drawee: null
      }
    },
    waiver: false
  },
  draftComment: null
};
